VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BSPTree8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'*****************************
'  Code for BSP Half-Life file
'*****************************
' ---------------
' Changed by Mike
' ---------------
' ---------------
' Changed by Adam
' ---------------

'##CD This class allows the rendering of  BSP (Half-life scene) or BSP3 (Quake3 maps) files created by WorldCraft or extracted from a _
game. If you want to create a game with rooms, doors, monsters (like Doom or Half-Life), you _
can create your scene with WorldCraft (HL scene editor) and render with this class. _
Now, this class contains a PVS (Possible visible leafs) checking and a lightmap loader and renderer _
<b>(only for the single pass multitexturing)</b>



Option Explicit

Private CollidedPlane As Long
Private Nleaf As Long, Quake3 As Integer
Private Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type
Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

Public Type BSPTraceReturn
    AllSolid As Boolean
    StartSolid As Boolean
    Intersection As D3DVECTOR
    PlaneNormal As D3DVECTOR
    PlaneOffset As Single
    FaceCollided As Integer
    EntityCollided As Integer
    LinePercent As Single
End Type

Private Type BSPEntry
  offset As Long
  Size As Long
End Type
Private Type BBox
  min As D3DVECTOR
  max As D3DVECTOR
End Type


Private LA As Long, TextureLoaded As Boolean

Private Type IntBBox
  min(2) As Long
  max(2) As Long
End Type
Private Type IntBBox2
  min(2) As Integer
  max(2) As Integer
End Type



Private Type BSPHeader
  'magic As String * 4
  version As Long
  entities As BSPEntry
  planes As BSPEntry
  miptex As BSPEntry
  vertices As BSPEntry
  visilist As BSPEntry
  nodes As BSPEntry
  TexInfo As BSPEntry
  faces As BSPEntry
  lightmaps As BSPEntry
  clipnodes As BSPEntry
  leaves As BSPEntry
  lface As BSPEntry
  edges As BSPEntry
  ledges As BSPEntry
  models As BSPEntry
End Type

Private Type Q3BSPHeader
    Header As String * 4
    entities As BSPEntry
    Shader As BSPEntry
    planes As BSPEntry
    nodes As BSPEntry
    leafs As BSPEntry
    lface As BSPEntry
    temp As BSPEntry
    models As BSPEntry
    unk9 As BSPEntry
    unk10 As BSPEntry
    Verts As BSPEntry
    elems As BSPEntry
    unk13 As BSPEntry
    faces As BSPEntry
    lightmaps As BSPEntry
    unk14 As BSPEntry
    vis As BSPEntry
End Type

Private Type Q3Visibility
  numcluster As Long
  rowsize As Long
  Row() As Byte
End Type

Private Type Q3Node
  Plane As Long
  Children(1) As Long
  Bound As IntBBox
End Type

Private Type Q3Model
  Bound As BBox
  fface As Long
  Numface As Long
  funk As Long
  numunk As Long
End Type

Private Type Q3Leaf
  cluster As Long
  area As Long
  BBox As IntBBox
  fface As Long
  Numface As Long
  funk As Long
  numunk As Long
End Type

Private Type Q3Shader
   Shader As String * 64
   ShaderIndex As Long
   ShaderUnk As Long
End Type

Private Type Q3Vertex
   Vec As D3DVECTOR
   St As D3DVECTOR2
   EnvST As D3DVECTOR2
   norm As D3DVECTOR
   color(3) As Byte
End Type

Private BitShift(8) As Byte
Private Type Q3Face
   Shader As Long
   unk As Long
   facetype As Long
   firstvert As Long
   numvert As Long
   firstelem As Long
   numelem As Long
   lightmap As Long
   lightmapoffset(1) As Long
   lightmapsize(1) As Long
   Origin As D3DVECTOR
   Bound As BBox
   norm As D3DVECTOR
   mesh_cp(1) As Long
End Type
   
Private TriggerTexture As Long

Private Type EdgeType
  V1 As Integer
  V2 As Integer
End Type


Private Type LeafType
  Type As Long
  VisList As Long
  Bound As IntBBox2
  face_id As Integer
  face_num As Integer
  style(3) As Byte
End Type

Private Type facetype
  plane_id As Integer
  side As Integer
  egde_id As Long
  numedge As Integer
  texinfo_id As Integer
  lightstyle(3) As Byte
  lightmap As Long
End Type

Private Type Node
  PlaneNum As Long
  Children(1) As Integer
  BBox As IntBBox2
  FirstFace As Integer
  NumFaces As Integer
End Type


Private Type MipTexture
  TextureName As String * 16
  width As Long
  height As Long
  offset1 As Long
  offset2 As Long
  offset4 As Long
  offset8 As Long
End Type


Private Type Vertex3D
  x As Single
  y As Single
  z As Single
End Type

Private Type TextureInfo
  S As D3DVECTOR
  DistS As Single
  t As D3DVECTOR
  DistT As Single
  Texture_id As Long
  Animated As Long
End Type

Private Type Planetype
  normal As D3DVECTOR
  Dist As Single
  Type As Long
End Type

Private Type ModelType
  Bound As BBox
  Origin As D3DVECTOR
  HeadNode(3) As Long
  VisList As Long
  FirstFace As Long
  Numface As Long
End Type

' ADDED - Adam Hoult

Private Type TransformedFaces
  Vertex() As D3DVECTOR
  E() As Integer

  LightMapWidth As Single
  LightMapHeight As Single
  Texture As Integer
  Shader As Integer
  Translucy As Boolean
  TransFactor As Long
  lightmap As Long
  
  Material As D3DMATERIAL8
  '*** New Code Start
  VertexOffset As Long
  VertexCount As Long
  IndexNum As Long
  PrimitiveCount As Long
  
  '*** End
  Q3Mesh As Long
End Type

Private Type BSPModelSphere
  Center As D3DVECTOR
  Radius As Single
  Visible As Boolean
End Type
    

'Q3 Meshes are Curves stuff. Look at Q3Mesh functions
Private Type Q3Meshes
    Size(1) As Long
    Point() As D3DVECTOR
    St() As D3DVECTOR2
    lmst() As D3DVECTOR2
    colour() As Long
    numelems As Long
    elem() As Long
    Face As Long
End Type


Private Type BSPType
  MipMapping As Boolean
  Ambient As D3DCOLORVALUE
  Plane() As Planetype
  Vertex() As D3DVECTOR
  Face() As facetype
  Node() As Node
  Edge() As EdgeType
  leaf() As LeafType
  TexInfo() As TextureInfo
  Model() As ModelType
  lEdge() As Long
  lface() As Integer
  FaceT() As TransformedFaces
  FrustumPlanes() As Planetype
  MipTexture() As MipTexture
  AffVis() As Long
  '*** New Code Start
  VisList() As Byte
  LeafVis() As Long
  LeafSphere() As BSPModelSphere
  '*** End
  '*** Code Change - AH ***
  lightmaps() As Byte
  '*** End - AH ***
  Filename As String
  Matrix As D3DMATRIX
  TexturePath As String
  TextureN As Boolean
  Entity As String
  UseLightMap As Boolean
  UsePVS As Boolean
  UseTextureNumber As Boolean
  Culling As CONST_TV_CULLING
  ActualLeaf As Long
  ActualPosition As D3DVECTOR
  WadFilename As String
  WadEnable As Boolean
  GlowMesh() As Mesh8
  numGlowMesh As Integer
  VertexBuffer As Direct3DVertexBuffer8
  IndexBuffer As Direct3DIndexBuffer8
  VertexNumber As Long
  ModelSphere() As BSPModelSphere
  Q3Shader() As Q3Shader
  Q3Vertex() As Q3Vertex
  Q3Face() As Q3Face
  Q3LFace() As Long
  Q3Vis As Q3Visibility
  Q3Model() As Q3Model
  Q3Node() As Q3Node
  Q3Leaf() As Q3Leaf
  Q3Mesh() As Q3Meshes
  Q3Plane() As TVPlane
  Q3NodeV() As Integer
  Q3Curve As Integer
  SkyM As Integer
  SkyEnabled As Boolean
  CollidedLeaf() As Integer
  NumCollidedLeaf As Integer
End Type

'For Quake3 QSort
Private Facelist() As Integer, DispFace() As Integer, NumDispFace As Integer
Private FaceShader() As Integer

Private Type ShaderFileDesc
    Shader() As String
    NumShader As Integer
    Filename As String
    offset() As Long
End Type

Private ShaderFile() As ShaderFileDesc, NumFileShader As Integer

Private BSP As BSPType

'*** New Code Start
Private numplane As Long, numedge As Long, numledge As Long, Numface As Long, NumNode As Long, numleaf As Long, numtex As Long, nummodel As Long, NumVertex As Long, numlface As Long, numvis As Long
Private LeafVisCounter As Long, numlightmaps As Long, LightMapMode As Boolean, NumShader As Long
Private NumMesh As Long
'*** End

Private tex() As Direct3DTexture8
Private lightmap() As Direct3DTexture8
Private LightmapCount As Long

'----------------------------
' Collision detection results
'----------------------------
Private Type BSPCollideResult
  Collide As Boolean
  Distance As Single
  TriangleU As Single
  TriangleV As Single
 ' Normal As D3DVECTOR
End Type

Private Type WAD3
   id As String * 4
   NumTexture As Long
   offset As Long
End Type

Private Type WAD3Texture
  Name As String * 16
  width As Long
  height As Long
  offset As Long
  offset2 As Long
  offset3 As Long
  offset4 As Long
End Type

Private Type WAD3Entity
  offset1 As Long
  offset2 As Long
  offset3 As Long
  offset4 As Long
  Name As String * 16
End Type
Private Mat As D3DMATRIX
Private Corner(8) As D3DVECTOR, EyePoint As D3DVECTOR

Private TempDdsd As D3DSURFACE_DESC, TempLightMap As Direct3DTexture8
Private TempMat As D3DMATERIAL8



Public Enum CONST_TV_CURVE
  TV_CURVE_LOW = 0
  TV_CURVE_NORMAL = 1
  TV_CURVE_HIGH = 2
End Enum
Private Type TokenString
  LeftStr As String
  ResteStr As String
End Type

'------------------------------------------------------------------------------
' Global Constants
'------------------------------------------------------------------------------
Private Const CP_FRONT = 1
Private Const CP_BACK = 2
Private Const CP_ONPLANE = 3

'Friend Function AdvancedCollision(StartPos As D3DVECTOR, EndPos As D3DVECTOR) As CollisionResult
'##BD This method checks if there is a BSP face that intersects the line between the StartPos and the EndPos. _
Returns a CollisionResult class. If there is PVS information, collision detection will be faster.
Public Function AdvancedSphereCollision(SpherePos As D3DVECTOR, NewSpherePosition As D3DVECTOR, SphereRadius As Single) As CollisionResult8
   Dim Direction As D3DVECTOR
   Dim i As Long, BestNormal As D3DVECTOR, BestDist As Single, BestPos As D3DVECTOR, t As Single, U As Single, vu As Single
   Dim Start As D3DVECTOR
   Dim EndL As D3DVECTOR
   Start = MITransform(BSP.Matrix, SpherePos)
   EndL = MITransform(BSP.Matrix, NewSpherePosition)
   Direction = VNormalize(VSubtract(EndL, Start))
   
   Dim a As Long, v As Long, g As Byte
   
   Set AdvancedSphereCollision = New CollisionResult8
   ReDim BSP.CollidedLeaf(numleaf)
   BSP.NumCollidedLeaf = 0
   BestDist = 9999
   Dim r As Boolean
   r = DetectSphereCollision(NewSpherePosition, SphereRadius, 1)
   If BSP.NumCollidedLeaf > 0 Or r = True Then
      If Quake3 = 1 Then
        For i = 1 To BSP.NumCollidedLeaf
         'Check each face in each collided leaf. Logically, we have to check only two of three face, so it's very fast
          With BSP.Q3Leaf(BSP.CollidedLeaf(i))
            For a = .fface To .Numface + .fface
               With BSP.FaceT(BSP.Q3LFace(a))
                 For v = 0 To .VertexCount - 2 Step 3
                  g = Ray_Tri(Start, Direction, .Vertex(v), .Vertex(v + 1), .Vertex(v + 2), t, U, vu, True)
                     If t > 0 And t < BestDist And g <> 0 And t < SphereRadius Then
                        BestDist = t
                        BestNormal = CollisionNormal
                        BestPos = CollisionImpact
                     End If
                 Next v
               End With
            Next a
         End With
       
        Next i
       If BestDist <> 9999 Then AdvancedSphereCollision.SetCollisionProperties True, BestDist, U, vu, BestNormal, -2, BestPos: Exit Function
       If r = True Then AdvancedSphereCollision.SetCollisionProperties True, 0, 0, 0, BestNormal, -2, BestPos: Exit Function
       
       
      End If
      
   Else
     AdvancedSphereCollision.SetCollisionProperties False, 0, 0, 0, Vector(0, 0, 0), 0, Vector(0, 0, 0), 0
   End If
   
End Function

'-------------------------------------------------------------------------------------
' Name : ClassifyPoint ()
' Desc : Given a Position Vector and a plane, tells us where it falls
'-------------------------------------------------------------------------------------
Private Function ClassifyPoint(ByRef Plane As Planetype, ByRef Point As D3DVECTOR)
    Dim result As Single
    result = (Plane.normal.x * Point.x + Plane.normal.y * Point.y + Plane.normal.z * Point.z - Plane.Dist)
    If result < -0.001 Then
        ClassifyPoint = CP_BACK
    ElseIf result > 0.001 Then
        ClassifyPoint = CP_FRONT
    Else
        ClassifyPoint = CP_ONPLANE
    End If
End Function

Private Function ClassifyPoint2(ByRef Point As D3DVECTOR, ByRef Plane As TVPlane)
    Dim result As Single
    result = (Plane.normal.x * Point.x + Plane.normal.y * Point.y + Plane.normal.z * Point.z - Plane.offset)
    If result < -0.001 Then
        ClassifyPoint2 = CP_BACK
    ElseIf result > 0.001 Then
        ClassifyPoint2 = CP_FRONT
    Else
        ClassifyPoint2 = CP_ONPLANE
    End If
End Function

Function DetectSphereCollision(Position As D3DVECTOR, Optional SphereRadius As Single = 1, Optional Reserved1 As Integer) As Boolean
   '##BD Perform a detection collision in the BSP Tree (BSP or BSP3). This function detects if _
   any part of the sphere is in the solid space. If so, returns True, else returns False. _
   <b><i>Note</i> Just pass in the position where you are moving to. If the method returns True, don't _
   move the player to the new position.

   '##PD Position Center of the sphere to test
   '##PD SphereRadius Radius of the sphere to test
   If Quake3 = 0 Then
     DetectSphereCollision = CollideSphere(Position, SphereRadius, 0)
   Else
     DetectSphereCollision = Q3CollideSphere(Position, SphereRadius, 0, Reserved1)
   End If
End Function

'-------------------------------------------------------------------------------------
' Name : GetDistanceToPlane ()
' Desc : Ummm... Gets the distance from the point to the plane =)
'-------------------------------------------------------------------------------------
Private Function GetDistanceToPlane(Point As D3DVECTOR, ByRef Plane As Planetype) As Single
    GetDistanceToPlane = Sqr(Abs(Plane.normal.x * Point.x + Plane.normal.y * Point.y + Plane.normal.z * Point.z - Plane.Dist))
End Function
Private Function GetDistanceToPlane2(Point As D3DVECTOR, ByRef Plane As TVPlane) As Single
    GetDistanceToPlane2 = Sqr(Abs(Plane.normal.x * Point.x + Plane.normal.y * Point.y + Plane.normal.z * Point.z - Plane.offset))
End Function

'-------------------------------------------------------------------------------------
' Name : CollideSphere ()
' Desc : This function collects ALL the polys which we could possibly be colliding
'        With.
'-------------------------------------------------------------------------------------
Private Function CollideSphere(Centre As D3DVECTOR, Radius As Single, Node As Integer) As Boolean
    Dim DistanceToPlane As Single, i As Long, r As Long
    Dim result As Single
    If Node = 0 Then
     
       Centre = MITransform(BSP.Matrix, Centre)
       Centre.x = -Centre.x
    End If
    DistanceToPlane = GetDistanceToPlane(Centre, BSP.Plane(BSP.Node(Node).PlaneNum))
    Select Case ClassifyPoint(BSP.Plane(BSP.Node(Node).PlaneNum), Centre)
        Case CP_FRONT, CP_ONPLANE
            If (BSP.Node(Node).Children(0) < 0) Then
                r = -(BSP.Node(Node).Children(0) + 1)
                If BSP.leaf(r).Type = -2 Then
                    CollideSphere = True
                    Exit Function
                End If
            Else
                CollideSphere = CollideSphere(Centre, Radius, BSP.Node(Node).Children(0))
                If CollideSphere = True Then Exit Function
            End If
            If Radius > DistanceToPlane Then
                If (BSP.Node(Node).Children(1) < 0) Then
                    r = -(BSP.Node(Node).Children(1) + 1)
                    If BSP.leaf(r).Type = -2 Then
                        CollideSphere = True
                        Exit Function
                    End If
                Else
                    CollideSphere = CollideSphere(Centre, Radius, BSP.Node(Node).Children(1))
                    If CollideSphere = True Then Exit Function
                End If
            End If
        Case CP_BACK
            If (BSP.Node(Node).Children(1) < 0) Then
                r = -(BSP.Node(Node).Children(1) + 1)
                If BSP.leaf(r).Type = -2 Then
                    CollideSphere = True
                    Exit Function
                End If
            Else
                CollideSphere = CollideSphere(Centre, Radius, BSP.Node(Node).Children(1))
                If CollideSphere = True Then Exit Function
            End If
            If Radius > DistanceToPlane Then
                If (BSP.Node(Node).Children(0) < 0) Then
                    r = -(BSP.Node(Node).Children(0) + 1)
                    If BSP.leaf(r).Type = -2 Then
                        CollideSphere = True
                        Exit Function
                    End If
                Else
                    CollideSphere = CollideSphere(Centre, Radius, BSP.Node(Node).Children(0))
                    If CollideSphere = True Then Exit Function
                End If
            End If
    End Select
End Function


'-------------------------------------------------------------------------------------
' Name : CollideSphere ()
' Desc : This function collects ALL the polys which we could possibly be colliding
'        With.
'-------------------------------------------------------------------------------------
Private Function Q3CollideSphere(Centre As D3DVECTOR, Radius As Single, Node As Long, Adv As Integer) As Boolean
    Dim DistanceToPlane As Single, i As Long, r As Long
    Dim result As Single
    If Node = 0 Then
       'Transform for OpenGL axis bug
       Centre = MITransform(BSP.Matrix, Centre)
       Centre.x = -Centre.x
    End If
    
    CollidedPlane = 0

    DistanceToPlane = GetDistanceToPlane2(Centre, BSP.Q3Plane(BSP.Q3Node(Node).Plane))
    
    Select Case ClassifyPoint2(Centre, BSP.Q3Plane(BSP.Q3Node(Node).Plane))
        Case CP_FRONT, CP_ONPLANE
            If (BSP.Q3Node(Node).Children(0) < 0) Then
                r = -(BSP.Q3Node(Node).Children(0) + 1)
                If BSP.Q3Leaf(r).area = -1 Then
                    'CollidedPlane = BSP.Q3Node(Node).Plane
                    If Adv = 1 Then
 '                     BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
 '                     BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                    Else
                     Q3CollideSphere = True
                     Exit Function
                    End If
                End If
                If Adv = 1 Then
                 BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
                 BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                End If
            Else
                Q3CollideSphere = Q3CollideSphere(Centre, Radius, BSP.Q3Node(Node).Children(0), Adv)
                If Q3CollideSphere = True Then Exit Function
            End If
            If Radius > DistanceToPlane Then
                If (BSP.Q3Node(Node).Children(1) < 0) Then
                    r = -(BSP.Q3Node(Node).Children(1) + 1)
                    
                    If BSP.Q3Leaf(r).area = -1 Then
                        'CollidedPlane = BSP.Q3Node(Node).Plane
                    If Adv = 1 Then
  '                    BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
  '                    BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                    Else
                        Q3CollideSphere = True
                        
                        Exit Function
                    End If
                    
                    End If
                   If Adv = 1 Then
                 BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
                 BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                End If
            
                Else
                    Q3CollideSphere = Q3CollideSphere(Centre, Radius, BSP.Q3Node(Node).Children(1), Adv)
                    If Q3CollideSphere = True Then Exit Function
                End If
            End If
        Case CP_BACK
            If (BSP.Q3Node(Node).Children(1) < 0) Then
                r = -(BSP.Q3Node(Node).Children(1) + 1)
                If BSP.Q3Leaf(r).area = -1 Then
                   If Adv = 1 Then
  '                    BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
  '                    BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                    Else

                    'CollidedPlane = BSP.Q3Node(Node).Plane
                    Q3CollideSphere = True
                    Exit Function
                    End If
                End If
                 If Adv = 1 Then
                 BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
                 BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                End If
            
           
            Else
                Q3CollideSphere = Q3CollideSphere(Centre, Radius, BSP.Q3Node(Node).Children(1), Adv)
                If Q3CollideSphere = True Then Exit Function
            End If
            If Radius > DistanceToPlane Then
                If (BSP.Q3Node(Node).Children(0) < 0) Then
                    r = -(BSP.Q3Node(Node).Children(0) + 1)
                    
                    If BSP.Q3Leaf(r).area = -1 Then
                       
                       
                    If Adv = 1 Then
                      'BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
                      'b 'SP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                    Else
                        Q3CollideSphere = True
                        Exit Function
                    End If
                    End If
                 If Adv = 1 Then
                 BSP.NumCollidedLeaf = BSP.NumCollidedLeaf + 1
                 BSP.CollidedLeaf(BSP.NumCollidedLeaf) = r
                End If
            
                
                Else
                    Q3CollideSphere = Q3CollideSphere(Centre, Radius, BSP.Q3Node(Node).Children(0), Adv)
                    If Q3CollideSphere = True Then Exit Function
                End If
            End If
    End Select
End Function



'##PD StartPos A D3DVECTOR that represents the start of the line (usually the vector position)
'##PD EndPos A D3DVECTOR that represents the end of the line (usually the vector position + vector direction)
'   Dim a As D3DVECTOR, b As D3DVECTOR, c As Boolean
'   a = MITransform(BSP.Matrix, StartPos)
'   b = MITransform(BSP.Matrix, EndPos)
'   Set AdvancedCollision = New CollisionResult
'   Dim t As Single, U As Single, V As Single, Normal As D3DVECTOR
'   c = Collision(a, b, t, U, V, Normal, False)
'   If c = True Then
'       AdvancedCollision.SetCollisionProperties True, t, U, V, Normal, -1, CollisionImpact'
'
'   End If
'End Function

Sub ClosePackWAD()
  BSP.WadEnable = False
End Sub

Private Function Collision(S As D3DVECTOR, d As D3DVECTOR, ByRef Dist As Single, ByRef U As Single, ByRef v As Single, ByRef normal As D3DVECTOR, Optional UseClass As Boolean = False) As Boolean
  ' Collision detection for BSP Tree
  ' If there are VIS info, ignore invisible leafs.
   Dim DistD As Single, UD As Single, VD As Single, vis As Boolean
   Dim i As Long, UCount As Single, BestDist As Single
    Dim dd As D3DVECTOR
    On Error GoTo 0
    'Get the ray direction
    'D = VSubtract(D, S)
    D3DXVec3Subtract dd, d, S
    D3DXVec3Normalize d, dd
 '   Debug.Print d.X, d.y, d.z, S.X, S.y, S.z
    'DirectX.VectorNormalize D
'    BestDist = 99999
    vis = True
    For i = 0 To Numface - 1
      If ((vis And BSP.AffVis(i) = 1)) Or (i > BSP.Model(1).FirstFace And BSP.FaceT(i).Texture <> TriggerTexture) Then
         'We must work with each triangle (these are FAN triangles)
          With BSP.FaceT(i)
         
         For UCount = 0 To .VertexCount - 3
           ' Check if there is a intersection
           
           If RayTri(.Vertex(0), .Vertex(UCount + 1), .Vertex(UCount + 2), d, S, DistD, UD, VD, True) = 1 Then
           ' If Ray_Tri(S, d, .Vertex(0), .Vertex(UCount + 1), .Vertex(UCount + 2), DistD, UD, VD, True) = 1 Then
              ' if any, return true and stop the function
              If DistD < PrecisionCollide And DistD > 0 Then
               Collision = True
              If UseClass = False Then
                CollisionImpact = MTransform(BSP.Matrix, CollisionImpact)
                CollisionNormal = MTransform(BSP.Matrix, CollisionNormal)
                 Dist = DistD
                  U = UD
                  v = VD
                 Exit Function
               Else
     '           If DistD < BestDist Then
     '            BestDist = DistD
     '            U = UD
     '            V = VD
     '           End If
               End If
             End If
           End If
        Next UCount
       End With
       
      End If
    Next i
    Dist = BestDist
End Function



Friend Function GetEntity() As String
  GetEntity = BSP.Entity
End Function

Private Function GetEntityToken(Key As String, value As String) As String
  On Local Error GoTo ErrorReport
   Dim GetStart As Boolean
  Dim TempToken As String, TempLeft As String
  Dim TokEnd As Long, TokStart As Long
  TempLeft = BSP.Entity
  Do
    GetStart = False
    TokStart = InStr(TempLeft, "{")
    TokEnd = InStr(TempLeft, "}")
    TempToken = mid$(TempLeft, TokStart, TokEnd - TokStart)
    TempLeft = mid$(TempLeft, TokEnd + 1)
    If InStr(TempToken, Chr(34) + Key + Chr(34) + " " + Chr(34) + value + Chr(34)) > 0 Then
     GetStart = True
    End If
    
  Loop Until GetStart = True
  GetEntityToken = TempToken
  Exit Function
  
ErrorReport:
  GetEntityToken = ""
End Function

Private Function GetEntityToken2(Key As String, value As String, Optional TempVal As String) As TokenString
  On Local Error GoTo ErrorReport
   Dim GetStart As Boolean
  Dim TempToken As String, TempLeft As String
  Dim TokEnd As Long, TokStart As Long, TempKey As String
  If TempVal = "" Then
  TempLeft = BSP.Entity
  Else
  TempLeft = TempVal
  End If
  Do
    GetStart = False
    TokStart = InStr(TempLeft, "{")
    TokEnd = InStr(TempLeft, "}")
    TempToken = mid$(TempLeft, TokStart, TokEnd - TokStart)

    If value = "" Then
     TempKey = ""
    Else
     TempKey = " " + Chr$(34) + value + Chr$(34)
    End If
    If InStr(TempToken, Chr$(34) + Key + Chr$(34) + TempKey) > 0 Then
     GetStart = True
    Else
        TempLeft = mid$(TempLeft, TokEnd + 1)
    End If
    
  Loop Until GetStart = True
  GetEntityToken2.LeftStr = TempToken
  GetEntityToken2.ResteStr = mid$(TempLeft, TokEnd + 1)
  
  Exit Function
  
ErrorReport:
  GetEntityToken2.LeftStr = ""
  GetEntityToken2.ResteStr = ""
End Function
Private Function GetIntersection(S As D3DVECTOR, E As D3DVECTOR, P As D3DVECTOR, o As Single, i As D3DVECTOR) As Boolean
 Dim Dir As D3DVECTOR
 Dim Po As Single
 Dim Dot As Single, Dist As Single
 Dim V1 As D3DVECTOR
 Dir = VSubtract(E, S)
 Dot = D3DXVec3Dot(Dir, P)
  If Abs(Dot) < 0.001 Then
    'The direction is in the same plane
    GetIntersection = False
    Exit Function
  End If
V1 = VSubtract(VScale(P, -o), S)
Dist = D3DXVec3Dot(V1, P)
Po = Dist / Dot
If Po < 0 Then GetIntersection = False: Exit Function
If Po > 1 Then GetIntersection = False: Exit Function
i.x = S.x + Dir.x * Po
i.y = S.y + Dir.y * Po
i.z = S.z + Dir.z * Po
GetIntersection = True
End Function

Friend Function GetKeyValue(TempToken As String, Key As String) As String
    Dim x As Long, LeftR As String, LeftToken As Long, RightToken As Long
    x = InStr(TempToken, Chr$(34) + Key + Chr$(34))
    x = x + Len(Key) + 3
    LeftR = mid$(TempToken, x)
    LeftToken = InStr(LeftR, """")
    RightToken = InStr(LeftToken + 1, LeftR, Chr$(34))
    GetKeyValue = mid$(LeftR, LeftToken + 1, RightToken - LeftToken - 1)
End Function
Function GetAltitudeFromPos(PosX As Single, PosY As Single, PosZ As Single, Optional UseCameraPosition As Boolean) As Single
   '##BD Get the floor (or object) altitude according to the player position
   '##PD PosX X-Coordinate of the player (if the UseCameraPosition flags is off)
   '##PD PosY Y-Coordinate of the player (if the UseCameraPosition flags is off)
   '##PD PosZ Z-Coordinate of the player (if the UseCameraPosition flags is off)
   '##PD UseCameraPosition The camera position will be used instead of manual coordinates.
   Dim a As D3DVECTOR
   Dim b As D3DVECTOR, t As Single
   Dim OldDet As Single, Coll As Boolean
   OldDet = PrecisionCollide
   PrecisionCollide = 10000
 
   If UseCameraPosition = False Then
     a = MITransform(BSP.Matrix, Vector(PosX, PosY, PosZ))
     b = MITransform(BSP.Matrix, Vector(PosX, PosY - 5, PosZ))
   Else
     a = MITransform(BSP.Matrix, StartPos)
     b = MITransform(BSP.Matrix, Vector(StartPos.x, StartPos.y - 5, StartPos.z))
   End If
 
   Coll = Collision(a, b, t, 0, 0, Vector(0, 0, 0), True)
   PrecisionCollide = OldDet
   If UseCameraPosition = True Then
      GetAltitudeFromPos = StartPos.y - t
   Else
      GetAltitudeFromPos = PosY - t
   End If
End Function

Function GetStartPlayerPosition() As D3DVECTOR
  '##BD Get the player start position from the BSP entities.
 On Error Resume Next
  Dim GetStart As Boolean
  Dim TempToken As String, TempLeft As String
  Dim TokEnd As Long, TokStart As Long
  TempLeft = BSP.Entity
  Do
    GetStart = False
    TokStart = InStr(TempLeft, "{")
    TokEnd = InStr(TempLeft, "}")
    TempToken = mid(TempLeft, TokStart, TokEnd - TokStart)
    If TempLeft = "" Then Exit Function
    TempLeft = mid(TempLeft, TokEnd + 1)
    
    
    If InStr(TempToken, "info_player_start") > 0 Or InStr(TempToken, "info_player_deathmatch") > 0 Then
     GetStart = True
    
    End If
  Loop Until GetStart = True
  Dim x As String
  x = GetKeyValue(TempToken, "origin")
  Dim a As D3DVECTOR
  
  'Fix the BSP orientation bug
  a = TransformKeyInVector(x)
  a.x = -a.x
  Dim v4 As D3DVECTOR4
   D3DXVec3Transform v4, a, BSP.Matrix
   GetStartPlayerPosition = Vector(v4.x, v4.y, v4.z)
   Debug.Print v4.x, v4.y, v4.z
End Function
Private Function InitTextureSurface() As Integer
    'Dim i As Long
    'Dim bIsFound As Boolean
    'Dim TextureEnum As Direct3DEnumPixelFormats
    'Dim ddsd As DDSURFACEDESC2
   '
   ' Set TextureEnum = Device.GetTextureFormatsEnum()
   '
   ' For i = 1 To TextureEnum.GetCount()
   '     bIsFound = True
  '      Call TextureEnum.GetItem(i, ddsd.ddpfPixelFormat)
  '
  '      With ddsd.ddpfPixelFormat
  '          ' Skip unusual modes.
  '          If .lFlags And (DDPF_LUMINANCE Or DDPF_BUMPLUMINANCE Or DDPF_BUMPDUDV) Then bIsFound = False
  '          ' Skip any FourCC formats.
  '          If .lFourCC <> 0 Then bIsFound = False
  '
  '          'Skip alpha modes.
  '          If .lFlags And DDPF_ALPHAPIXELS Then bIsFound = False
  '
  '          'We only want 16-bit formats, so skip all others.
  '          If .lRGBBitCount <> 16 Then bIsFound = False
  '      End With
  '
  '      If bIsFound Then Exit For
  '
  '  Next i
  '  ' If we did not find surface support, we should exit the application.
  '  If Not bIsFound Then
  '      MsgBox "Unable to locate 16-bit surface support on your hardware."
  '       InitTextureSurface = -1
  '      Exit Function
  '  End If
  '  InitTextureSurface = 1
  '  ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
  '  If Memory = DDSCAPS_SYSTEMMEMORY Then
  '    ddsd.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
  '    ddsd.ddsCaps.lCaps2 = 0
  '  Else
  '   ddsd.ddsCaps.lCaps = DDSCAPS_TEXTURE
  '   ddsd.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
  '  End If
  '  ddsd.lWidth = 256
  '  ddsd.lHeight = 256
  '  Set TempLightMap = DD.CreateSurface(ddsd)
  '  TempDdsd = ddsd
  '  Debug.Print "init success "; Err.Description
  '
End Function

Public Function LineSight(Start As D3DVECTOR, LEnd As D3DVECTOR, NodeID As Long) As Boolean
Dim temp As Single
Dim Intersection As D3DVECTOR

Dim Plane As TVPlane
Dim Node As Q3Node

Dim PointA As Integer
Dim PointB As Integer

Dim l As Long
'
'NODE  *CurrNode=&NodeArray[Node];
'PLANE *Plane=&PlaneArray[CurrNode->Plane];
If NodeID < 0 Then
  If BSP.Q3Leaf(-NodeID - 1).area = -1 Then
     LineSight = False
  Else
     LineSight = True
  End If
  Exit Function
End If
  
With BSP.Q3Node(NodeID)
PointA = ClassifyPoint2(Start, BSP.Q3Plane(BSP.Q3Node(NodeID).Plane))
PointB = ClassifyPoint2(LEnd, BSP.Q3Plane(BSP.Q3Node(NodeID).Plane))

If PointA = CP_ONPLANE And PointB = CP_ONPLANE Then
    If .Children(0) < 0 Then
      'Check for solid space
      l = -(.Children(0) + 1)
      If BSP.Q3Leaf(l).area = -1 Then
         'Point is in a solid leaf
         'Solid leaf
         LineSight = False
         Exit Function
      Else
         LineSight = True
         Exit Function
      End If
    Else
       'else recurse
       LineSight = LineSight(Start, LEnd, .Children(0))
       Exit Function
    End If
End If

If PointA = CP_FRONT And PointB = CP_BACK Then
   If .Children(1) < 0 Then
     l = -(.Children(1) + 1)
     If BSP.Q3Leaf(l).area = -1 Then
        LineSight = False
        Exit Function
     End If
   End If
   GetIntersection Start, LEnd, BSP.Q3Plane(.Plane).normal, BSP.Q3Plane(.Plane).offset, Intersection
   
   If .Children(0) < 0 Then
      LineSight = LineSight(LEnd, Intersection, .Children(1))
       Exit Function
   Else
      LineSight = LineSight(Start, Intersection, .Children(0)) And LineSight(LEnd, Intersection, .Children(1))
      Exit Function
   End If
End If

If PointA = CP_BACK And PointB = CP_FRONT Then
   If .Children(1) < 0 Then
     l = -(.Children(1) + 1)
     If BSP.Q3Leaf(l).area = -1 Then
        LineSight = False
        Exit Function
     End If
   End If
   GetIntersection Start, LEnd, BSP.Q3Plane(.Plane).normal, BSP.Q3Plane(.Plane).offset, Intersection
   Debug.Print Intersection.x, Intersection.y, Intersection.z
   If .Children(0) < 0 Then
      LineSight = LineSight(Start, Intersection, .Children(1))
      Exit Function
   Else
      LineSight = LineSight(LEnd, Intersection, .Children(0)) And LineSight(Start, Intersection, .Children(1))
      Exit Function
   End If

End If
   

If PointA = CP_FRONT Or PointB = CP_FRONT Then
  If .Children(0) < 0 Then
     LineSight = True
     Exit Function
  Else
     LineSight = LineSight(Start, LEnd, .Children(0))
     Exit Function
  End If
Else
  If .Children(1) < 0 Then
     l = -(.Children(1) + 1)
     If BSP.Q3Leaf(l).area = -1 Then
       LineSight = False
       Exit Function
     End If
     
     
   Else
      LineSight = LineSight(Start, LEnd, .Children(1))
      Exit Function
   End If
End If
LineSight = True
End With
  

End Function
Private Function NDebug()
 Dim i As Long
 For i = 0 To NumNode
   With BSP.Q3Node(i)
     Debug.Print "Node :" + CStr(i)
     Debug.Print .Children(0), .Children(1)
     Debug.Print BSP.Q3Plane(.Plane).normal.x, BSP.Q3Plane(.Plane).normal.y, BSP.Q3Plane(.Plane).normal.z, BSP.Q3Plane(.Plane).offset
     Debug.Print "#####################################"
   End With
 Next i
End Function



Private Sub LoadDynamicLight()
  Dim TempLight As LightEngine8
  Dim TempString As String
  Dim result As TokenString
  Dim modelKey As String, r As Single, b As Single, g As Single, range As Single
  Dim Origin As D3DVECTOR, sp As Long, TempRest As String
  Dim a As Long
  
  Set TempLight = New LightEngine8

DynLight:
  result.ResteStr = BSP.Entity
   
   Do
     TempRest = result.ResteStr
     If a = 0 Then
      result = GetEntityToken2("classname", "light", TempRest)
     Else
      result = GetEntityToken2("classname", "light_spot", TempRest)
     End If
     
     
     If result.LeftStr <> "" Then
     
      TempString = GetKeyValue(result.LeftStr, "origin")
      Origin = TransformKeyInVector(TempString)
      Origin.x = -Origin.x
      Origin = MTransform(BSP.Matrix, Origin)
      
      TempString = GetKeyValue(result.LeftStr, "_light")
      
      sp = InStr(TempString, " ")
      r = val(Left$(TempString, sp - 1)) / 255: TempString = mid$(TempString, sp + 1)
      
      sp = InStr(TempString, " ")
      g = val(Left$(TempString, sp - 1)) / 255: TempString = mid$(TempString, sp + 1)
      
      sp = InStr(TempString, " ")
      b = val(Left$(TempString, sp - 1)) / 255: TempString = mid$(TempString, sp + 1)
      
      range = val(TempString)
      Debug.Print r, g, b, range
      TempLight.CreatePointLight Origin, range, r * 10, g * 10, b * 10, 1
     End If
  Loop Until Trim$(result.ResteStr) = ""
  If a = 0 Then a = 1: GoTo DynLight
End Sub

'*** New Code - AH ***
'Private Function MakeVectorFromMT(V As MultiTexVertex) As D3DVECTOR
'    With MakeVectorFromMT
'        .x = V.x: .y = V.y: .z = V.z
'    End With
'End Function
'*** End - AH ***
Function DetectCollision(StartPos1 As D3DVECTOR, EndPos1 As D3DVECTOR) As Boolean
'##BD This function returns True if there is a mesh, a landscape or a BSP face that intersects the line between the StartPos and the EndPos.

'##PD StartPos A D3DVECTOR that represents the start of the line (usually the position vector )
'##PD EndPos A D3DVECTOR that represents the end of the line (usually the position  vector + direction vector)
  Dim a As D3DVECTOR
  Dim b As D3DVECTOR
   a = MITransform(BSP.Matrix, StartPos1)
   b = MITransform(BSP.Matrix, EndPos1)
   DetectCollision = Collision(a, b, 0, 0, 0, Vector(0, 0, 0), False)
   
End Function
'*** New Code Start
Private Function FindPlayerLeaf() As Integer
 
  Dim counter As Integer
  Dim sp As D3DVECTOR
  sp = MITransform(BSP.Matrix, StartPos)
  With BSP
  For counter = 1 To numleaf
    If -sp.x >= .leaf(counter).Bound.min(0) And -sp.x <= .leaf(counter).Bound.max(0) Then
      If sp.y >= .leaf(counter).Bound.min(1) And sp.y <= .leaf(counter).Bound.max(1) Then
        If sp.z >= .leaf(counter).Bound.min(2) And sp.z <= .leaf(counter).Bound.max(2) Then
           FindPlayerLeaf = counter
           Exit Function
        End If
      End If
    End If
  Next
  End With
 
End Function

Public Sub LoadShaderDirectory(DirectoryPath As String)
   Dim d As String, o As String
   d = DirectoryPath
   If Right$(d, 1) <> "\" Or Right$(d, 1) <> "\" Then d = d + "\"
   
   o = Dir$(d + "*.shader")
   Do While o <> ""
     NumFileShader = NumFileShader + 1
     ReDim Preserve ShaderFile(NumFileShader)
     ShaderFile(NumFileShader).Filename = d + o
     LoadShaderHeader NumFileShader
     o = Dir$
   Loop
   
End Sub

Private Sub LoadShaderHeader(file As Integer)
    'Load the shader header for each file
     Dim Ident As Integer
     Dim lin$
     With ShaderFile(file)
      Open ShaderFile(file).Filename For Input As 3
       Do
          Line Input #3, lin$
          lin$ = Trime(lin$)
          If lin$ = "" Or Left$(lin$, 2) = "//" Then
          Else
            'not a comment line
            If InStr(lin$, "{") <> 0 Then
              Ident = Ident + 1
            ElseIf InStr(lin$, "}") <> 0 Then
              Ident = Ident - 1
            Else
             If Ident = 0 Then
              'it's a shader name
              'let's add it in the shaderlist
              .NumShader = .NumShader + 1
              ReDim Preserve .Shader(.NumShader)
              ReDim Preserve .offset(.NumShader)
              .offset(.NumShader) = Seek(3)
              .Shader(.NumShader) = lin$
             End If
            End If
          End If
       Loop Until EOF(3) = True
      Close #3
     End With
     
End Sub


Private Function NewCollide(LineStart As D3DVECTOR, LineEnd As D3DVECTOR) As Boolean
    NewCollide = LineSight(LineStart, LineEnd, 0)
End Function

Private Sub ParseEntity()

End Sub

Private Function Q3FindPlayerCluster() As Integer

  Dim counter As Integer
  Dim sp As D3DVECTOR
  
  sp = MITransform(BSP.Matrix, StartPos)
  With BSP
  For counter = 1 To numleaf
    If -sp.x >= .Q3Leaf(counter).BBox.min(0) And -sp.x <= .Q3Leaf(counter).BBox.max(0) Then
      If sp.y >= .Q3Leaf(counter).BBox.min(1) And sp.y <= .Q3Leaf(counter).BBox.max(1) Then
        If sp.z >= .Q3Leaf(counter).BBox.min(2) And sp.z <= .Q3Leaf(counter).BBox.max(2) Then
           Q3FindPlayerCluster = .Q3Leaf(counter).cluster
           Exit Function
        End If
      End If
    End If
  Next
  End With
 Q3FindPlayerCluster = 0
End Function


'*** New Code Start
Private Function FindVisiblefaces(LeafIndex As Long)

On Error GoTo Fin

  Dim l As Long
  Dim bit As Integer
  Dim x As Integer
  Dim tmpFace As Integer
  Dim i As Integer
    
 If LeafIndex > numleaf Then GoTo Fin
 If CheckSphere(BSP.LeafSphere(LeafIndex).Center, BSP.LeafSphere(LeafIndex).Radius) = 1 Then
   For l = 0 To BSP.leaf(LeafIndex).face_num - 1
       BSP.AffVis(BSP.lface(BSP.leaf(LeafIndex).face_id + l)) = 1
   Next l
 End If
Fin:
On Error GoTo 0

End Function

'*** New Code Start
Private Function FindVisibleLeafs(LeafIndex As Long) As Long
On Error Resume Next
  Dim v As Long
  Dim l As Long
  Dim bit As Integer
  Dim x As Integer
  Dim LeafVisCounter As Long
  
  v = BSP.leaf(LeafIndex).VisList
 
  If Err Then Exit Function
  
 
  LeafVisCounter = 1
  l = 1
  
  Do Until l >= numleaf
    If Err.Number = 9 Then Exit Do
    If BSP.VisList(v) = 0 Then
      l = l + (8# * BSP.VisList(v + 1))
      v = v + 1
    Else
      bit = 1
      Do Until bit >= 256
        If (BSP.VisList(v) And bit) Then
          BSP.LeafVis(LeafVisCounter) = l
          LeafVisCounter = LeafVisCounter + 1
        End If
        bit = bit * 2
        l = l + 1
      Loop
    End If
    v = v + 1
  Loop
  FindVisibleLeafs = LeafVisCounter
End Function

Private Sub GetSquaredSize(ByRef CWidth As Long, ByRef CHeight As Long)
   'If CWidth > 2 And CWidth <= 4 Then CWidth = 4
   'If CWidth > 4 And CWidth <= 8 Then CWidth = 8
   
   '*** CHANGED - AH ***
   ' Certain Cards REALLY don't like textures below 8 pixels wide or high
   ' i.e the voodoo 3 for a start
   If CWidth <= 8 Then CWidth = 8
   If CWidth > 8 And CWidth <= 16 Then CWidth = 16
   If CWidth > 16 And CWidth <= 32 Then CWidth = 32
   If CWidth > 32 And CWidth <= 64 Then CWidth = 64
   If CWidth > 64 And CWidth <= 128 Then CWidth = 128
   If CWidth > 128 Then CWidth = 256
  
   'fixed
   If CHeight <= 8 Then CHeight = 8
   If CHeight > 8 And CHeight <= 16 Then CHeight = 16
   If CHeight > 16 And CHeight <= 32 Then CHeight = 32
   If CHeight > 32 And CHeight <= 64 Then CHeight = 64
   If CHeight > 64 And CHeight <= 128 Then CHeight = 128
   If CHeight > 128 Then CHeight = 256
End Sub

Private Sub LoadQuake3()
  '------------------------
  ' Quake 3 BSP loading
  '-----------------------
  
  ' Get the header with chunks
  On Error Resume Next
  
  Dim Header As Q3BSPHeader
  Get #1, , Header
  
  
  'Get shader desc.
  NumShader = Header.Shader.Size / Len(BSP.Q3Shader(1))
  ReDim Preserve BSP.Q3Shader(NumShader) As Q3Shader
 
  Dim i As Long
  AddLog ""
  AddLog "---------------------------------"
  AddLog " QUAKE BSP 3 Loading Stats       "
  AddLog "---------------------------------"
  Seek 1, Header.Shader.offset + 1
  For i = 0 To NumShader - 1
    Get #1, , BSP.Q3Shader(i)
  Next i
  Dim S As Long
  S = Header.entities.Size
  Dim a As String
  a = Space$(S)
  Get #1, Header.entities.offset + 1, a
  BSP.Entity = a
  'Get Vertexes desc
  NumVertex = Header.Verts.Size / Len(BSP.Q3Vertex(1))
  ReDim Preserve BSP.Q3Vertex(NumVertex) As Q3Vertex
  
  Seek 1, Header.Verts.offset + 1
  Get #1, , BSP.Q3Vertex
  
  'get Face desc
  Numface = Header.faces.Size / Len(BSP.Q3Face(1))
  ReDim Preserve BSP.Q3Face(Numface) As Q3Face
  
  Seek 1, Header.faces.offset + 1
  Get #1, , BSP.Q3Face
  
  'get vertex elem
  numedge = Header.elems.Size / Len(BSP.lEdge(1))
  ReDim Preserve BSP.lEdge(numedge) As Long
  Seek 1, Header.elems.offset + 1
  Get #1, , BSP.lEdge
  
  
  'get index face
  numlface = Header.lface.Size / Len(BSP.Q3LFace(1))
  ReDim Preserve BSP.Q3LFace(numlface) As Long
  Seek 1, Header.lface.offset + 1
  Get #1, , BSP.Q3LFace
  
  'Fix OpenGL axis bug
  For i = 0 To NumVertex - 1
    BSP.Q3Vertex(i).Vec.x = -BSP.Q3Vertex(i).Vec.x
  Next i
  
  
  'Load Vis stuff
  Get #1, Header.vis.offset + 1, BSP.Q3Vis.numcluster
  Get #1, , BSP.Q3Vis.rowsize
  ReDim Preserve BSP.Q3Vis.Row(BSP.Q3Vis.numcluster * BSP.Q3Vis.rowsize) As Byte
  Get #1, , BSP.Q3Vis.Row
  
  
 'Load Nodes
  NumNode = Header.nodes.Size / Len(BSP.Q3Node(1))
  ReDim Preserve BSP.Q3Node(NumNode)
  Get #1, Header.nodes.offset + 1, BSP.Q3Node
  
 'Load Leafs
  numleaf = Header.leafs.Size / Len(BSP.Q3Leaf(1))
  ReDim Preserve BSP.Q3Leaf(numleaf)
  Get #1, Header.leafs.offset + 1, BSP.Q3Leaf
  
 'Load Models
  nummodel = Header.models.Size / Len(BSP.Q3Model(1))
  ReDim Preserve BSP.Q3Model(nummodel)
  Get #1, Header.models.offset + 1, BSP.Q3Model
   
  'Load Lightmaps
  ReDim Preserve BSP.lightmaps(Header.lightmaps.Size)
  Get #1, Header.lightmaps.offset + 1, BSP.lightmaps
  
  'Load Planes
  numplane = Header.planes.Size / Len(BSP.Q3Plane(1))
  ReDim Preserve BSP.Q3Plane(numplane)
  Get #1, Header.planes.offset + 1, BSP.Q3Plane
  
 ' For i = 0 To numleaf
 '  With BSP.Q3Leaf(i)
 '    AddLog CStr(.area) + " " + CStr(.funk) + " " + CStr(.numunk)
 '  End With
 ' Next i
  
  
  AddLog " num  Shader        : " + CStr(NumShader)
  AddLog " size Entities      : " + CStr(Header.entities.Size)
  AddLog " num  Vertex        : " + CStr(NumVertex)
  AddLog " num  Face          : " + CStr(Numface)
  AddLog " num  Vertex elem   : " + CStr(numedge)
  AddLog " num  Indexed faces : " + CStr(numlface)
  AddLog " size PVS Info      : " + CStr(Header.vis.Size)
  AddLog " num  Cluster       : " + CStr(BSP.Q3Vis.numcluster)
  AddLog " num  Leafs         : " + CStr(numleaf)
  
  AddLog "-------------------------------------------"
  
  AddLog "Load Lightmaps : " + CStr(numlightmaps)
  Q3LoadLightMaps
   'D3DXMatrixScaling Mat, 1, 1, 1
   D3DXMatrixRotationX BSP.Matrix, -PI / 2
   'D3DXMatrixMultiply BSP.Matrix, Mat, BSP.Matrix
  AddLog "Transform faces for TrueVision"
  Q3TransformFace
  ReDim BSP.AffVis(Numface)
  ReDim BSP.LeafVis(numleaf)
 
End Sub

Sub OpenPackWAD(WadFilename As String)
   BSP.WadEnable = True
   BSP.WadFilename = WadFilename
End Sub

Private Static Function Q3ClipBoundingBox(Bound As BBox) As Integer
   Dim BValue(6) As Single, CornerB(8) As D3DVECTOR
   Dim Clipcode As Long, clip_or As Long, clip_and As Long, clip_in As Long
   Dim i As Long
   DXCopyMemory BValue(0), Bound, 24
   
   If EyePoint.x >= BValue(0) And EyePoint.x <= BValue(3) And _
      EyePoint.y >= BValue(1) And EyePoint.y <= BValue(4) And _
      EyePoint.z >= BValue(2) And EyePoint.z <= BValue(5) Then
        Q3ClipBoundingBox = 1
        Exit Function
   End If
      
   clip_in = 0
   clip_or = 0
   clip_and = &HFF
      
   For i = 0 To 7
     CornerB(i).x = BValue(Corner(i).x)
     CornerB(i).y = BValue(Corner(i).y)
     CornerB(i).z = BValue(Corner(i).z)
     Clipcode = VolumeCheck(CornerB(i), Mat)
     clip_or = clip_or Or Clipcode
     clip_and = clip_and And Clipcode
     If Clipcode = 0 Then clip_in = 1
   Next i
    
   If clip_and > 0 Then Q3ClipBoundingBox = 0: Exit Function
   If clip_or = 0 Then Q3ClipBoundingBox = 2: Exit Function
   If clip_in = 1 Then Q3ClipBoundingBox = 1: Exit Function
     Q3ClipBoundingBox = 1
End Function
Private Static Function Q3ClipBoundInt(Bound As IntBBox) As Integer
    Dim P As BBox
     P.min.x = Bound.min(0)
     P.min.y = Bound.min(1)
     P.min.z = Bound.min(2)
     P.max.x = Bound.max(0)
     P.max.y = Bound.max(1)
     P.max.z = Bound.max(2)
    Q3ClipBoundInt = Q3ClipBoundingBox(P)
End Function


Private Sub Q3MeshFillCurve3(cp As Long, Size As Long, stride As Long, P() As D3DVECTOR, Start As Long) '
  Dim Step As Long, halfstep As Long, i As Long, mid As Long
  Dim a As D3DVECTOR, b As D3DVECTOR
  Step = (Size - 1) / (cp - 1)
  
  Do While Step > 0
     halfstep = Step / 2
     For i = 0 To Size - 2 Step Step * 2
        mid = (i + Step) * stride + Start
        a = VAverage(P(i * stride + Start), P(mid))
        b = VAverage(P(mid), P((i + Step * 2) * stride + Start))
        P(mid) = VAverage(a, b)
        If halfstep > 0 Then
          P((i + halfstep) * stride + Start) = a
          P((i + 3 * halfstep) * stride + Start) = b
        End If
     Next i
     Step = Step / 2
  Loop
  
End Sub
Private Sub Q3MeshFillCurve2(cp As Long, Size As Long, stride As Long, P() As D3DVECTOR2, Start As Long) '
  Dim Step As Long, halfstep As Long, i As Long, mid As Long
  Dim a As D3DVECTOR2, b As D3DVECTOR2
  Step = (Size - 1) / (cp - 1)
  
  Do While Step > 0
     halfstep = Step / 2
     For i = 0 To Size - 2 Step Step * 2
        mid = (i + Step) * stride + Start
        a = VAverage2(P(i * stride + Start), P(mid))
        b = VAverage2(P(mid), P((i + Step * 2) * stride + Start))
        P(mid) = VAverage2(a, b)
        If halfstep > 0 Then
          P((i + halfstep) * stride + Start) = a
          P((i + 3 * halfstep) * stride + Start) = b
        End If
     Next i
     Step = Step / 2
  Loop
  
End Sub
Private Sub Q3MeshFillPatch3(numcp() As Long, Size() As Long, P() As D3DVECTOR)
   Dim Step As Long, U As Long, v As Long
   
   Step = (Size(0) - 1) / (numcp(0) - 1)
   For U = 0 To Size(0) - 1 Step Step
    Q3MeshFillCurve3 numcp(1), Size(1), Size(0), P(), U
   Next U
   For v = 0 To Size(1) - 1 Step 1
    Q3MeshFillCurve3 numcp(0), Size(0), 1, P(), v * Size(0)
   Next v
End Sub
Private Sub Q3MeshFillPatch2(numcp() As Long, Size() As Long, P() As D3DVECTOR2)
   Dim Step As Long, U As Long, v As Long
   
   Step = (Size(0) - 1) / (numcp(0) - 1)
   For U = 0 To Size(0) - 1 Step Step
    Q3MeshFillCurve2 numcp(1), Size(1), Size(0), P(), U
   Next U
   For v = 0 To Size(1) - 1 Step 1
    Q3MeshFillCurve2 numcp(0), Size(0), 1, P(), v * Size(0)
   Next v
End Sub

Private Function Q3MeshCreate(Face As Long) As Long
    Dim Step(1) As Long, Size(1) As Long, lens As Long, i As Long, U As Long, v As Long, P As Long
    Dim cp() As D3DVECTOR, vertn As Long
    'Dim Vert() As Q3Vertex
    
    ReDim cp(BSP.Q3Face(Face).numvert)
    For i = 0 To BSP.Q3Face(Face).numvert - 1
      cp(i) = BSP.Q3Vertex(BSP.Q3Face(Face).firstvert + i).Vec
    Next i
    
    
    ' Find the degree of subdivision in the u and v directions
    Q3MeshFindSize Face, cp(), Size()
    
    Erase cp
    
    lens = Size(0) * Size(1)
    NumMesh = NumMesh + 1
    ReDim Preserve BSP.Q3Mesh(NumMesh)
    
    
    With BSP.Q3Mesh(NumMesh)
     .Size(0) = Size(0)
     .Size(1) = Size(1)
     
          
     ReDim .Point(lens)
     ReDim .colour(lens)
     ReDim .lmst(lens)
     ReDim .St(lens)
        
     Step(0) = (Size(0) - 1) / (BSP.Q3Face(Face).mesh_cp(0) - 1)
     Step(1) = (Size(1) - 1) / (BSP.Q3Face(Face).mesh_cp(1) - 1)
   
      
    vertn = BSP.Q3Face(Face).firstvert
    
    For v = 0 To Size(1) - 1 Step Step(1)
      For U = 0 To Size(0) - 1 Step Step(0)
         P = v * Size(0) + U
         .Point(P) = BSP.Q3Vertex(vertn).Vec
         .St(P) = BSP.Q3Vertex(vertn).St
         .lmst(P) = BSP.Q3Vertex(vertn).EnvST
         .colour(P) = BSP.Q3Vertex(vertn).color
         vertn = vertn + 1
      Next U
   Next v
    
    'Fill in each mesh
    Q3MeshFillPatch3 BSP.Q3Face(Face).mesh_cp, Size, .Point
    Q3MeshFillPatch2 BSP.Q3Face(Face).mesh_cp, Size, .St
    Q3MeshFillPatch2 BSP.Q3Face(Face).mesh_cp, Size, .lmst
     
  .numelems = (Size(0) - 1) * (Size(1) - 1) * 6
  ReDim .elem(.numelems)
  i = 0
  For v = 0 To Size(1) - 2
   For U = 0 To Size(0) - 2
      .elem(i + 0) = v * Size(0) + U
      .elem(i + 1) = (v + 1) * Size(0) + U
      .elem(i + 2) = v * Size(0) + U + 1
      .elem(i + 3) = v * Size(0) + U + 1
      .elem(i + 4) = (v + 1) * Size(0) + U
      .elem(i + 5) = (v + 1) * Size(0) + U + 1
      i = i + 6
   Next U
 Next v
 
End With
  Q3MeshCreate = NumMesh
End Function

Private Sub Q3LoadLightMaps()
  '--------------------------------------------------------------------
  ' Load LigthMaps from 128*128*3 lightmap tile in the Quake3 engine
  '--------------------------------------------------------------------
  
  
  If DisplayConsole = True Then
       LocalScreen.DrawText "Load lightmaps...", 20, 42, &HFF00FFFF, "BSP"
       FlipToScreen
     End If
     
  Dim i As Long
  Dim TexSize As Long
  TexSize = 128# * 128 * 3
  numlightmaps = UBound(BSP.lightmaps) / TexSize
  Dim TempData() As Byte
  ReDim Preserve TempData(1# * numlightmaps * TexSize)
  ReDim Preserve lightmap(numlightmaps)
  For i = 0 To numlightmaps - 1
    ' DXCopyMemory TempData(0), BSP.lightmaps(i * TexSize), TexSize
     Set lightmap(i) = CreateTextureFromLM(-3, i * TexSize)
     'TexSave "c:\lm" + CStr(i) + ".bmp", lightmap(i)
  Next i
  
End Sub

Private Function Q3MeshFindLevel(v() As D3DVECTOR) As Long
    Dim Level As Long
    Dim a As D3DVECTOR, b As D3DVECTOR, Dist As D3DVECTOR
    Dim MaxMeshLevel As Long, SubDivisionTol As Single
    MaxMeshLevel = BSP.Q3Curve
    SubDivisionTol = 0
     
    For Level = 0 To MaxMeshLevel - 1
        a = VAverage(v(0), v(1))
        b = VAverage(v(1), v(2))
        v(2) = VAverage(a, b)
        
        Dist = VSubtract(v(2), v(1))
        
        If VDotProduct(Dist, Dist) < SubDivisionTol * SubDivisionTol Then
          Exit For
        End If
         v(1) = a
        
    Next Level
    
    Q3MeshFindLevel = Level
    

End Function

Private Sub Q3MeshFindSize(Face As Long, cp() As D3DVECTOR, Size() As Long)
   Dim U As Long, v As Long, found As Long, Level As Long
   Dim a As D3DVECTOR, b As D3DVECTOR
   Dim ta As D3DVECTOR, tb As D3DVECTOR
   Dim test(2) As D3DVECTOR
   Dim numcp(1) As Long
   numcp(0) = BSP.Q3Face(Face).mesh_cp(0)
   numcp(1) = BSP.Q3Face(Face).mesh_cp(1)
   
   
'------------------------
'  U Test
'------------------------
   
   found = 0
   
   For v = 0 To numcp(1) - 1
     For U = 0 To numcp(0) - 2 Step 2
        ta = cp(v * numcp(0) + U)
        tb = cp(v * numcp(0) + U + 2)
        If VCompare(ta, tb) = 0 Then
          found = 1
          Exit For
        End If
     Next U
     If found = 1 Then Exit For
   Next v
    
    If found = 0 Then
      AddLog "QUAKE 3 MESH CURVES MAKER : ERROR : Bad controls points"
    End If
    
    test(0) = a
    test(1) = cp(v * numcp(0) + U + 3)
    test(2) = b
    Level = Q3MeshFindLevel(test())
    
    Size(0) = (2 ^ (Level + 1)) * ((numcp(0) - 1) / 2) + 1
    
'-------------------------
' V Test
'-------------------------
    
    found = 0
   
   For U = 0 To numcp(0) - 1
     For v = 0 To numcp(1) - 2 Step 2
        ta = cp(v * numcp(0) + U)
        tb = cp((v + 2) * numcp(0) + U)
        If VCompare(ta, tb) = 0 Then
          found = 1
          Exit For
        End If
     Next v
     If found = 1 Then Exit For
   Next U
  
    If found = 0 Then
      AddLog "QUAKE 3 MESH CURVES MAKER : ERROR : Bad controls points"
    End If
    
    test(0) = a
    test(1) = cp(v * numcp(0) * 3 + U)
    test(2) = b
    Level = Q3MeshFindLevel(test())
  
    Size(1) = (2 ^ (Level + 1)) * ((numcp(1) - 1) / 2) + 1
  
End Sub
Private Sub Q3Render()
Dim i As Long
  Dim a As Long, anc As Long, Face As Boolean, ActFace As Long, StartFace As Long, EndFace As Long
  Dim CurrentSH As Long
  Static OldTime As Long, AV As D3DVECTOR, v As D3DVECTOR
'Nleaf = 0
'D3DXMatrixMultiply Mat, BSP.Matrix, ViewMatrix
'D3DXMatrixMultiply Mat, Mat, ProjectionMatrix
'Mat = BSP.Matrix
'EyePoint = MITransform(BSP.Matrix, StartPos)
 Device.SetTextureStageState 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE
 'Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
' Device.SetTransform D3DTS_TEXTURE0, WorldMatrix
 Device.SetTransform D3DTS_WORLD, BSP.Matrix
v = VNormalize(VSubtract(EndPos, StartPos))

If VCompare(BSP.ActualPosition, StartPos) = 0 Then
  BSP.ActualPosition = StartPos
  anc = Q3FindPlayerCluster
  If anc <> BSP.ActualLeaf And anc <> -1 Then
    ReDim BSP.LeafVis(numleaf)
    BSP.ActualLeaf = anc
    Q3WalkVLeaf anc
    Face = True
  End If
End If
If BSP.UsePVS = False Then
  
  NumDispFace = Numface
  For i = 0 To Numface
     Facelist(i) = i
     FaceShader(i) = BSP.Q3Face(i).Shader
  Next i
  'Sort the face according to the shader
  QSort FaceShader(), Facelist(), 1, NumDispFace
Else
If GetTickCount - OldTime > 2000 Or Face = True Or Abs(VDotProduct(v, AV)) < 0.7 Then
    ReDim BSP.AffVis(Numface)
    NumDispFace = 0
    AV = v
    For i = 1 To numleaf
       Q3WalkLeaf i, 0
    Next i
    OldTime = GetTickCount
    QSort FaceShader(), Facelist(), 1, NumDispFace
 End If
End If
Device.SetRenderState D3DRS_ALPHATESTENABLE, 0
Device.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATER
Device.SetRenderState D3DRS_ALPHAREF, 0
Device.SetRenderState D3DRS_LIGHTING, 0
Device.SetRenderState D3DRS_CULLMODE, BSP.Culling
Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
Device.SetTextureStageState 1, D3DTSS_MIPFILTER, D3DTEXF_POINT
Device.SetTextureStageState 0, D3DTSS_MIPFILTER, D3DTEXF_POINT

  Dim V2 As D3DLVERTEX2, f As Long

' Draw the face of Model 0:
  Device.SetVertexShader TV_LVERTEX2
  Device.SetStreamSource 0, BSP.VertexBuffer, Len(V2)
  Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
  Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
  anc = 1
  NumFaceDisplayed = NumFaceDisplayed + NumDispFace
  For i = 1 To NumDispFace
    f = Facelist(i)
   If BSP.FaceT(f).Shader = -1 Then
       If FaceShader(i) <> anc Then
        Device.SetTexture 0, tex(BSP.FaceT(f).Texture)
        anc = FaceShader(i)
       End If
       Device.DrawPrimitive D3DPT_TRIANGLELIST, BSP.FaceT(f).VertexOffset, BSP.FaceT(f).VertexCount
   End If
  
  Next i
  'Dim Idex() As Integer, numId As Integer
  'numId = 0
  'anc = FaceShader(1)
  'Device.SetIndices BSP.IndexBuffer, 0
  
 ' ReDim Idex(NumDispFace * 30)
 ' For i = 1 To NumDispFace
 '   f = Facelist(i)
 '   If BSP.FaceT(f).Shader = -1 Then
 '       D3DIndexBuffer8SetData BSP.IndexBuffer, numId * 2, BSP.FaceT(f).IndexNum * 2, 0, BSP.FaceT(f).E(0)
 '       numId = numId + BSP.FaceT(f).IndexNum
 '
 '      If FaceShader(i) <> anc Then
 '       Device.SetTexture 0, tex(BSP.FaceT(f).Texture)
 '       anc = FaceShader(i)
 '       'Device.DrawPrimitive D3DPT_TRIANGLELIST, BSP.FaceT(f).VertexOffset, BSP.FaceT(f).VertexCount
 '       Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, 0, numId, 0, numId \ 3
 '       numId = 0
 '      End If
   
 '  End If
  
  'Next i
    
  'Exit Sub
anc = -1
If BSP.UseLightMap = True Then
 Device.SetRenderState D3DRS_ALPHATESTENABLE, 0
 Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 1
 Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_DESTCOLOR
 Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ZERO
 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
 For i = 1 To NumDispFace
    f = Facelist(i)
   If BSP.FaceT(f).Shader = -1 Then
     If BSP.FaceT(f).lightmap <> -1 Then
         If anc <> BSP.FaceT(f).lightmap Then
            anc = BSP.FaceT(f).lightmap
            Device.SetTexture 0, lightmap(BSP.FaceT(f).lightmap)
         End If
         Device.DrawPrimitive D3DPT_TRIANGLELIST, BSP.FaceT(f).VertexOffset, BSP.FaceT(f).VertexCount
     End If
   End If
 Next i
End If
 'Exit Sub


 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
'Exit Sub

On Error Resume Next
'Render the "shadered" objects
 Dim anims As Integer
 ActFace = 0
 StartFace = 0
 CurrentSH = FaceShader(ActFace)
 Do
     f = Facelist(ActFace)
     'If BSP.FaceT(f).Shader > -1 Then
        If CurrentSH <> FaceShader(ActFace) Then
          If CurrentSH <> -1 Then RenderShaders BSP.Q3Shader(CurrentSH).ShaderIndex, StartFace, ActFace - 1
          StartFace = ActFace
          CurrentSH = FaceShader(ActFace)
        End If
     'Else
     '   StartFace = ActFace
     'End If
     ActFace = ActFace + 1
 Loop Until ActFace > NumDispFace
 'Finish the stuff
 If CurrentSH > -1 Then
 RenderShaders BSP.Q3Shader(CurrentSH).ShaderIndex, StartFace, ActFace - 1
 End If
    Device.SetTextureStageState 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE
    Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
    Device.SetTransform D3DTS_TEXTURE0, WorldMatrix

 If BSP.SkyM > 0 And BSP.SkyEnabled = True Then
  Mesh(BSP.SkyM).Enabled = True
  Mesh(BSP.SkyM).Object.SetCullMode TV_DOUBLESIDED
  Mesh(BSP.SkyM).Object.SetPosition StartPos.x, StartPos.y, StartPos.z
  Mesh(BSP.SkyM).Object.Render
  Mesh(BSP.SkyM).Object.EnableSphereMapping True
  Mesh(BSP.SkyM).Enabled = False

 End If
 'LocalScene.DrawText "Critique mode " + CStr(BSP.Q3Plane(CollidedPlane).normal.x) + " " + CStr(BSP.Q3Plane(CollidedPlane).normal.y) + " " + CStr(BSP.Q3Plane(CollidedPlane).normal.z) + " " + CStr(BSP.Q3Plane(CollidedPlane).offset) + " " + CStr(Nleaf) + " Face " + CStr(BSP.ActualLeaf), 40, 40
End Sub
Private Function Q3TransformFace()
  Dim i As Long, h As Long, a As Long, found As Long
  Dim ShaderStr As String
  
  ' Load Shaders
  ReDim tex(NumShader)
  If DisplayConsole = True Then
    LocalScreen.DrawText "Load Shaders...", 20, 62, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
  
  Dim Sky As Long
  Sky = 0
  
  
  For i = 0 To NumShader - 1
    ' Test if this shader is in the shader list
     ShaderStr = Left$(BSP.Q3Shader(i).Shader, -1 + InStr(BSP.Q3Shader(i).Shader, Chr$(0)))
     found = 0
     For a = 1 To NumFileShader
       For h = 1 To ShaderFile(a).NumShader
         If ShaderStr = ShaderFile(a).Shader(h) Then
          found = 1
          Exit For
         End If
       Next h
       If found = 1 Then Exit For
     Next a
    
    If found = 1 Then
     Debug.Print ShaderStr
     'Load effectively the shaders !
     Open ShaderFile(a).Filename For Input As 3
        Seek 3, ShaderFile(a).offset(h)
        BSP.Q3Shader(i).ShaderIndex = LoadSimpleShader(3, ShaderStr, True)
        If Shaders(BSP.Q3Shader(i).ShaderIndex).Flags And SHADER_SKY Then
          Sky = BSP.Q3Shader(i).ShaderIndex
        End If
     Close #3
    Else
     Debug.Print "* "; ShaderStr
     ShaderStr = ShaderStr + ".TGA"
     If Exist(ShaderStr) = False Then
       'Test JPG
       ShaderStr = Left$(ShaderStr, Len(ShaderStr) - 4) + ".JPG"
     
     End If
     BSP.Q3Shader(i).ShaderIndex = -1
     Set tex(i) = LoadTexture(ShaderStr)
         
    End If
  Next i

   
  
  Debug.Print " face"
  ' Change Q3 Faces to TFaces
  ReDim BSP.FaceT(Numface)
  ReDim FaceShader(Numface)
  ReDim Facelist(Numface)
  Dim VO As Long, V1 As D3DVECTOR
  Dim TVertex() As D3DLVERTEX2
  Dim r As Long, edge_i As Long, factor As Single
  If DisplayConsole = True Then
    LocalScreen.DrawText "Q3 Mesh Curves calculations...", 20, 72, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
    
    For i = 0 To Numface - 1
    'TexInfo = BSP.TexInfo(BSP.Face(i).texinfo_id)

    With BSP.Q3Face(i)
      
     If .numelem > 0 Then
         ReDim BSP.FaceT(i).Vertex(.numelem)
         ReDim Preserve TVertex(VO + .numelem)
     '  AddLog "Surface normale " + CStr(.facetype) + " " +main CStr(.firstelem) + " " + CStr(.firstvert) + " " + CStr(.Shader) + " " + CStr(.numelem) + " " + CStr(.numvert)
      
      
      For r = 0 To .numelem - 1
       edge_i = .firstelem + r
       edge_i = BSP.lEdge(edge_i) + .firstvert
       V1 = BSP.Q3Vertex(edge_i).Vec
         
         With TVertex(VO + r)
             .x = V1.x: .y = V1.y: .z = V1.z
             .color = &HFFFFFFFF
             .tu1 = BSP.Q3Vertex(edge_i).St.x
             .tv1 = BSP.Q3Vertex(edge_i).St.y
             .tu2 = BSP.Q3Vertex(edge_i).EnvST.x
             .tv2 = BSP.Q3Vertex(edge_i).EnvST.y
         ' Debug.Print .tu2, .tv2
         End With
        BSP.FaceT(i).Vertex(r) = V1  'just for detection collision
        BSP.FaceT(i).lightmap = .lightmap
        BSP.FaceT(i).VertexCount = UBound(BSP.FaceT(i).Vertex) \ 3
    
       Next r
      Else
    
       If .facetype = 2 Then
         'Bezier Quadratic patch
         'Create it
          
         BSP.FaceT(i).Q3Mesh = Q3MeshCreate(i)
         With BSP.Q3Mesh(BSP.FaceT(i).Q3Mesh)
            ReDim BSP.FaceT(i).Vertex(.numelems)
            ReDim Preserve TVertex(VO + .numelems)
            For r = 0 To .numelems - 1
              TVertex(VO + r).x = .Point(.elem(r)).x
              TVertex(VO + r).y = .Point(.elem(r)).y
              TVertex(VO + r).z = .Point(.elem(r)).z
              TVertex(VO + r).color = &HFFFFFFFF
              TVertex(VO + r).tu1 = .St(.elem(r)).x
              TVertex(VO + r).tv1 = .St(.elem(r)).y
              TVertex(VO + r).tu2 = .lmst(.elem(r)).x
              TVertex(VO + r).tv2 = .lmst(.elem(r)).y
              BSP.FaceT(i).Vertex(r) = .Point(.elem(r))  'just for detection collision
              BSP.FaceT(i).lightmap = BSP.Q3Face(i).lightmap
           Next r
         End With
              BSP.FaceT(i).VertexCount = UBound(BSP.FaceT(i).Vertex) \ 3
       
       End If
        'BSP.FaceT(i).VertexCount = 0
          
      End If
    
    'Debug.Print "////////////////////////////////"
    BSP.FaceT(i).VertexOffset = VO
    If BSP.Q3Shader(.Shader).ShaderIndex > -1 Then
     BSP.FaceT(i).Texture = -1
     BSP.FaceT(i).Shader = BSP.Q3Shader(.Shader).ShaderIndex
    Else
     BSP.FaceT(i).Texture = .Shader
     BSP.FaceT(i).Shader = -1
    End If
    'FaceList(i) = i
    'FaceShader(i) = .Shader
    'AddLog CStr(.Shader)
    VO = VO + BSP.FaceT(i).VertexCount * 3
    'Debug.Print .lightmapoffset(0), .lightmapoffset(1), .lightmap
    'BSP.FaceT(i).Texture = BSP.TexInfo(.texinfo_id).Texture_id
    '*** New Code Start
    If BSP.FaceT(i).Translucy = False Then
      factor = 1
    Else
      factor = BSP.FaceT(i).TransFactor / 255
    End If
    'BSP.FaceT(i).Material.Ambient = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.Diffuse = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.emissive = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.Specular = DXColor(2, 2, 2, 2) 'DXColor(0.4, 0.4, 0.4, 1)
    'B SP.FaceT(i).Material.power = 1
    '*** End Code
    End With
  Next i
  If DisplayConsole = True Then
    LocalScreen.DrawText "Managing Data", 20, 82, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
    
  ReDim BSP.LeafSphere(numleaf)
  For i = 0 To numleaf - 1
   With BSP.Q3Leaf(i).BBox
     BSP.LeafSphere(i).Center.x = (.min(0) + .max(0)) * 0.5
     BSP.LeafSphere(i).Center.y = (.min(1) + .max(1)) * 0.5
     BSP.LeafSphere(i).Center.z = (.min(2) + .max(2)) * 0.5
     BSP.LeafSphere(i).Radius = Sqr((.max(0) - .min(0)) ^ 2 + (.max(1) - .min(1)) ^ 2 + (.max(2) - .min(2)) ^ 2) * 0.5
     BSP.LeafSphere(i).Center.x = -BSP.LeafSphere(i).Center.x
   End With
  Next i
  On Error Resume Next
  'QSort FaceShader(), FaceList(), 0, Numface - 1
  'For i = 0 To Numface - 1
  ' AddLog CStr(FaceShader(i)) + " " + CStr(FaceList(i))
  'Next i
  'Create the vertex buffer
  If Sky > 0 Then
    BSP.SkyM = LocalScene.CreateMeshBuilder("BSPSky").GetMeshIndex
    Mesh(BSP.SkyM).Object.CreateSphere Nothing, 2048, 12, 12
    Mesh(BSP.SkyM).Enabled = False
    Mesh(BSP.SkyM).Object.SetShader Shaders(Sky).Object
  End If
  
  Set BSP.VertexBuffer = Device.CreateVertexBuffer(VO * 40#, 0, TV_LVERTEX2, D3DPOOL_DEFAULT)
  D3DVertexBuffer8SetData BSP.VertexBuffer, 0, VO * 40#, 0, TVertex(0)
  BSP.VertexNumber = VO



End Function
Private Function Q3TransformFace2()
  Dim i As Long, h As Long, a As Long, found As Long
  Dim ShaderStr As String, NumInd As Long
  
  ' Load Shaders
  ReDim tex(NumShader)
  If DisplayConsole = True Then
    LocalScreen.DrawText "Load Shaders...", 20, 62, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
  
  Dim Sky As Long
  Sky = 0
  
  
  For i = 0 To NumShader - 1
    ' Test if this shader is in the shader list
     ShaderStr = Left$(BSP.Q3Shader(i).Shader, -1 + InStr(BSP.Q3Shader(i).Shader, Chr$(0)))
     found = 0
     For a = 1 To NumFileShader
       For h = 1 To ShaderFile(a).NumShader
         If ShaderStr = ShaderFile(a).Shader(h) Then
          found = 1
          Exit For
         End If
       Next h
       If found = 1 Then Exit For
     Next a
    
    If found = 1 Then
     Debug.Print ShaderStr
     'Load effectively the shaders !
     Open ShaderFile(a).Filename For Input As 3
        Seek 3, ShaderFile(a).offset(h)
        BSP.Q3Shader(i).ShaderIndex = LoadSimpleShader(3, ShaderStr, True)
        If Shaders(BSP.Q3Shader(i).ShaderIndex).Flags And SHADER_SKY Then
          Sky = BSP.Q3Shader(i).ShaderIndex
        End If
     Close #3
    Else
     Debug.Print "* "; ShaderStr
     ShaderStr = ShaderStr + ".TGA"
     If Exist(ShaderStr) = False Then
       'Test JPG
       ShaderStr = Left$(ShaderStr, Len(ShaderStr) - 4) + ".JPG"
     
     End If
     BSP.Q3Shader(i).ShaderIndex = -1
     Set tex(i) = LoadTexture(ShaderStr)
         
    End If
  Next i

   
  NumInd = 0
  Debug.Print " face"
  ' Change Q3 Faces to TFaces
  ReDim BSP.FaceT(Numface)
  ReDim FaceShader(Numface)
  ReDim Facelist(Numface)
  Dim VO As Long, V1 As D3DVECTOR
  Dim TVertex() As D3DLVERTEX2
  Dim r As Long, edge_i As Long, factor As Single
  If DisplayConsole = True Then
    LocalScreen.DrawText "Q3 Mesh Curves calculations...", 20, 72, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
    
    ReDim Preserve TVertex(NumVertex)
    For i = 0 To NumVertex - 1
      DXCopyMemory TVertex(i).x, BSP.Q3Vertex(i).Vec.x, 12
      DXCopyMemory TVertex(i).tu1, BSP.Q3Vertex(i).St.x, 8
      DXCopyMemory TVertex(i).tu2, BSP.Q3Vertex(i).EnvST.x, 8
      TVertex(i).color = &HFFFFFFFF
    Next i
    VO = NumVertex
    For i = 0 To Numface - 1
    
    With BSP.Q3Face(i)
      
     If .numelem > 0 Then
      NumInd = NumInd + .numelem
      'For collision detection
      ReDim BSP.FaceT(i).Vertex(.numelem)
      ReDim BSP.FaceT(i).E(.numelem)
      
      BSP.FaceT(i).IndexNum = .numelem
      
      For r = 0 To .numelem - 1
       edge_i = .firstelem + r
       edge_i = BSP.lEdge(edge_i) + .firstvert
       BSP.FaceT(i).E(r) = edge_i
          
        BSP.FaceT(i).Vertex(r) = BSP.Q3Vertex(edge_i).Vec 'just for detection collision
        BSP.FaceT(i).lightmap = .lightmap
        BSP.FaceT(i).VertexCount = UBound(BSP.FaceT(i).Vertex) \ 3
    
       Next r
      Else
    
       If .facetype = 2 Then
         'Bezier Quadratic patch
         'Create it
          
         BSP.FaceT(i).Q3Mesh = Q3MeshCreate(i)
         NumInd = NumInd = .numelem
         With BSP.Q3Mesh(BSP.FaceT(i).Q3Mesh)
            ReDim BSP.FaceT(i).Vertex(.numelems)
            ReDim BSP.FaceT(i).E(.numelems)
            BSP.FaceT(i).IndexNum = .numelems
            
            ReDim Preserve TVertex(VO + .numelems)
            For r = 0 To .numelems - 1
              BSP.FaceT(i).E(r) = VO + r
              DXCopyMemory TVertex(VO + r).x, .Point(.elem(r)).x, 12
              'TVertex(VO + r).x = .Point(.elem(r)).x
              'TVertex(VO + r).y = .Point(.elem(r)).y
              'TVertex(VO + r).z = .Point(.elem(r)).z
              TVertex(VO + r).color = &HFFFFFFFF
              
              DXCopyMemory TVertex(VO + r).tu1, .St(.elem(r)).x, 8
              DXCopyMemory TVertex(VO + r).tu2, .lmst(.elem(r)).x, 8
              
              ''TVertex(VO + r).tu1 = .St(.elem(r)).x
              'TVertex(VO + r).tv1 = .St(.elem(r)).y
              'TVertex(VO + r).tu2 = .lmst(.elem(r)).x
              'TVertex(VO + r).tv2 = .lmst(.elem(r)).y
              BSP.FaceT(i).Vertex(r) = .Point(.elem(r))  'just for detection collision
              BSP.FaceT(i).lightmap = BSP.Q3Face(i).lightmap
           Next r
         End With
         BSP.FaceT(i).VertexCount = UBound(BSP.FaceT(i).Vertex) \ 3
         VO = VO + UBound(BSP.FaceT(i).Vertex)
       End If
        'BSP.FaceT(i).VertexCount = 0
          
      End If
    
    'Debug.Print "////////////////////////////////"
    'BSP.FaceT(i).VertexOffset = VO
    If BSP.Q3Shader(.Shader).ShaderIndex > -1 Then
     BSP.FaceT(i).Texture = -1
     BSP.FaceT(i).Shader = BSP.Q3Shader(.Shader).ShaderIndex
    Else
     BSP.FaceT(i).Texture = .Shader
     BSP.FaceT(i).Shader = -1
    End If
    'FaceList(i) = i
    'FaceShader(i) = .Shader
    'AddLog CStr(.Shader)
    'VO = VO + BSP.FaceT(i).VertexCount * 3
    'Debug.Print .lightmapoffset(0), .lightmapoffset(1), .lightmap
    'BSP.FaceT(i).Texture = BSP.TexInfo(.texinfo_id).Texture_id
    '*** New Code Start
    If BSP.FaceT(i).Translucy = False Then
      factor = 1
    Else
      factor = BSP.FaceT(i).TransFactor / 255
    End If
    'BSP.FaceT(i).Material.Ambient = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.Diffuse = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.emissive = DXColor(1, 1, 1, factor)
    'BSP.FaceT(i).Material.Specular = DXColor(2, 2, 2, 2) 'DXColor(0.4, 0.4, 0.4, 1)
    'B SP.FaceT(i).Material.power = 1
    '*** End Code
    End With
  Next i
  If DisplayConsole = True Then
    LocalScreen.DrawText "Managing Data", 20, 82, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
    
  ReDim BSP.LeafSphere(numleaf)
  For i = 0 To numleaf - 1
   With BSP.Q3Leaf(i).BBox
     BSP.LeafSphere(i).Center.x = (.min(0) + .max(0)) * 0.5
     BSP.LeafSphere(i).Center.y = (.min(1) + .max(1)) * 0.5
     BSP.LeafSphere(i).Center.z = (.min(2) + .max(2)) * 0.5
     BSP.LeafSphere(i).Radius = Sqr((.max(0) - .min(0)) ^ 2 + (.max(1) - .min(1)) ^ 2 + (.max(2) - .min(2)) ^ 2) * 0.5
     BSP.LeafSphere(i).Center.x = -BSP.LeafSphere(i).Center.x
   End With
  Next i
  On Error Resume Next
  'QSort FaceShader(), FaceList(), 0, Numface - 1
  'For i = 0 To Numface - 1
  ' AddLog CStr(FaceShader(i)) + " " + CStr(FaceList(i))
  'Next i
  'Create the vertex buffer
  If Sky > 0 Then
    BSP.SkyM = LocalScene.CreateMeshBuilder("BSPSky").GetMeshIndex
    Mesh(BSP.SkyM).Object.CreateSphere Nothing, 2048, 12, 12
    Mesh(BSP.SkyM).Enabled = False
    Mesh(BSP.SkyM).Object.SetShader Shaders(Sky).Object
  End If
  
  Set BSP.VertexBuffer = Device.CreateVertexBuffer(VO * 40#, 0, TV_LVERTEX2, D3DPOOL_DEFAULT)
  Set BSP.IndexBuffer = Device.CreateIndexBuffer(NumInd * 2, 0, D3DFMT_INDEX16, D3DPOOL_MANAGED)
  D3DVertexBuffer8SetData BSP.VertexBuffer, 0, VO * 40#, 0, TVertex(0)
  BSP.VertexNumber = VO



End Function
Private Function Q3PVS(from As Long, toclus As Long) As Byte
'        (*(r_visibility->data + (from)*r_visibility->rowsize + \
'           ((to)>>3)) & (1 << ((to) & 7)))
 'On Error Resume Next
       Q3PVS = (BSP.Q3Vis.Row(BSP.Q3Vis.rowsize * from + (toclus \ 8)) And (2 ^ (toclus And 7)))
End Function

Private Static Sub Q3WalkLeaf(leaf As Long, accept As Long)
  'Dim i As Long
  
      Dim i As Long, f As Long
  With BSP.Q3Leaf(leaf)
    On Error Resume Next
    'If BSP.ActualLeaf >= 0 And .cluster >= 0 Then
    '  If Q3PVS(BSP.ActualLeaf, .cluster) = 0 Then Exit Sub
    'End If
    'If accept = 0 Then
    '   'If Q3ClipBoundInt(.bbox) = 0 Then Exit Sub
    If .cluster < 0 Then Exit Sub
    
    If BSP.LeafVis(.cluster) = 0 Then Exit Sub
    If CheckSphere(BSP.LeafSphere(leaf).Center, BSP.LeafSphere(leaf).Radius) = 0 Then Exit Sub
    'End If
   '
   On Local Error Resume Next
    'Nleaf = Nleaf + 1
    'For i = .fface To .Numface + .fface - 1
    '
    '  BSP.AffVis(BSP.Q3LFace(i)) = 1
    '
    'Next i
    Nleaf = Nleaf + 1
    For i = .fface To .Numface + .fface - 1
       f = BSP.Q3LFace(i)
       If BSP.AffVis(f) = 0 Then
         BSP.AffVis(f) = 1
         NumDispFace = NumDispFace + 1
         Facelist(NumDispFace) = f
         FaceShader(NumDispFace) = BSP.Q3Face(f).Shader
       End If
    Next i
  End With
End Sub

Private Sub Q3WalkVLeaf(leaf As Long)
  Dim v As Long
  Dim l As Long
  Dim i As Long
  Dim bit As Integer
  Dim x As Integer
  Dim Q3PVSe As Byte
  On Error Resume Next
  v = 1# * leaf * BSP.Q3Vis.rowsize
  If v < 0 Then Exit Sub
  
  Nleaf = 0
  Dim r As Long
  ReDim BSP.LeafVis(BSP.Q3Vis.numcluster)
  
  For i = 0 To BSP.Q3Vis.numcluster - 1
    BSP.LeafVis(i) = BSP.Q3Vis.Row(v + i \ 8) And (2 ^ (i And 7))
  Next i
  
 ' Do Until l >= numleaf - 1
 '   r = BSP.Q3Leaf(l).cluster
 '   'If Err.Number = 9 Then Exit Do
 '   If Q3PVSe <> 0 Then
 '      Nleaf = Nleaf + 1
 '      If CheckSphere(BSP.LeafSphere(l).Center, BSP.LeafSphere(l).radius) Then
 '        For i = BSP.Q3Leaf(l).fface To BSP.Q3Leaf(l).fface + BSP.Q3Leaf(l).numface - 1
 '          BSP.AffVis(BSP.Q3LFace(i)) = 1
 '        Next i
 '      End If
 '   End If
 '   l = l + 1
 ' Loop
  'Q3WalkVLeaf = LeafVisCounter
  '
End Sub


Private Static Sub Q3WalkNode(Node As Long, accept As Long)
  Dim Plane As TVPlane
  Dim clipstate As Long
   If BSP.Q3NodeV(Node) = 1 Then Exit Sub
   BSP.Q3NodeV(Node) = 1
   With BSP.Q3Node(Node)
     Plane = BSP.Q3Plane(.Plane)
   '  AddLog "CheckNode :" + CStr(node) + " " + CStr(Plane.Normal.x) + " " + CStr(Plane.Normal.y) + " " + CStr(Plane.Normal.z)
   '  AddLog "Child " + CStr(.Children(0)) + " " + CStr(.Children(1))
     If accept = 0 Then
         clipstate = Q3ClipBoundInt(.Bound)
         If clipstate = 0 Then Exit Sub
         If clipstate = 2 Then accept = 1
     End If
     
    ' If ClassifyPoint(EyePoint, Plane) > 0 Then
    '    If .Children(0) < 0 Then
    '       Q3WalkLeaf -(.Children(0) + 1), accept
    '    Else
    '       Q3WalkNode .Children(0), accept
    '    End If
    '    If .Children(1) < 0 Then
    '       Q3WalkLeaf -(.Children(1) + 1), accept
    '    Else
    '       Q3WalkNode .Children(1), accept
    '    End If
    ' Else
    '    If .Children(1) < 0 Then
    '       Q3WalkLeaf -(.Children(1) + 1), accept
    '    Else
    '       Q3WalkNode .Children(1), accept
    '    End If
    '    If .Children(0) < 0 Then
    '       Q3WalkLeaf -(.Children(0) + 1), accept
    '    Else
    '       Q3WalkNode .Children(0), accept
    '    End If
    ' End If
     
   End With
   
End Sub
'*** New Code Start
Public Sub Render()
'##BD This method renders all the visible faces (if PVS is on), or all the faces (if PVS is off). _
You can specified if you want lightmaps or not thanks to SetParameter.

 If Quake3 = 1 Then Q3Render: Exit Sub
 RenderHl
End Sub
Private Sub RenderHl()
 Static AcLeaf As Long, i As Long, LeafVisCounter As Long
  Static Critique As Long, AV As D3DVECTOR
  Dim a As Long, anc As Long, Face As Boolean
  Dim v As D3DVECTOR, j As Integer
' Draw the multipass texturing BSP
 On Error Resume Next
anc = -1
v = VNormalize(VSubtract(EndPos, StartPos))
Device.SetTransform D3DTS_WORLD, BSP.Matrix
  If VCompare(BSP.ActualPosition, StartPos) = 0 Then
     AcLeaf = FindPlayerLeaf
     BSP.ActualPosition = StartPos
     If AcLeaf <> BSP.ActualLeaf Then
       BSP.ActualLeaf = AcLeaf
       LeafVisCounter = FindVisibleLeafs(BSP.ActualLeaf)
       Face = True
     End If
  End If
 

 If FPS < 20 Then
   If Critique = 0 Then
    Critique = 1
    LocalScene.SetViewFrustum AngleFOV * 180 / 3.14, 1500
   End If
 Else
  If FPS > 40 Then
   If Critique = 1 Then
    Critique = 0
    LocalScene.SetViewFrustum AngleFOV * 180 / 3.14, farPlane
   End If
  End If
 End If

 Static OldTime As Long
 If GetTickCount - OldTime > 2000 Or Face = True Or Abs(VDotProduct(v, AV)) < 0.7 Then
  ReDim BSP.AffVis(Numface)
  AV = v
  For i = 1 To LeafVisCounter
        FindVisiblefaces BSP.LeafVis(i)
  Next i
  j = 1
  OldTime = GetTickCount
 End If

  'At the moment do only the multipass stuff
  Render2
  
  'Scene.DrawText CStr(j), 60, 60
  Exit Sub
'On Error GoTo ete
  
'  Device.SetRenderState D3DRS_LIGHTING, False
'Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_DESTCOLOR
'Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ZERO
'Device.SetRenderState D3DRS_CULLMODE, BSP.Culling
'Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
'Device.SetTextureStageState 1, D3DTSS_MIPFILTER, D3DTEXF_POINT
'Device.SetTextureStageState 0, D3DTSS_MIPFILTER, D3DTEXF_POINT''

 
'  Dim v As D3DVERTEX2

' Draw the LightMaps of Model 0:
'  Device.SetVertexShader TV_VERTEX2 '
'  Device.SetStreamSource 0, BSP.VertexBuffer, Len(v)
' Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
' Device.SetMaterial TempMat
' Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
' Device.SetTextureStageState 1, D3DTSS_TEXCOORDINDEX, 1
' Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
' Device.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATER
' Device.SetRenderState D3DRS_ALPHAREF, 0
' Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
 
' Set the base texture.

' Set the base texture operation and args.
'Call Device.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
'Call Device.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
'Call Device.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)

' Set the diffuse light map.

' Set the blend stage.
'Call Device.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE)
'Call Device.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
'Call Device.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)

 'For i = 0 To BSP.Model(0).numface - 1
 '  If BSP.AffVis(i) = 1 Then
 '    If BSP.FaceT(i).lightmap <> -1 Then
 '     Device.SetTexture 1, lightmap(BSP.FaceT(i).lightmap)
 '    Else
 '
 '    End If
 '    If anc <> BSP.FaceT(i).Texture Then
 '       Device.SetTexture 0, tex(BSP.FaceT(i).Texture)
 '       anc = BSP.FaceT(i).Texture
 '    End If
 '     Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(i).VertexOffset, BSP.FaceT(i).VertexCount - 2
 '  End If
 'Next i
 
 
 
'Call Device.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
'Call Device.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
'Call Device.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
'Call Device.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE)

'Exit Sub
' Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0'

 'Draw the non transparent other models
' For i = 1 To nummodel - 1
'    With BSP.Model(i)
'     If CheckSphere(BSP.ModelSphere(i).Center, BSP.ModelSphere(i).Radius) = 1 Then
'     If BSP.FaceT(.FirstFace).Translucy = False And BSP.FaceT(.FirstFace).Texture <> TriggerTexture Then
'      For a = .FirstFace To .FirstFace + .numface - 1
'        Device.SetMaterial BSP.FaceT(a).Material
'        Device.SetTexture 0, tex(BSP.FaceT(a).Texture)
'       Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(a).VertexOffset, BSP.FaceT(a).VertexCount - 2
'     Next a
'     End If
'     End If
'    End With
' Next i'

'Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCCOLOR
'Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
'Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
'Device.SetRenderState D3DRS_ZWRITEENABLE, 0
''Draw the transparent other models
'For i = 1 To nummodel - 1
'    With BSP.Model(i)
'      If BSP.FaceT(.FirstFace).Translucy = True And BSP.FaceT(.FirstFace).Texture <> TriggerTexture Then
'      For a = .FirstFace To .FirstFace + .numface - 1
'        Device.SetMaterial BSP.FaceT(a).Material
'        Device.SetTexture 0, tex(BSP.FaceT(a).Texture)
'        Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(a).VertexOffset, BSP.FaceT(a).VertexCount - 2
'      Next a
'      End If
'    End With
' Next i
' Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
'Device.SetRenderState D3DRS_ZWRITEENABLE, 1
'Device.SetRenderState D3DRS_LIGHTING, 0
End Sub
Private Sub Render2()
Dim i As Long
  Dim a As Long, anc As Long, Face As Boolean

Device.SetRenderState D3DRS_LIGHTING, False
Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_DESTCOLOR
Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ZERO
Device.SetRenderState D3DRS_CULLMODE, BSP.Culling
Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
Device.SetTextureStageState 1, D3DTSS_MIPFILTER, D3DTEXF_POINT
Device.SetTextureStageState 0, D3DTSS_MIPFILTER, D3DTEXF_POINT

 
  Dim v As D3DVERTEX2

' Draw the LightMaps of Model 0:
  Device.SetVertexShader TV_VERTEX2
  Device.SetStreamSource 0, BSP.VertexBuffer, Len(v)
 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
 Device.SetMaterial TempMat
 Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 1
 
 If BSP.UseLightMap = True Then
 For i = 0 To BSP.Model(0).Numface - 1
   If BSP.AffVis(i) = 1 Then
     If BSP.FaceT(i).lightmap <> -1 Then
      Device.SetTexture 0, lightmap(BSP.FaceT(i).lightmap)
      Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(i).VertexOffset, BSP.FaceT(i).VertexCount - 2
     End If
   End If
 Next i
 
 Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
 Device.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATER
 Device.SetRenderState D3DRS_ALPHAREF, 0
 
 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
 End If
 'Draw the model faces:
  
  Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
  For i = 0 To BSP.Model(0).Numface - 1
   Device.SetMaterial BSP.FaceT(i).Material
    If BSP.AffVis(i) = 1 Then
        If anc <> BSP.FaceT(i).Texture Then
            Device.SetTexture 0, tex(BSP.FaceT(i).Texture)
            anc = BSP.FaceT(i).Texture
        End If
     Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(i).VertexOffset, BSP.FaceT(i).VertexCount - 2
   
   End If
 Next i

'Exit Sub
 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0

 'Draw the non transparent other models
 For i = 1 To nummodel - 1
    With BSP.Model(i)
     If CheckSphere(BSP.ModelSphere(i).Center, BSP.ModelSphere(i).Radius) = 1 Then
     If BSP.FaceT(.FirstFace).Translucy = False And BSP.FaceT(.FirstFace).Texture <> TriggerTexture Then
      For a = .FirstFace To .FirstFace + .Numface - 1
        Device.SetMaterial BSP.FaceT(a).Material
        Device.SetTexture 0, tex(BSP.FaceT(a).Texture)
       Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(a).VertexOffset, BSP.FaceT(a).VertexCount - 2
     Next a
     End If
     End If
    End With
 Next i

Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCCOLOR
Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
Device.SetRenderState D3DRS_ZWRITEENABLE, 0
'Draw the transparent other models
For i = 1 To nummodel - 1
    With BSP.Model(i)
      If BSP.FaceT(.FirstFace).Translucy = True And BSP.FaceT(.FirstFace).Texture <> TriggerTexture Then
      For a = .FirstFace To .FirstFace + .Numface - 1
        Device.SetMaterial BSP.FaceT(a).Material
        Device.SetTexture 0, tex(BSP.FaceT(a).Texture)
        Device.DrawPrimitive D3DPT_TRIANGLEFAN, BSP.FaceT(a).VertexOffset, BSP.FaceT(a).VertexCount - 2
      Next a
      End If
    End With
 Next i
 Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
Device.SetRenderState D3DRS_ZWRITEENABLE, 1
Device.SetRenderState D3DRS_LIGHTING, 0
'LocalScene.DrawText "Critique mode " + CStr(Critique) + " Face " + CStr(Face), 40, 40

End Sub


Private Sub LoadTextures(Optional UseNumberFilename As Boolean, Optional TextureWidth As Long, Optional TextureHeight As Long)
 On Error GoTo apprend
      Dim TempTexture As Direct3DTexture8
     
     Dim C As Direct3DSurface8
   
    Dim WadHeader As WAD3
    Dim WadEnt() As WAD3Entity
    Dim WadTex As WAD3Texture
    Dim WF As Integer, a As Long, x As Long, y As Long, w As Long, h As Long
    Dim Palette(767) As Byte, color(255) As Long, hdc As Long, z As Long, offset As Long, offset1 As Long, d As Byte
    Dim by(512) As Byte, Format As Long
    Dim Data() As Byte
    LocalScreen.DrawText "Load textures...", 20, 46, &HFF00FFFF, "BSP"
    FlipToScreen
   Dim i As Long

' Load in WAD files
 If BSP.WadEnable = True Then
    WF = FreeFile
    Open BSP.WadFilename For Binary As WF
    Get #WF, , WadHeader
    ReDim WadEnt(WadHeader.NumTexture - 1)
    Get #WF, WadHeader.offset + 1, WadEnt()
    For i = 0 To WadHeader.NumTexture - 1
      WadEnt(i).Name = Left$(WadEnt(i).Name, InStr(WadEnt(i).Name, Chr$(0)) - 1)
    Next i
 End If

Dim TWidth As Long, THeight As Long
On Error GoTo apprend

 
If IsMissing(UseNumberFilename) = True Then
  UseNumberFilename = False
End If
'
Dim Trans As Boolean

 For i = 0 To UBound(BSP.MipTexture) - 1
      If TextureWidth = 0 Then
        TWidth = BSP.MipTexture(i).width
      Else
        TWidth = TextureWidth
      End If
      If TextureHeight = 0 Then
        THeight = BSP.MipTexture(i).height
      Else
        THeight = TextureHeight
      End If
      If Left$(BSP.MipTexture(i).TextureName, 1) = "{" Then
       Trans = True
      Else
       Trans = False
      End If
      ErrStr = "Debug 1"
      GetSquaredSize TWidth, THeight

  If BSP.WadEnable = True Then
   For a = 0 To WadHeader.NumTexture - 1
     If UCase$(WadEnt(a).Name) = UCase$(BSP.MipTexture(i).TextureName) Then
       Exit For
     End If
  Next a
   If a >= WadHeader.NumTexture Then
     AddLog BSP.MipTexture(i).TextureName + " no found in WAD3 Pack"
     GoTo suite
   End If

     Get #1, WadEnt(a).offset1 + 1, WadTex
     ReDim Data(WadTex.width * WadTex.height)
     w = WadTex.width
     h = WadTex.height
     Get #WF, , Data()
     Get #WF, WadEnt(a).offset1 + WadEnt(a).offset2 - 769, Palette
 
     offset = 0
     offset1 = 0
    'Transparent textures
    If Trans = True Then
     For x = 0 To 255
       Format = D3DFMT_A1R5G5B5
        'transform 24 bits palette to R5G6B5 color format
        by(offset1 + 1) = (Palette(offset) And &HF8) \ 2 Or (Palette(offset + 1) And &HC0) \ 64 Or &H80
        by(offset1) = (Palette(offset + 1) And &H38) * 4 Or (Palette(offset + 2) And &HF8) \ 8
        If Palette(offset) = 0 And Palette(offset + 1) = 0 And Palette(offset + 2) = 255 Then by(offset1 + 1) = 0: by(offset1) = 0
        offset1 = offset1 + 2
        offset = offset + 3
     Next x
    Else
     'Non transparent textures
        Format = D3DFMT_R5G6B5
     For x = 0 To 255
     
        'transform 24 bits palette to R5G6B5 color format
        by(offset1 + 1) = (Palette(offset) And &HF8) Or (Palette(offset + 1) And &HE0) \ 32
        by(offset1) = (Palette(offset + 1) And &H1C) * 8 Or (Palette(offset + 2) And &HF8) \ 8
        offset1 = offset1 + 2
        offset = offset + 3
     Next x
    End If
     offset = 0
     ReDim TData(WadTex.width * WadTex.height * 2#) As Byte
     For y = 0 To WadTex.height - 1
       For x = 0 To WadTex.width - 1
        d = Data(offset)
        TData(offset * 2) = by(d * 2)
        TData(offset * 2 + 1) = by(d * 2 + 1)
        offset = offset + 1
       Next x
      Next y
    
     w = WadTex.width
     h = WadTex.height
     
     If w < 8 Then w = 8
     If h < 8 Then h = 8
     Set C = Nothing
     D3DX.CheckTextureRequirements Device, w, h, 0, 0, Format, D3DPOOL_DEFAULT
     Set TempTexture = Device.CreateTexture(w, h, 1, 0, Format, D3DPOOL_MANAGED)
     Set C = Device.CreateImageSurface(w, h, Format)
     D3DX.LoadSurfaceFromMemory C, ByVal 0, ByVal 0, TData(0), Format, WadTex.width * 2, ByVal 0, REC(0, 0, WadTex.width, WadTex.height), D3DX_FILTER_LINEAR, &HFF000000
     Device.CopyRects C, ByVal 0, 0, TempTexture.GetSurfaceLevel(0), ByVal 0
     Dim f As Long, g As Long, cw As Long, ch As Long
     f = TempTexture.GetLevelCount
     cw = w
     ch = h
     'For g = 1 To f - 1
     ' w = w / 2
     ' h = h / 2
      'D3DX.LoadSurfaceFromSurface TempTexture.GetSurfaceLevel(g), ByVal 0, REC(0, 0, w, h), TempTexture.GetSurfaceLevel(0), ByVal 0, REC(0, 0, cw, ch), D3DX_FILTER_LINEAR, &HFF0000FF
     'Next g
     'delete trigger texture
     If InStr(UCase$(BSP.MipTexture(i).TextureName), "AAATRIGGER") > 0 Then
        TriggerTexture = i
     End If
     
     'no mipmapping in WAD mode
     D3DX.FilterTexture TempTexture, ByVal 0, 0, D3DX_FILTER_LINEAR
     Set tex(i) = TempTexture
     Set TempTexture = Nothing
    Else
suite:
   If UseNumberFilename = True Then
    ErrStr = "Use Number"
    Set tex(i) = LoadTexture(CStr(i) + ".bmp", &HFF0000FF, TWidth, THeight)
   Else
    ErrStr = "Dont Use numbers"
    '*** New Code Start
    '*  Fixed bug with TextureName + ".bmp" left a space after the Texture name
    Set tex(i) = LoadTexture(Trim$(BSP.MipTexture(i).TextureName) + ".bmp", &HFF0000FF, TWidth, THeight)
    '*** End
    If BSP.TexturePath <> "" Then
     If BSP.TextureN = False Then
       FileCopy CurDir$ + "\" + Trim(BSP.MipTexture(i).TextureName) + ".bmp", BSP.TexturePath + "\" + Trim(BSP.MipTexture(i).TextureName) + ".bmp"
     Else
       FileCopy CurDir$ + "\" + Trim(BSP.MipTexture(i).TextureName) + ".bmp", BSP.TexturePath + "\" + CStr(i) + ".bmp"
     End If
   End If
   End If
  
   If InStr(UCase(BSP.MipTexture(i).TextureName), "AAATRIGGER") Then
     ErrStr = "Trigger"
     TriggerTexture = i
   End If
'   If Left(BSP.MipTexture(i).TextureName, 1) = "{" Then
'
'      ERrStr = "Set Color Key"
'
'      Dim ck As DDCOLORKEY
'      ck.high = ppf.lBBitMask
'      ck.low = ppf.lBBitMask
'      'On Error Resume Next
'      tex(i).SetColorKey DDCKEY_SRCBLT, ck
      'Device.SetRenderState D3DRENDERSTATE_COLORKEYBLENDENABLE, True
      'Device.SetRenderState D3DRENDERSTATE_COLORKEYENABLE, True
'
  End If
 Next i
' Set TempTexture = Nothing
'  TextureLoaded = True
'  Close WF'

'  If BSP.MipMapping = True Then
'    CreateMipmaps
'  End If
'Exit Sub
Exit Sub
apprend:

AddLog CStr(Date) + " " + CStr(Time) + " Error in LoadTextures " + CurDir + " " + Err.Description + " " + CStr(Err.Number) + " " + CStr(i) + " " + ErrStr
Resume Next
End Sub
Private Sub ReleaseBSPTree()
  On Error Resume Next
  Dim i As Long
  If Not Device Is Nothing Then
    ClearScreen
    D3DX.DrawText D3DFont, &HFFFF0000, "Desallocate texture memory. Please Wait...", REC(10, 10, 0, 0), 0
    FlipToScreen
  End If
  For i = 0 To numtex - 1
   Set tex(i) = Nothing
  Next i
  For i = 0 To LightmapCount - 1
   Set lightmap(i) = Nothing
  Next i
  Erase BSP.AffVis, BSP.FaceT, BSP.Face, BSP.VisList, BSP.lightmaps
  Erase tex
  Erase lightmap
  Erase BSP.Edge
  Erase BSP.leaf, BSP.Face, BSP.FaceT, BSP.LeafVis, BSP.lEdge, BSP.lface, BSP.lightmaps, BSP.MipTexture, BSP.Model
  Erase BSP.Node, BSP.Plane
  Close
  
End Sub







Private Sub RenderShaders(Shader As Long, StartFace As Long, EndFace As Long)
          Dim a As Long, t As Long, f As Long, anims As Long, Light As Long
          Static b As Single
          b = b + 0.01
          
          Dim Mat As D3DMATRIX
          With Shaders(Shader)
           If .Flags And SHADER_SKY Then Exit Sub
           For a = 1 To .NbLayer
             With .Layers(a)
                
                If .Flags And SHADER_BLEND Then
                    Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
                    Device.SetRenderState D3DRS_SRCBLEND, .SrcBlend
                    Device.SetRenderState D3DRS_DESTBLEND, .DestBlend
                 Else
                    Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
                End If
                Light = 0
                Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
                If .Flags And SHADER_ANIMMAP Then
                   anims = (Int(GetTickCount * .FPS * 0.001) Mod .NbTex) + 1
                   Device.SetTexture 0, Textures(.tex(anims)).TexSurf
                ElseIf .Flags And SHADER_LIGHTMAP Then
                  Light = 1
                  Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 1
                Else
                  Device.SetTexture 0, Textures(.tex(1)).TexSurf
                End If
                
                If .Flags And SHADER_TCMOD Then
                 Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0 Or D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR
                 Device.SetTextureStageState 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2
                 D3DXMatrixIdentity Mat
                 Mat.m11 = 1
                 Mat.m22 = 1
                 If .Flags And SHADER_TCMODSCALE Then
                  Mat.m11 = .TcCoordScale.x '/ 10
                  Mat.m22 = .TcCoordScale.y '/ 100
                 End If
                 If .Flags And SHADER_TCMODSCROLL Then
                  Mat.m42 = .TcCoordScroll.x * GetTickCount * 0.001
                  Mat.m41 = .TcCoordScroll.y * GetTickCount * 0.001
                 End If
                 Device.SetTransform D3DTS_TEXTURE0, Mat
                Else
                 Device.SetTextureStageState 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE
                End If
                'Exit Sub
             End With
             If Light = 0 Then
                For f = StartFace To EndFace
                 t = Facelist(f)
                 Device.DrawPrimitive D3DPT_TRIANGLELIST, BSP.FaceT(t).VertexOffset, BSP.FaceT(t).VertexCount
               Next f
             Else
               For f = StartFace To EndFace
                 t = Facelist(f)
                 Device.SetTexture 0, lightmap(BSP.FaceT(t).lightmap)
                 Device.DrawPrimitive D3DPT_TRIANGLELIST, BSP.FaceT(t).VertexOffset, BSP.FaceT(t).VertexCount
               Next f
             
            End If
           Next a
        End With
       Device.SetTextureStageState 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE
      Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
      Device.SetTransform D3DTS_TEXTURE0, WorldMatrix
End Sub

Sub SetCopyTexturesFolder(OnOff As Boolean, pathname As String, Optional TextureNumber As Boolean = False)
  '##BD Enable/Disable the 'copy textures' functionnality
  '##PD OnOff Enable/Disable
  '##PD pathName Set the directory in that the texture will be copied.
  '##PD TextureNumber Decides if TrueVision must use texture numbers instead of texture name to create BMP files.
  If OnOff = True Then
    BSP.TexturePath = pathname
    BSP.TextureN = TextureNumber
  Else
    BSP.TexturePath = ""
  End If
End Sub

Sub SetCurvePrecision(CurvePrecision As CONST_TV_CURVE)
  BSP.Q3Curve = CurvePrecision
End Sub

Sub SetParameters(Optional UseLightMaps As Boolean = True, Optional UsePVSInfo As Boolean = True, Optional Culling As CONST_TV_CULLING = TV_DOUBLESIDED, Optional DisplaySky As Boolean = False)
  '##BD Changes the settings for the BSP rendering.
  '##PD UseLightMaps Decides if the loaded lightmaps will be rendered.
  '##PD UsePVSInfo Decides if TrueVision will check the possible visible leafs (speed up your rendering)
  '##PD Culling Culling mode
  BSP.Culling = Culling
  BSP.UsePVS = UsePVSInfo
  BSP.UseLightMap = UseLightMaps
  BSP.SkyEnabled = DisplaySky
End Sub

Sub SetPosition(x As Single, y As Single, z As Single)
    Dim Ident As D3DMATRIX
    D3DXMatrixRotationX Ident, -PI / 2
    BSP.Matrix = MTranslate(Ident, x, y, z)
End Sub

Public Function SlidingCollision(StartPos1 As D3DVECTOR, EndPos1 As D3DVECTOR, Ret As D3DVECTOR, Radius As Single) As Boolean
     '##BD Performs a sliding collision (only on x-z planes) and modifies the EndPos1 according to the result
     '##PD StartPos1 The player current position
     '##PD EndPos1 The player new position to test
     Ret = EndPos1
     SlidingCollision = True
 
      
     If DetectSphereCollision(Vector3(StartPos1.x, EndPos1.y, EndPos1.z), Radius) = True Then
        Ret.z = StartPos1.z
     End If
'          Ret.x = StartPos.x
'          Ret.y = EndPos1.y
'          SlidingCollision = False
'
'     End If
     If DetectSphereCollision(Vector3(EndPos1.x, EndPos1.y, StartPos1.z), Radius) = True Then
        Ret.x = StartPos1.x
     End If
'          Ret.z = StartPos.x
'          Ret.y = EndPos1.y
'          SlidingCollision = False
'
'     End If
End Function

Public Function StayOnFloor(Position As D3DVECTOR, Optional TestMin As Single = -5, Optional TestMax As Single = 100, Optional Radius As Single = 5) As Single
  
 Dim z As Single, ok As Integer, zok As Single
 If Radius = 0 Then Exit Function
 For z = TestMin To TestMax Step Radius
   If DetectSphereCollision(Vector3(Position.x, Position.y + z, Position.z), Radius) = False Then
      ok = 1
      zok = z
      Exit For
   End If
 Next z
  
If ok = 1 Then
 StayOnFloor = Position.y + zok
Else
 StayOnFloor = Position.y
End If
End Function

Public Function Trace(StartPos As D3DVECTOR, EndPos As D3DVECTOR) 'As BSPTraceReturn
    
End Function

Private Function LocateLeaf(ByRef Point As D3DVECTOR) '// By Adam Hoult
  Dim Current_Node As Long, result As Long
  If Quake3 = 0 Then
    Current_Node = 0
    While Current_Node > -1
        result = ClassifyPoint(BSP.Plane(BSP.Node(Current_Node).PlaneNum), Point)
        Select Case result
            Case CP_FRONT, CP_ONPLANE:
                Current_Node = BSP.Node(Current_Node).Children(0)
            Case CP_BACK:
                Current_Node = BSP.Node(Current_Node).Children(1)
        End Select
    Wend
  Else
   Current_Node = 0
    While Current_Node > -1
        result = ClassifyPoint2(Point, BSP.Q3Plane(BSP.Q3Node(Current_Node).Plane))
        Select Case result
            Case CP_FRONT, CP_ONPLANE:
                Current_Node = BSP.Q3Node(Current_Node).Children(0)
            Case CP_BACK:
                Current_Node = BSP.Q3Node(Current_Node).Children(1)
        End Select
    Wend
  End If
  LocateLeaf = -(Current_Node + 1)
End Function

Friend Function TransformBSPVector(v As D3DVECTOR) As D3DVECTOR
  v.x = -v.x
  TransformBSPVector = MTransform(BSP.Matrix, v)
End Function

Private Sub TransformFaces(Optional LoadLightMap As Boolean = True)
  On Error GoTo errtra
  Dim V1 As D3DVECTOR, V2 As D3DVECTOR
  Dim i As Long, nedge As Long, nbedge As Long, r As Long, edge_i As Long, S As Single, t As Single
  ReDim Preserve BSP.FaceT(Numface)
  Debug.Print numedge, Numface
  Dim TempS(10) As Single, TempT(10) As Single, factor As Single, EnvKey As String
   'If bsp.Filename = "" Then
   '  AddLog "BSPTREE : A Bsp file must be loaded before calling this method"
   '  Exit Sub
   'End If

  Dim TexInfo As TextureInfo ' Temporary storage of the tex info struct
  Dim Enti As String, RenderAMT As Long, RenderModeAMT As Long
  
  'Search translucy
  Dim result As TokenString, modelKey As String
  result.ResteStr = BSP.Entity
  
  If DisplayConsole = True Then
    LocalScreen.DrawText "Create world...", 20, 62, &HFF00FFFF, "BSP"
    FlipToScreen
  End If
  Do
     result = GetEntityToken2("model", "", result.ResteStr)
     If result.LeftStr <> "" Then
       modelKey = GetKeyValue(result.LeftStr, "model")
       If Left$(modelKey, 1) = "*" Then
         'normal model
         i = val(mid(modelKey, 2))
         RenderAMT = val(GetKeyValue(result.LeftStr, "renderamt"))
         RenderModeAMT = val(GetKeyValue(result.LeftStr, "rendermode"))
         For r = BSP.Model(i).FirstFace To BSP.Model(i).FirstFace + BSP.Model(i).Numface - 1
           BSP.FaceT(r).TransFactor = RenderAMT
           If RenderAMT > 0 And RenderAMT < 255 Then
             BSP.FaceT(r).Translucy = True
           End If
         Next r
       Else
       EnvKey = GetKeyValue(result.LeftStr, "classname")
         'check if it's a sprite
         If EnvKey = "env_sprite" Or EnvKey = "env_glow" Then
            ' search if the sprite is already used
            For i = 1 To NumSpriteTex
             If InStr(modelKey, SpriteTexName(i)) > 0 Then
                If InStr(modelKey, "\") > 0 Then
                  modelKey = mid$(modelKey, InStr(modelKey, "\") + 1)
                End If
                If InStr(modelKey, "/") > 0 Then
                  modelKey = mid$(modelKey, InStr(modelKey, "/") + 1)
                End If
                GoTo PassPak
             End If
            Next i
            TestPAKFile modelKey
            AddLog result.LeftStr
            
            If DisplayConsole = True Then
               'LocalConsole.WriteConsole "Sprite or glow " + CStr(modelKey) + " used...", RGB(256, 256, 0)
               'FlipToScreen
            End If
PassPak:
            'CreateMeshFromSprite result.LeftStr, modelKey
            DeletePAKTemp modelKey
            Debug.Print "Ok "; modelKey

         End If
       End If
     End If
  Loop Until Trim$(result.ResteStr) = ""
  
  'Vertex transforming
  Dim ActualVertexOfs As Long, TVertex() As D3DVERTEX2
  
  
  For i = 0 To Numface - 1
    TexInfo = BSP.TexInfo(BSP.Face(i).texinfo_id)

    With BSP.Face(i)
      nedge = .egde_id
      nbedge = .numedge
       ReDim BSP.FaceT(i).Vertex(.numedge)
       ReDim Preserve TVertex(ActualVertexOfs + nbedge)
      
      For r = 0 To nbedge - 1
       edge_i = nedge + r
       edge_i = BSP.lEdge(edge_i)
       
       If edge_i < 0 Then
        V1 = BSP.Vertex(BSP.Edge(-edge_i).V2)
       Else
        V1 = BSP.Vertex(BSP.Edge(edge_i).V1)
       End If
   
        S = (-V1.x * TexInfo.S.x + V1.y * TexInfo.S.y + V1.z * TexInfo.S.z + TexInfo.DistS) / BSP.MipTexture(TexInfo.Texture_id).width
        t = (-V1.x * TexInfo.t.x + V1.y * TexInfo.t.y + V1.z * TexInfo.t.z + TexInfo.DistT) / BSP.MipTexture(TexInfo.Texture_id).height
        
       
         With TVertex(ActualVertexOfs + r)
            .x = V1.x: .y = V1.y: .z = V1.z
            .nx = 0: .ny = 0: .nz = 1
            .tu1 = S: .tv1 = t
         End With
         BSP.FaceT(i).Vertex(r) = V1  'just for detection collision
      Next r
    
    BSP.FaceT(i).VertexCount = UBound(BSP.FaceT(i).Vertex)
    BSP.FaceT(i).VertexOffset = ActualVertexOfs
    
    ActualVertexOfs = ActualVertexOfs + BSP.FaceT(i).VertexCount
    BSP.FaceT(i).Texture = BSP.TexInfo(.texinfo_id).Texture_id
    '*** New Code Start
    If BSP.FaceT(i).Translucy = False Then
      factor = 1
    Else
      factor = BSP.FaceT(i).TransFactor / 255
    End If
    BSP.FaceT(i).Material.Ambient = DXColor(1, 1, 1, factor)
    BSP.FaceT(i).Material.Diffuse = DXColor(1, 1, 1, factor)
    BSP.FaceT(i).Material.emissive = DXColor(1, 1, 1, factor)
    BSP.FaceT(i).Material.Specular = DXColor(2, 2, 2, 2) 'DXColor(0.4, 0.4, 0.4, 1)
    BSP.FaceT(i).Material.power = 1
    '*** End Code
    End With

  Next i
  
  'Create the vertex buffer
  Set BSP.VertexBuffer = Device.CreateVertexBuffer(ActualVertexOfs * 40#, 0, TV_VERTEX2, D3DPOOL_DEFAULT)
  D3DVertexBuffer8SetData BSP.VertexBuffer, 0, ActualVertexOfs * 40#, 0, TVertex(0)
  BSP.VertexNumber = ActualVertexOfs
  
  TempMat.Ambient = DXColor(1, 1, 1, 1)
  TempMat.Diffuse = DXColor(1, 1, 1, 1)
  TempMat.emissive = DXColor(1, 1, 1, 1)
  TempMat.Specular = DXColor(1, 1, 1, 1)
  If LoadLightMap = True Then LoadLightMaps
  
  'Create spheres for Visibility checking
  ReDim BSP.ModelSphere(nummodel)
  For i = 0 To nummodel - 1
    BSP.ModelSphere(i).Center = VScale(VAdd(BSP.Model(i).Bound.min, BSP.Model(i).Bound.max), 0.5)
    BSP.ModelSphere(i).Radius = VModulus(VSubtract(BSP.Model(i).Bound.min, BSP.Model(i).Bound.max)) / 2
    BSP.ModelSphere(i).Center.x = -BSP.ModelSphere(i).Center.x
  Next i
  
  ReDim BSP.LeafSphere(numleaf)
  For i = 0 To numleaf - 1
   With BSP.leaf(i).Bound
     BSP.LeafSphere(i).Center.x = (.min(0) + .max(0)) * 0.5
     BSP.LeafSphere(i).Center.y = (.min(1) + .max(1)) * 0.5
     BSP.LeafSphere(i).Center.z = (.min(2) + .max(2)) * 0.5
     BSP.LeafSphere(i).Radius = Sqr((.max(0) - .min(0)) ^ 2 + (.max(1) - .min(1)) ^ 2 + (.max(2) - .min(2)) ^ 2) * 0.5
     BSP.LeafSphere(i).Center.x = -BSP.LeafSphere(i).Center.x
   End With
  Next i
  
  'we need no more the vertexes, the texinfo
  Erase BSP.Vertex
  Erase BSP.Edge
  Erase BSP.TexInfo
  ReDim BSP.AffVis(Numface)
  
  Exit Sub
errtra:
  AddLog "BSPTREE : Error in creating world. STATE : ERROR (Level : 2/5)"
  AddLog Err.Description + " " + CStr(Err.Number)
  Resume Next
End Sub

Private Sub LoadLightMaps()
 'Load BSP lightmaps
On Error GoTo TreatError
'If DisplayConsole = True Then
' 'LocalConsole.WriteConsole "Lightmaps loader", RGB(256, 0, 0)
 'LocalConsole.WriteConsole "Load the world lightmaps & create textures coordinates...", RGB(0, 256, 0)
 'FlipToScreen
'End If
'    InitTextureSurface
    'On Error Resume Next
     Dim u_mid_poly As Single, v_mid_poly As Single
     Dim u_mid_texture As Single, v_mid_texture As Single

     Dim Mins(0 To 1) As Single, Maxs(0 To 1) As Single, val As Single
     Dim LMData() As Byte ' Stores the lightmap data, which we pass to the
                         ' Lightmap Texture creation function
    'Dim TexSize As Single, totalsize As Long
     Dim i As Long, j, k, l, E, b As Byte
     Dim v As D3DVECTOR
     Dim MinU As Single, MaxU As Single, MinV As Single, MaxV As Single
     Dim TexInfo As TextureInfo
     'If DisplayConsole = True Then
     '   LocalConsole.WriteConsole "", RGB(0, 256, 256), True
     ' End If

    
    
     ReDim TVertex(BSP.VertexNumber) As D3DVERTEX2
     D3DVertexBuffer8GetData BSP.VertexBuffer, 0, BSP.VertexNumber * 40#, 0, TVertex(0)
     
     If DisplayConsole = True Then
       LocalScreen.DrawFilledBox 20, 100, 180, 110, &H77000000, True
       LocalScreen.DrawBox 20, 100, 180, 110, &HFF00FF00
       LocalScreen.DrawText "Load lightmaps...", 20, 82, &HFF00FFFF, "BSP"
       FlipToScreen
     End If
    
    Dim GetNum As Single
    For i = 0 To Numface - 1
       If i Mod 10 = 0 Then
          GetNum = i / Numface
           LocalScreen.DrawFilledBox 21, 101, 21 + 158 * (i / Numface), 109, RGBA(1, GetNum, 0, 1), False
 '         LocalConsole.WriteConsole "LightMaps loaded :" + CStr(Int(i / numface * 100)) + " % (" + CStr(GetFreeMem) + " video memory bytes left)", RGB(0, 256, 256), True
           FlipToScreen
       End If
        TexInfo = BSP.TexInfo(BSP.Face(i).texinfo_id)
        If BSP.Face(i).lightmap > -1 And Trim(UCase(BSP.MipTexture(BSP.FaceT(i).Texture).TextureName)) <> "SKY" Then
            ReDim Preserve lightmap(LightmapCount)
            MinU = 100000: MinV = 100000
            MaxU = -100000: MaxV = -100000
            For j = 0 To BSP.FaceT(i).VertexCount - 1
                v = BSP.FaceT(i).Vertex(j)
                val = -v.x * TexInfo.S.x + v.y * TexInfo.S.y + v.z * TexInfo.S.z + TexInfo.DistS
                If val < MinU Then MinU = val
                If val > MaxU Then MaxU = val
                val = -v.x * TexInfo.t.x + v.y * TexInfo.t.y + v.z * TexInfo.t.z + TexInfo.DistT
                If val < MinV Then MinV = val
                If val > MaxV Then MaxV = val
            Next j
            'Store these Min/Max values, we need them later
            Mins(0) = MinU: Mins(1) = MinV
            Maxs(0) = MaxU: Maxs(1) = MaxV
            MinU = Floor(MinU / 16)
            MinV = Floor(MinV / 16)
            MaxU = Ceil(MaxU / 16)
            MaxV = Ceil(MaxV / 16)
           'Calculate LightMap Width and Heights.
            BSP.FaceT(i).LightMapWidth = MaxU - MinU + 1
            BSP.FaceT(i).LightMapHeight = MaxV - MinV + 1
            Set lightmap(LightmapCount) = CreateTextureFromLM(i, BSP.Face(i).lightmap)
            'get min/max u/v values (from the values we stored earlier)
            u_mid_poly = (Maxs(0) + Mins(0)) / 2#
            v_mid_poly = (Maxs(1) + Mins(1)) / 2#
            u_mid_texture = BSP.FaceT(i).LightMapWidth / 2#
           v_mid_texture = BSP.FaceT(i).LightMapHeight / 2#
            Dim uu As Single, vv As Single
            
            For k = 0 To BSP.FaceT(i).VertexCount - 1
                v = BSP.FaceT(i).Vertex(k)
                'Crap fix to sort out the way you load the vertices
                v.x = -v.x
                uu = v.x * TexInfo.S.x + v.y * TexInfo.S.y + v.z * TexInfo.S.z + TexInfo.DistS
                vv = v.x * TexInfo.t.x + v.y * TexInfo.t.y + v.z * TexInfo.t.z + TexInfo.DistT
                TVertex(k + BSP.FaceT(i).VertexOffset).tu2 = (u_mid_texture + (uu - u_mid_poly) / 16) / BSP.FaceT(i).LightMapWidth
                TVertex(k + BSP.FaceT(i).VertexOffset).tv2 = (v_mid_texture + (vv - v_mid_poly) / 16) / BSP.FaceT(i).LightMapHeight
            Next k
            BSP.FaceT(i).lightmap = LightmapCount
            LightmapCount = LightmapCount + 1
        Else
           BSP.FaceT(i).lightmap = -1
        End If
    Next i
    D3DVertexBuffer8SetData BSP.VertexBuffer, 0, BSP.VertexNumber * 40#, 0, TVertex(0)
    'we no longer need the lightmap data, so kill it.
    Erase BSP.lightmaps
    Erase BSP.TexInfo
    Erase BSP.Vertex
    Erase BSP.Edge
   ' Erase BSP.Plane
    Erase BSP.Face
  Exit Sub
TreatError:
    AddLog "Error in BSP Loading " + Err.Description + " " + CStr(D3DX.GetErrorString(Err.Number))
'    If DisplayConsole = True Then
'      LocalConsole.WriteConsole "Error in BSP LightMap Coordinates Loading..." + Err.Description + " " + CStr(Err.Number), RGB(256, 128, 128)
'      FlipToScreen
'    End If
  Resume Next
End Sub

Private Function Floor(value As Single) As Single
    If Int(value) < value Then
        Floor = Int(value)
    Else
        Floor = value
    End If
End Function
Private Function Ceil(value As Single) As Single
    If Int(value) < value Then
        Ceil = Int(value) + 1
    Else
        Ceil = value
    End If
End Function

'*** Code Added - AH ***
Private Function CreateTextureFromLM(Face As Long, LMPointer As Long) As Direct3DTexture8
    Dim i As Long, w As Long, h As Long, offset As Long, offset1 As Long
    Dim width As Long, height As Long
    If Face = -3 Then
      w = 128
      h = 128
    Else
      w = BSP.FaceT(Face).LightMapWidth
      h = BSP.FaceT(Face).LightMapHeight
    End If
    offset = LMPointer
    offset1 = 0
    ReDim by(w * h * 2#) As Byte
    For i = 0 To w * h - 1
      'Add a ambient light
      BSP.lightmaps(offset) = IIf(BSP.lightmaps(offset) < 223, BSP.lightmaps(offset) + 32, 255)
      BSP.lightmaps(offset + 1) = IIf(BSP.lightmaps(offset + 1) < 223, BSP.lightmaps(offset + 1) + 32, 255)
      BSP.lightmaps(offset + 2) = IIf(BSP.lightmaps(offset + 2) < 223, BSP.lightmaps(offset + 2) + 32, 255)
      
      'Transform 24bits to 16bits in order to load it in a surface
      by(offset1 + 1) = (BSP.lightmaps(offset) And &HF8) Or (BSP.lightmaps(offset + 1) And &HE0) \ 32
      by(offset1) = (BSP.lightmaps(offset + 1) And &H1C) * 8 Or (BSP.lightmaps(offset + 2) And &HF8) \ 8
      offset1 = offset1 + 2
      offset = offset + 3
    Next i
    width = w: height = h
    If width < 8 Then width = 8
    If height < 8 Then height = 8
    Dim Format As Long
    Format = 23
    
    D3DX.CheckTextureRequirements Device, width, height, 1, 0, Format, D3DPOOL_DEFAULT
    Dim TempTexture As Direct3DTexture8
    Set TempTexture = Device.CreateTexture(width, height, 1, 0, Format, D3DPOOL_MANAGED)
    Dim C As Direct3DSurface8
    Set C = Device.CreateImageSurface(width, height, D3DFMT_R5G6B5)
    D3DX.LoadSurfaceFromMemory C, ByVal 0, ByVal 0, by(0), D3DFMT_R5G6B5, w * 2, ByVal 0, REC(0, 0, w, h), D3DX_DEFAULT, 0
    Device.CopyRects C, ByVal 0, 0, TempTexture.GetSurfaceLevel(0), ByVal 0
   
    Set CreateTextureFromLM = TempTexture
    

End Function

Public Sub Load(Filename As String, Optional LoadLightMaps As Boolean = True, Optional LoadTexture As Boolean = True, Optional TextureNumber As Boolean = False, Optional TexturePath As String, Optional CreateDynamicLights As Boolean = False, Optional CreateMipmaps As Boolean = True)
'##BD This method loads a BSP file with the specified capabilities in the BSP buffer. When you have loaded the file, you can change the parameters and render it. You can use BSP (Half-Life maps) and BSP3 (Quake3 Maps) <i><b>Note :</b> The interface has changed since the version 1.8. Now the class has been simplified and this method loads the lightmaps and the textures directly.</i>

'##PD Filename BSP Tree file.
'##PD LoadLightMaps Decides if TrueVision must load the lightmaps or not.
'##PD LoadTexture Decides if TrueVision must load the textures.
'##PD TextureNumber Decides if TrueVision must use texture number instead of texture name to load textures.
If DisplayConsole = True Then
      ClearScreen
      LocalScreen.CreateUserFont "BSP", "Tahoma", 8, True, False, False
      LocalScreen.DrawFilledColorBox 10, 5, 200, 130, &HFF777700, &HFF007700, &HFF007777, &HFF770000, True
      LocalScreen.DrawBox 10, 5, 200, 130, &HFF00FF00
      LocalScreen.DrawText "BSP Loader for TrueVision 8 ", 20, 10, &HFFFF0000, "BSP"
      LocalScreen.DrawText "----------------------------", 20, 20, &HFFFF0000, "BSP"
      LocalScreen.DrawText "Load file " + CStr(Filename) + "...", 20, 30, &HFF00FFFF, "BSP"
      FlipToScreen
End If
BSP.Filename = Filename
TriggerTexture = -1
AddLog ""
AddLog "------------------------------------"
AddLog "  BSP Loader for TrueVision "
AddLog "------------------------------------"
AddLog " Load header and lumps."

BSP.MipMapping = CreateMipmaps
'On Error GoTo GestError
  '*** New Code Startm
  Dim i As Integer, S As String, EscChr As String
  '*** End
  Dim BSPH As BSPHeader
  TestPAKFile Filename
  
  Open Filename For Binary As 1
    Dim Header As String * 4
    Get #1, , Header
    If Header = "IBSP" Then
      AddLog " QUAKE 3 MAP ."
      Quake3 = 1
      LoadQuake3
      Exit Sub
    End If
    Quake3 = 0
    Get #1, 1, BSPH
    
    NumVertex = BSPH.vertices.Size / Len(BSP.Vertex(1))
    ReDim Preserve BSP.Vertex(NumVertex)
    Get #1, BSPH.vertices.offset + 1, BSP.Vertex()

    
    numplane = BSPH.planes.Size / Len(BSP.Plane(1))
    ReDim Preserve BSP.Plane(numplane)
    Get #1, BSPH.planes.offset + 1, BSP.Plane()

    
    '*** New Code Start
    numvis = BSPH.visilist.Size / Len(BSP.VisList(1))
    ReDim Preserve BSP.VisList(numvis)
    Get #1, BSPH.visilist.offset + 1, BSP.VisList()
    '*** End

    Numface = BSPH.faces.Size / Len(BSP.Face(1))
    ReDim Preserve BSP.Face(Numface)
    Get #1, BSPH.faces.offset + 1, BSP.Face()
   
    NumNode = BSPH.nodes.Size / Len(BSP.Node(1))
    ReDim Preserve BSP.Node(NumNode)
    Get #1, BSPH.nodes.offset + 1, BSP.Node()
   
    numedge = BSPH.edges.Size / Len(BSP.Edge(1))
    ReDim Preserve BSP.Edge(numedge)
    Get #1, BSPH.edges.offset + 1, BSP.Edge()
   
    numleaf = BSPH.leaves.Size / Len(BSP.leaf(1))
    ReDim Preserve BSP.leaf(numleaf)
    Get #1, BSPH.leaves.offset + 1, BSP.leaf()
   
    numtex = BSPH.TexInfo.Size / Len(BSP.TexInfo(1))
    ReDim Preserve BSP.TexInfo(numtex)
    Get #1, BSPH.TexInfo.offset + 1, BSP.TexInfo()
    
    numledge = BSPH.ledges.Size / Len(BSP.lEdge(1))
    ReDim Preserve BSP.lEdge(numledge)
    Get #1, BSPH.ledges.offset + 1, BSP.lEdge()
    
     nummodel = BSPH.models.Size / Len(BSP.Model(1))
    ReDim Preserve BSP.Model(nummodel)
    Get #1, BSPH.models.offset + 1, BSP.Model()
    
    numlface = BSPH.lface.Size / Len(BSP.lface(1))
    ReDim Preserve BSP.lface(numlface)
    Get #1, BSPH.lface.offset + 1, BSP.lface()
    
    AddLog "Load entities."
    '*** Code Change - AH ***
    ReDim Preserve BSP.lightmaps(BSPH.lightmaps.Size)
    Get #1, BSPH.lightmaps.offset + 1, BSP.lightmaps()
    '*** End - AH ***
    
    S = BSPH.entities.Size
    Dim a As String
    a = Space$(S)
    Get #1, BSPH.entities.offset + 1, a
    BSP.Entity = a
    
    Dim offset() As Long
    Dim NumMip As Long
    
    Get #1, BSPH.miptex.offset + 1, NumMip
    
    ReDim Preserve offset(NumMip)
    Get #1, , offset()
   
    ReDim Preserve BSP.MipTexture(NumMip)
     For i = 0 To NumMip - 1
     Get #1, BSPH.miptex.offset + 1 + offset(i), BSP.MipTexture(i)
    
     'Remove Chr(0)
     EscChr = InStr(BSP.MipTexture(i).TextureName, Chr(0))
     BSP.MipTexture(i).TextureName = Left(BSP.MipTexture(i).TextureName, EscChr - 1)
   
    ' Debug.Print offset(i), BSP.MipTexture(i).TextureName
     
    Next i
 
    '*** New Code Start
    '*** Fix for loading Half-Life BSPs
    For i = 0 To NumVertex - 1
      BSP.Vertex(i).x = -BSP.Vertex(i).x
    Next
    
    ReDim BSP.LeafVis(numleaf)
    ReDim BSP.AffVis(Numface)
    ReDim tex(numtex)
    ReDim lightmap(LightmapCount)

    '*** End
 'BSP.Filename = AppPath + Filename
 BSP.numGlowMesh = 0
 ReDim BSP.GlowMesh(0)
 
' AddLog CStr(BSP.Filename)
  Close #1
 
 D3DXMatrixRotationX BSP.Matrix, -PI / 2
 
 AddLog ""
 AddLog "BSP file Summary :"
 AddLog "Vertexes, models, planes, leafs loaded"
 AddLog CStr(NumVertex) + " Vertexes"
 AddLog CStr(numtex) + " Textures"
 AddLog CStr(nummodel) + " Models"
 AddLog CStr(Numface) + " Faces"
 AddLog CStr(UBound(BSP.lightmaps())) + " lightmap bytes."
 AddLog CStr(Len(BSP.Entity)) + " entity bytes"
 AddLog ""
AddLog "BSP TREE : Load textures."
LightMapMode = LoadLightMaps
If LoadTexture = True Then
  If TexturePath <> "" Then
    ChDir TexturePath
  End If
  LoadTextures TextureNumber
End If
AddLog "BSP TREE : Create world..."
TransformFaces LoadLightMaps
SetParameters LightMapMode

If CreateDynamicLights = True Then
  LoadDynamicLight
End If
DeletePAKTemp Filename
'w
Exit Sub

GestError:
  AddLog "BSP TREE : Error during loading : " + Err.Description + " " + CStr(Err.Number)
  If Err.Number = 53 Then
   Err.Clear
   Exit Sub
  End If
Resume Next


End Sub
Friend Function TransformKeyInVector(Key As String) As D3DVECTOR
   Dim x As Long, lef As String
   With TransformKeyInVector
     x = InStr(Key, " ")
     .x = val(Left$(Key, x - 1))
     lef = mid$(Key, x + 1)
     x = InStr(lef, " ")
     .y = val(Left$(lef, x - 1))
     .z = val(mid$(lef, x + 1))
   End With
   
End Function

Private Function Vector(x, y, z) As D3DVECTOR
  Vector.x = x
  Vector.y = y
  Vector.z = z
End Function


Private Sub Class_Initialize()
  AddLog "BSP Tree object initialized. STATE : OK"
  BSP.ActualLeaf = -50
  BSP.Culling = TV_DOUBLESIDED
  BSP.UseLightMap = True
  BSP.UsePVS = True
  Set BSPTree = Me
  BSP.ActualPosition = Vector(-9999, -9999, -9999)
  
  Corner(0) = Vector(1, 2, 3)
  Corner(1) = Vector(3, 1, 2)
  Corner(2) = Vector(3, 4, 2)
  Corner(3) = Vector(0, 4, 2)
  Corner(4) = Vector(0, 1, 5)
  Corner(5) = Vector(3, 1, 5)
  Corner(6) = Vector(3, 4, 5)
  Corner(7) = Vector(0, 4, 5)
  
  BitShift(0) = 1
  BitShift(1) = 2
  BitShift(2) = 4
  BitShift(3) = 8
  BitShift(4) = 16
  BitShift(5) = 32
  BitShift(6) = 64
  BitShift(7) = 128
  
  End Sub


Private Sub Class_Terminate()
 AddLog "BSP Tree : Desallocate Memory from textures and lightmaps. "

 ReleaseBSPTree
End Sub


