VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Camera8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'##CD This class contains easy and advanced method to move and use the camera. You can create this class with <i>Public Camera As New Camera</i><br><br>You can find also :<br> _
Advanced camera controls : <br> - Purchase camera TM <br> - Simple camera following

'-----------------
'****************
' TrueVision 0.9
'****************
'----------------
'  Camera class
'----------------
' by ~ Sylvain Dupont ~
'
' 03-06-2000 : Two bugs fixed
' 28-06-2000 : Creation

Private EyeHeight As Single



'*******************************
'*******************************
Function CheckPointVisibility(PointX, PointY, PointZ) As Boolean
 '##BD Check if the specified point is in our view frustum.
 '##PD PointX X-coordinate of the point to check
 '##PD PointY Y-coordinate of the point to check
 '##PD PointZ Z-coordinate of the point to check
 Device.SetTransform D3DTS_WORLD, WorldMatrix
 If CheckSphere(Vector(PointX, PointY, PointZ), 1) = True Then
   CheckPointVisibility = True
 Else
   CheckPointVisibility = False
 End If
 
'' If Device.ComputeSphereVisibility(Vector(PointX, PointY, PointZ), 1) And &HFFF000 Then
''  CheckPointVisibility = False
' Else
'  CheckPointVisibility = True
' End If
End Function
Function CheckSphereVisibility(CenterX, CenterY, CenterZ, Radius As Single) As Boolean
 '##BD Check if the specified sphere is in our view frustum.
 '##PD CenterX X-coordinate of the sphere center
 '##PD CenterY Y-coordinate of the sphere center
 '##PD CenterZ Z-coordinate of the sphere center
 '##PD Radius Sphere radius
'  If Device.ComputeSphereVisibility(Vector(CenterX, CenterY, CenterZ), CSng(radius)) And &HFFF000 Then
'  CheckSphereVisibility = False
' Else
'  CheckSphereVisibility = True
' End If
 Device.SetTransform D3DTS_WORLD, WorldMatrix
 If CheckSphere(Vector(CenterX, CenterY, CenterZ), Radius) = True Then
   CheckSphereVisibility = True
 Else
   CheckSphereVisibility = False
 End If

End Function

Function GetCameraLookAt() As D3DVECTOR
  '##BD Returns the lookat vector of the current camera.
  GetCameraLookAt = EndPos
End Function
Function GetCameraPosition() As D3DVECTOR
  '##BD Returns the camera position.
  GetCameraPosition = StartPos
End Function
Function GetCameraRotationX() As Single
  '##BD Returns the camera rotation around the x-axis (in degrees)
  'GetCameraRotationX = GetCameraAngle2
End Function
Function GetCameraRotationY() As Single
  '##BD Returns the camera rotation around the y-axis (in degrees)
   GetCameraRotationY = GetCameraAngle
End Function
Function GetMatrix() As D3DMATRIX
   GetMatrix = ViewMatrix
End Function

Sub LookAtMesh(Mesh As Mesh8)
  '##BD Makes the camera look at a mesh
  '##PD Mesh to look at
  Dim Ind As Integer
  Ind = Mesh.GetMeshIndex
  SetCameraLookAt Mesh.GetPosition.x, Mesh.GetPosition.y, Mesh.GetPosition.z
End Sub
Sub MoveForward(StepPerSecond As Single, Optional FollowLandscapeAltitude As Boolean, Optional CheckCollide As Boolean)
 '##BD Move forward the camera with the specfied step.
 '##PD StepPerSecond Distance to move in a second
 '##PD FollowLandscapeAltitude Decides if the camera have to roll on the landscape
 '##PD CheckCollide Decides if the camera must move if there is collision
 Dim Step As Single
 Dim v As D3DVECTOR
 'bug fixed, I use now a standard function
 Step = StepPerSecond * SystemFrame / 1000
 
angle = (-GetCameraAngle + 90)
v.x = Cos(angle * PiFactor) * Step
v.y = 0
v.z = Sin(angle * PiFactor) * Step
'If CheckCollide = True Then
' If LocalScene.AdvancedCollide(StartPos, EndPos).IsCollision = True Then
'  Exit Sub
' End If
'End If

 
 EndPos = VAdd(v, EndPos)
 StartPos = VAdd(v, StartPos)
  
If FollowLandscapeAltitude = True Then
 y = LocalLand.GetHeight(StartPos.x, StartPos.z) + EyeHeight - StartPos.y
 EndPos.y = EndPos.y + y
 StartPos.y = StartPos.y + y
End If
   D3DXMatrixLookAtLH ViewMatrix, StartPos, EndPos, Vector3(0, 1, 0)
  'DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub

Sub PurchaseFollowing(MeshObject As Mesh8, RelativeEndPosition As D3DVECTOR, LookAtInMesh As D3DVECTOR, CameraSpeed As Single, Optional ExponentialSpeed As Boolean = True, Optional MaxCameraSpeed As Single = 100, Optional AvoidObject As Boolean = False)
   '##BD Makes the camera purchase a mesh. Purchase-Camera effect (Tomb-Raider, Race games).
   '##PD RelativeEndPosition Camera position relative to the mesh. <i>Ex : (0,0,0) is IN the mesh (0,0,-20) is behind the mesh...</i>
   '##PD LookAtInMesh Camera LookAtPoint relative to the mesh.
   '##PD CameraSpeed Speed of the camera purchasing.
   '##PD ExponentialSpeed The speed changes according to the mesh distance.
   '##PD MaxCameraSpeed Maximum speed for the camera
   '##PD AvoidObject Decides if the camera must avoid the objects (mesh, terrain)
   On Error Resume Next
   Dim RelPos As D3DVECTOR, Direct As D3DVECTOR, Direction As D3DVECTOR, EndV As D3DVECTOR, a As D3DVECTOR
   
   RelPos = MTransform(Mesh(MeshObject.GetMeshIndex).matrix, RelativeEndPosition)
   Direct = VSubtract(RelPos, StartPos)
   
   If ExponentialSpeed = True Then CameraSpeed = CameraSpeed * VModulus(Direct)
   If CameraSpeed > MaxCameraSpeed Then CameraSpeed = MaxCameraSpeed
   If CameraSpeed <= 0 Then Exit Sub
   If VModulus(Direct) < 0.0001 Then
     Exit Sub
   End If
   If Abs(Direct.y) < SystemFrame / 1000 Then Direct.y = 0
    D3DXVec3Normalize Direction, Direct

'    Direction = VNormalize(Direct)
    a = StartPos ''

    EndV = VAdd(StartPos, VScale(Direction, SystemFrame * CameraSpeed / 1000))
''   If LocalScene.Collide(a, EndV) = False Or AvoidObject = False Then
    StartPos = EndV
 '  Else
 '   StartPos = a
  ' End If

   RelPos = MTransform(Mesh(MeshObject.GetMeshIndex).matrix, LookAtInMesh)
   EndPos = RelPos
   SetState

End Sub

Sub RotateAngles(x As Single, y As Single, z As Single)
    Dim CameraMatrix As D3DMATRIX
    D3DXMatrixIdentity CameraMatrix
    If x <> 0 Or y <> 0 Or z <> 0 Then
    CameraMatrix = MRotate(CameraMatrix, x, y, z)
    End If
    CameraMatrix = MTranslate(CameraMatrix, StartPos.x, StartPos.y, StartPos.z)
    
    ViewMatrix = CameraMatrix
    EndPos = MTransform(CameraMatrix, Vector(0, 0, 1))
    
    SetState
End Sub

Sub SetCameraRool(Degrees As Single)
  CameraRoll = Degrees * 3.1415 / 180
End Sub

Sub SetCameraRotation(DegreesX As Single, DegreesY As Single)
  '##BD Set the camera rotation around x and y-axis in degrees.
  SetCameraLookAt StartPos.x + Cos(DegreesX * PiFactor), StartPos.y + Sin(DegreesY * PiFactor), StartPos.z + Sin(DegreesX * PiFactor)
End Sub

Sub RotateCameraY(DegreesPerSecond As Single)
     
   SetCameraRotation ((SystemFrame + 1) * DegreesPerSecond / 1000) - GetCameraAngle + 90, 0
End Sub


Sub RotateAroundMesh(DestMesh As Mesh8, AddMeshRotation As Boolean, DegreesAngle As Single, Optional Distance As Single, Optional CameraRelativeAltitude As Single)
  '##BD Rotates the camera around a specified mesh.
  '##PD DestMesh Mesh around which the camera must rotate.
  '##PD AddMeshRotation Add the mesh rotation to the camera rotation.
  '##PD DegreesAngle Rotation angle
  '##PD Distance Distance between mesh and DestMesh
  '##PD CameraRelativeAltitude Set the camera altitude relative to the mesh.
  If Distance = 0 Then
    'use camera-mesh distance
    Dim d As D3DVECTOR
    d = VSubtract(DestMesh.GetPosition, StartPos)
    Distance = Sqr(d.x ^ 2 + d.y ^ 2 + d.z ^ 2)
  End If
  If AddMeshRotation = True Then
    angle = DestMesh.GetRotation.y + DegreesAngle
  Else
    angle = DegreesAngle
  End If
 '
  EndPos = DestMesh.GetPosition
  StartPos = VAdd(DestMesh.GetPosition, Vector(Cos(angle) * Distance, CameraRelativeAltitude, Sin(angle) * Distance))
  D3DXMatrixLookAtLH ViewMatrix, StartPos, EndPos, Vector3(0, 1, 0)
'  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub
Sub SetCamera(PosX, PosY, PosZ, LookAtX, LookAtY, LookAtZ)
 '##BD Set the camera start point and look at point
 StartPos = Vector(PosX, PosY, PosZ)
 EndPos = Vector(LookAtX, LookAtY, LookAtZ)
SetState
End Sub


Sub SetCameraLookAt(x As Single, y As Single, z As Single)
 '##BD Set the camera look at point
 EndPos = Vector(x, y, z)
SetState
End Sub
'----------------------------------------------
' Wrapper for General module : StartPos, EndPos
'----------------------------------------------

Sub SetCameraPosition(x As Single, y As Single, z As Single)
  '##BD Set the camera position.
  StartPos = Vector(x, y, z)
  
  SetState
End Sub
Sub SetMatrix(matrix As D3DMATRIX)
  ViewMatrix = matrix
End Sub
Sub SetPlayerEyeHeight(height As Single)
   '##BD Set the camera altitude relative to the landscape.
   EyeHeight = height
End Sub


Private Sub SetState()
 D3DXMatrixLookAtLH ViewMatrix, StartPos, EndPos, Vector(0, 1, 0)
If CameraRoll <> 0 Then
  ViewMatrix = MRotate(ViewMatrix, 0, 0, CameraRoll)
End If
  Device.SetTransform D3DTS_VIEW, ViewMatrix
  

End Sub

Sub SimpleFollowing(MeshObject As Mesh8, RelativePosition As D3DVECTOR, Optional WithCameraMove As Boolean = True)
   '##BD The camera follows the mesh.
   '##PD MeshObject Mesh to follow
   '##PD RelativePosition Camera position relative to the mesh.
   '##PD WithCameraMove Always True
   Dim RelPos As D3DVECTOR
   RelPos = MTransform(Mesh(MeshObject.GetMeshIndex).matrix, RelativePosition)
   StartPos = RelPos
   EndPos = Mesh(MeshObject.GetMeshIndex).Features.Settings.Position
 SetState
 '  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, Vector(0, 1, 0), 0
End Sub

Private Sub Class_Initialize()
  EyeHeight = 10
End Sub


