VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CollisionResult8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'##CD This class is returned when you done a AdvancedCollision. It contains all the collision details. You can't create it directly.


'-----------------------------
' Wrapper for Collision Result
'-----------------------------

Private CollDist As Single
Private CollU As Single
Private CollV As Single
Private CollMeshIndex As Single
Private CollNormal As D3DVECTOR
Private ColYes As Boolean
Private IPoint As D3DVECTOR
Private Sliding As D3DVECTOR
Private CollTexture As Integer
Public Enum CONST_TV_OBJECT_TYPE
  '##EN The object type that has been collided
  TV_COLLIDE_MESH = 1
  '##EM A mesh
  TV_COLLIDE_TERRAIN = 2
  '##EM A Terrain (inused)
  TV_COLLIDE_LANDSCAPE = 4
  '##EM A Landscape object
  TV_COLLIDE_BSPTREE = 8
  TV_COLLIDE_OCTREE = 16
  TV_COLLIDE_ACTOR = 32
  TV_COLLIDE_PHYSICOBJECT = 64
End Enum
'
' A Advanced collsion detection returns :'
'
'    - Collision distance
'    - Collision face normal
'    - Collision face TU & TV
'    - Collision object (BSP tree, mesh, terrain)


Function GetCollisionDistance() As Single
  '##BD Returns the distance between the start point and the collision point.
  GetCollisionDistance = CollDist
End Function

Function GetCollisionMesh() As Mesh8
  '##BD Returns the collided mesh class.
  If CollMeshIndex > 0 Then
   Set GetCollisionMesh = Mesh(CollMeshIndex).Object
  End If
End Function

Function GetCollisionNormal() As D3DVECTOR
  '##BD Returns the collision normal.
  GetCollisionNormal = CollisionNormal
End Function

Function GetCollisionObjectType() As CONST_TV_OBJECT_TYPE
  '##BD Returns the collided object type.
   If CollMeshIndex = -1 Then
     GetCollisionObjectType = TV_COLLIDE_BSPTREE
   End If
   If CollMeshIndex > 0 Then
     GetCollisionObjectType = TV_COLLIDE_MESH
   End If
   If CollMeshIndex = -2 Then
     GetCollisionObjectType = TV_COLLIDE_LANDSCAPE
   End If
   
End Function

Function GetCollisionTriangleUV(ByRef tu As Single, ByRef tv As Single)
  '##BD Returns the texture coordinates of the collision point on the collided face.
  '##PD TU Returns TU
  '##PD TV Returns TV
   tu = CollU
   tv = CollV
End Function


Function GetImpactPoint() As D3DVECTOR
  '##BD Returns the collision point.
  GetImpactPoint = CollisionImpact
End Function

Function IsCollision() As Boolean
 '##BD Returns True if there is collision, False else.
 IsCollision = ColYes
End Function

Friend Sub SetCollisionProperties(Col, Dist, U, v, normal As D3DVECTOR, MeshIndex, IPointV As D3DVECTOR, Optional tex = 0)
 CollDist = Dist
 CollisionNormal = normal
 CollMeshIndex = MeshIndex
 
 CollU = U
 CollV = v
 ColYes = Col
  IPoint = IPointV
  CollTexture = tex
End Sub
