VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileTVO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------
' TrueVision TVO file format
'---------------------------------
' you should use this class for loading
' and saving a list of meshes, landscape,
' and all TV objects!
' In short, use this format to save a
' entire scene

Private tff As Integer
Private TVOChunkTable() As ChunkMesh
Private TVOTextureTable() As TextureType
Private TVOTableOffset As Long

Private TVORead As Boolean
Private TVOWrite As Boolean

Private TVONbChunk As Integer
Sub AddUserData(UserChunkType As Integer, ChunkName As String, Data() As Byte, DataLength As Long)
   AddLog "TVO FILE : Add user data to TVO"
    
    AddChunk UserChunkType, TVOChunkTable(), tff
    AddChunk CHUNK_GENERALNAME, TVOChunkTable(), tff
    Put #tff, , ChunkName
    Put #tff, , Data()
End Sub


Function AddLandscape()
    '##BD
   
   AddLog "TVO FILE : Add landscape to TVO"
    Dim Hm() As Single
    If TVOWrite = True Then
       Dim t As LandscapeType
       
       AddChunk CHUNK_LANDSCAPE, TVOChunkTable(), tff
       AddChunk CHUNK_LANDFEATURES1, TVOChunkTable(), tff
       
       'Copy NBTerrain as Int
       t = LocalLand.GetDesc
       Put #tff, , t.NbTerrain
       
       For i = 1 To t.NbTerrain
         AddChunk CHUNK_TERRAIN, TVOChunkTable(), tff
         AddChunk CHUNK_TERRAINFEATURES, TVOChunkTable(), tff
          Put #tff, , t.Terrain(i).Position
          Put #tff, , t.Terrain(i).width
          Put #tff, , t.Terrain(i).height
          Put #tff, , t.Terrain(i).Precision
          Put #tff, , t.Terrain(i).TextureI
          Put #tff, , t.Terrain(i).MaterialI
          Put #tff, , t.Terrain(i).LightmapI
         AddChunk CHUNK_TERRAINFEATURES2, TVOChunkTable(), tff
          Put #tff, , t.Terrain(i).Sphere
          Put #tff, , t.Terrain(i).Radius
         AddChunk CHUNK_TERRAINHEIGHTMAP, TVOChunkTable(), tff
         ReDim Hm(t.Terrain(i).width * t.Terrain(i).height) As Single
         For k = 0 To t.Terrain(i).NVertex - 1
           Hm(k) = t.Terrain(i).Vertex(k).y
         Next k
         Put #tff, , Hm()
       Next i
    End If
    
    
End Function

Function AddParticleSystem(Particle As ParticleSystem8, Optional ParticleName As String = "")
     AddLog "TVO FILE : Add particle system to TVO"
  
  If TVOWrite = True Then
     AddChunk CHUNK_PARTICLESYSTEM, TVOChunkTable, tff
     If ParticleName <> "" Then
       AddChunk CHUNK_GENERALNAME, TVOChunkTable, tff
       Put #tff, , ParticleName
     End If
     AddChunk CHUNK_STANDARDFORMAT, TVOChunkTable, tff
     Particle.WriteToFile tff
  End If
End Function
Function AddScript(Script As String, Optional ScriptName As String = "")
    AddLog "TVO FILE : Add script to TVO"

End Function

Function AddMesh(MeshOb As Mesh8, Optional SaveName As String = "")
   AddLog "TVO FILE : Add mesh to TVO " + CStr(SaveName)
   
   If TVOWrite = True Then
      Dim t() As Integer, NTex As Integer
      Dim TexTable() As TVOTextureTable
      Dim SaveN As String * 32
      
      MI = MeshOb.GetMeshIndex
      
      AddChunk CHUNK_MESH, TVOChunkTable(), tff
      AddChunk CHUNK_MESHNAME, TVOChunkTable(), tff
      SaveN = Mesh(i).MeshName
      Put #tff, , SaveN
      If SaveName <> "" Then
        AddChunk CHUNK_GENERALNAME, TVOChunkTable(), tff
        SaveN = SaveName
        Put #tff, , SaveN
      End If
      
      AddChunk CHUNK_FEATURES, TVOChunkTable(), tff
      Put #tff, , Mesh(MI).Features.Settings.Position
      Put #tff, , Mesh(MI).Features.Settings.Rotation
      Put #tff, , Mesh(MI).Features.Settings.Scaling
      Put #tff, , Mesh(MI).Features.Settings.SphereClip
      Put #tff, , Mesh(MI).Features.Settings.SphereRadius
      
      AddChunk CHUNK_NBVERTEX, TVOChunkTable(), tff
      Put #tff, , Mesh(MI).Features.NbVertex
      If Mesh(MI).Features.TypeVertex = TV_COLOR_VERTEX Then
        AddChunk CHUNK_LVERTEX, TVOChunkTable(), tff
        Put #tff, , Mesh(MI).Features.LVertex()
      Else
        AddChunk CHUNK_VERTEX, TVOChunkTable(), tff
        Put #tff, , Mesh(MI).Features.Vertex()
      End If
      
      'Write some mesh settings
      If Mesh(MI).Features.Settings.Billboard = True Then
        AddChunk CHUNK_BILLBOARD, TVOChunkTable(), tff
      End If
      
      If Mesh(MI).Features.Settings.SPREnabled = True Then
        AddChunk CHUNK_SPRITE, TVOChunkTable(), tff
      End If
      
      'Write face number
      AddChunk CHUNK_NBFACE, TVOChunkTable(), tff
      Put #tff, , Mesh(MI).Features.NumGroup
      
      'Write face descs
      For i = 1 To Mesh(MI).Features.NumGroup
        With Mesh(MI).Features.Groups(i)
        AddChunk CHUNK_FACE, TVOChunkTable(), tff
        AddChunk CHUNK_SPHEREMAPPING, TVOChunkTable(), tff
        Put #tff, , Mesh(MI).Features.Groups(i).ShpereMapping
        AddChunk CHUNK_ALPHABLENDING, TVOChunkTable(), tff
        Put #tff, , Mesh(MI).Features.Groups(i).AlphaBlending
      
      If SaveTexDesc = True Then
        If .LightmapI > 0 Then
          AddChunk CHUNK_FACELIGHTMAP, TVOChunkTable(), tff
          Put #tff, , .LightmapI
        End If
        
        If .MaterialI > 0 Then
          AddChunk CHUNK_FACEMATERIAL, TVOChunkTable(), tff
          Put #tff, , .MaterialI
        End If
        
        If .TextureI > 0 Then
          'Check if this texture is already in texture table
          For o = 1 To NTex
            If .TextureI = t(o) Then
             Exit For
            End If
          Next o
          If o = NTex + 1 Then
            NTex = NTex + 1
            ReDim Preserve t(NTex)
          End If
          
          'Store the used texture index
          t(o) = .TextureI
          
          AddChunk CHUNK_FACETEXTURE, TVOChunkTable(), tff
          Put #2, , .TextureI
        End If
      End If
        
        AddChunk CHUNK_FACEVERTEXNUMBER, TVOChunkTable(), tff
        Put #tff, , .IndicesCount
        
        AddChunk CHUNK_FACEVERTEXSTART, TVOChunkTable(), tff
        Put #tff, , .VertexOffset
        
        AddChunk CHUNK_ENDFACE, TVOChunkTable(), tff
        End With
      Next i
      
      AddChunk CHUNK_ENDMESH, TVOChunkTable(), tff
      
      'TODO :Write the texture table
      If SaveTexDesc = True Then
        AddChunk CHUNK_NBTEXTURE, TVOChunkTable(), tff
        Put #tff, , NTex
        AddChunk CHUNK_TEXTURE, TVOChunkTable(), tff
        'Write the texture table
        ReDim TexTable(NTex)
        
        For o = 1 To NTex
         TexTable(o).Filename = Textures(t(o)).TextureFileName
         TexTable(o).TextureName = Textures(t(o)).TextureName
         TexTable(o).width = Textures(t(o)).TextureWidth
         TexTable(o).height = Textures(t(o)).TextureHeight
        Next o
        
        'Put it in the file
        Put #tff, , TexTable
      End If
   End If
End Function
Sub CloseTVO()
     AddLog "TVO FILE : Close the TVO file"
  
  If TVOWrite = True Then
    'Close the file with a blank chunk
    AddChunk 0, TVOChunkTable, tff
    
    'Write the TVO Chunk Table to the end of file
    TVOTableOffset = Seek(tff)
    Put #tff, , TVOChunkTable
    
    'Finally write the table offset that starts the file
    Put #tff, 5, TVOTableOffset
    
    TVOWrite = False
  End If
  
  Close #tff
End Sub

Function GetChunkDesc(ChunkIndex As Integer, ByRef ChunkType As Integer, ByRef ChunkLength As Long, ByRef ChunkOffset As Long)
  If ChunkIndex <= TVONbChunk Then
    ChunkType = TVOChunkTable(ChunkIndex).ChunkType
    ChunkOffset = TVOChunkTable(ChunkIndex).ChunkOffset
    ChunkLength = TVOChunkTable(ChunkIndex).ChunkLength
  End If
End Function
Function GetChunkNameFromID(ChunkType As Integer) As String
   InitChunkString
   GetChunkNameFromID = ChunkString(ChunkType)
   
End Function


Function GetChunkNumber() As Integer
   GetChunkNumber = TVONbChunk
End Function
Function LoadLandscape() As Landscape8
  Dim Hm() As Single
  Dim Indices() As Integer
  Dim x As Long, z As Long, V As Long
  Dim width As Long, height As Long
  Dim LA As LandscapeType, Landscape As Boolean
  Dim ActualTerrain As Long
If TVORead = True Then
  For i = 1 To TVONbChunk - 1
    Seek #tff, TVOChunkTable(i).ChunkOffset
    Select Case TVOChunkTable(i).ChunkType
    
       Case CHUNK_LANDSCAPE
        Landscape = True
       Case CHUNK_LANDFEATURES1
        If Landscape = True Then
          Get #tff, , LA.NbTerrain
          ReDim Preserve LA.Terrain(LA.NbTerrain)
        End If
       Case CHUNK_TERRAIN
        If Landscape = True Then
          ActualTerrain = ActualTerrain + 1
           LA.NbTerrain = ActualTerrain
           ReDim Preserve LA.Terrain(LA.NbTerrain)
           
        End If
       Case CHUNK_TERRAINFEATURES2
        If Landscape = True Then
          Get #tff, , LA.Terrain(ActualTerrain).Sphere
          Get #tff, , LA.Terrain(ActualTerrain).Radius
        End If
       Case CHUNK_TERRAINFEATURES
         If Landscape = True Then
          Get #tff, , LA.Terrain(ActualTerrain).Position
          Get #tff, , LA.Terrain(ActualTerrain).width
          Get #tff, , LA.Terrain(ActualTerrain).height
          Get #tff, , LA.Terrain(ActualTerrain).Precision
          Get #tff, , LA.Terrain(ActualTerrain).TextureI
          Get #tff, , LA.Terrain(ActualTerrain).MaterialI
          Get #tff, , LA.Terrain(ActualTerrain).LightmapI
         End If
       Case CHUNK_TERRAINHEIGHTMAP
        If Landscape = True Then
          Precision = LA.Terrain(ActualTerrain).Precision
          ReDim Preserve Hm(LA.Terrain(ActualTerrain).width * LA.Terrain(ActualTerrain).height)
          
          Get #tff, , Hm()
          With LA.Terrain(ActualTerrain)
          
          ReDim Preserve .Vertex(.width * .height)
          For y = 0 To .height - 1
             For x = 0 To .width - 1
              V = y * .width + x
              .Vertex(V).x = x * Precision
              .Vertex(V).z = y * Precision
              .Vertex(V).y = Hm(V)
              .Vertex(V).ny = 1
              .Vertex(V).tu1 = x / .width
              .Vertex(V).tv1 = y / .height
              .Vertex(V).tu2 = .Vertex(V).tu2
              .Vertex(V).tv2 = .Vertex(V).tv2
           Next x
         Next y
         Nind = (.width * .height) * 6#
         ReDim Indices(Nind) As Integer
         Ind = 0
         
         
         For y = 0 To .height - 2
            For x = 0 To .width - 2
      
              V = y * .width + x
              If .Vertex(V).y <> -1 And .Vertex(V + 1).y <> -1 And .Vertex(V + .width).y <> -1 And .Vertex(V + .width + 1).y <> -1 Then
                Indices(Ind) = V
                Indices(Ind + 1) = V + 1
                Indices(Ind + 2) = V + .width
                Indices(Ind + 5) = V + 1
                Indices(Ind + 4) = V + .width
                Indices(Ind + 3) = V + .width + 1
                Ind = Ind + 6
               End If
         Next x
       Next y
   
            .NIndices = Ind
            .NVertex = .width * .height

            Set .Mesh = D3DX.CreateMeshFVF(.NVertex * 2, .NVertex, 0, TV_VERTEX2, Device)
            D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, .NVertex * 40#, 0, .Vertex(0)
            D3DIndexBuffer8SetData .Mesh.GetIndexBuffer, 0, .NIndices * 2#, 0, Indices(0)
            D3DXMatrixIdentity .Matrix
            D3DXMatrixTranslation .Matrix, .Position.x, .Position.y, .Position.z
      End With
    End If
   End Select
  Next i
  Set LoadLandscape = New Landscape8
  LA.LandscapeMode = 1
  LA.TexUsedNumber = 0
  
  LoadLandscape.SetDesc LA
     
End If
End Function

Function LoadMesh(MeshName As String) As Mesh8
  Set LoadMesh = LocalScene.CreateMeshBuilder(MeshName)
  Dim MI As Integer
  MI = LoadMesh.GetMeshIndex
    Dim Rotation As D3DVECTOR, Position As D3DVECTOR, Scaling As D3DVECTOR
   Dim MeshStart As Boolean, NbVertex As Long
   Dim TMeshName As String * 32
   Dim Face As Integer, NTex As Integer
   Face = 0
   With Mesh(MI)
   
   For i = 1 To TVONbChunk - 1
     
     Seek #tff, TVOChunkTable(i).ChunkOffset
    
     Select Case TVOChunkTable(i).ChunkType
       Case CHUNK_VERSION
         Get #tff, , version
       Case CHUNK_MESH
          MeshStart = True
       Case CHUNK_ENDMESH
          MeshStart = False
       Case CHUNK_MESHNAME, CHUNK_GENERALNAME
         Get #tff, , TMeshName
         If TMeshName <> "" And InStr(UCase$(TMeshName), UCase$(MeshName)) > 0 Then
           goodmesh = True
           .MeshName = TMeshName
         End If
     End Select
    If goodmesh = True And MeshStart = True Then
     Select Case TVOChunkTable(i).ChunkType
       Case CHUNK_FEATURES
         Get #tff, , .Features.Settings.Position
         Get #tff, , .Features.Settings.Rotation
         Get #tff, , .Features.Settings.Scaling
       Case CHUNK_NBVERTEX
          Get #tff, , NbVertex
           .Features.NbVertex = NbVertex
       Case CHUNK_VERTEX
         If NbVertex <> 0 And MeshStart = True Then
           ReDim Preserve .Features.Vertex(NbVertex)
           Get #tff, , .Features.Vertex
         End If
         
       Case CHUNK_LVERTEX
         If NbVertex <> 0 And MeshStart = True Then
           ReDim Preserve .Features.LVertex(NbVertex)
           Get #tff, , .Features.LVertex
           .Features.TypeVertex = TV_COLOR_VERTEX
         End If
         
       Case CHUNK_PRIMITIVETYPE
         Get #tff, , .Features.PrimType
       Case CHUNK_BILLBOARD
          .Features.Settings.Billboard = True
       Case CHUNK_SPRITE
          .Features.Settings.SPREnabled = True
       Case CHUNK_NBFACE
          Get #tff, , .Features.NumGroup
          ReDim .Features.Groups(.Features.NumGroup)
          .Object.SetGroupPointer .Features.NumGroup
       
       Case CHUNK_FACE
          Face = Face + 1
          
          'Face stuff
          Case CHUNK_FACEVERTEXSTART
           Get #tff, , .Features.Groups(Face).VertexOffset
          Case CHUNK_FACELIGHTMAP
           Get #tff, , .Features.Groups(Face).LightmapI
          Case CHUNK_FACEVERTEXNUMBER
           Get #tff, , .Features.Groups(Face).IndicesCount
          Case CHUNK_FACETEXTURE
           Get #tff, , .Features.Groups(Face).TextureI
          Case CHUNK_FACEMATERIAL
           Get #tff, , .Features.Groups(Face).MaterialI
          Case CHUNK_ALPHABLENDING
           Get #tff, , .Features.Groups(Face).AlphaBlending
          Case CHUNK_SPHEREMAPPING
           Get #tff, , .Features.Groups(Face).ShpereMapping
       Case CHUNK_ENDFACE
       
       Case CHUNK_ENDMESH
         MeshStart = False
         If goodmesh = True Then
           Exit For
         End If
         
       Case CHUNK_NBTEXTURE
           Get #tff, , NTex
       Case CHUNK_TEXTURE
           If NTex > 0 Then
             Dim TF As New TextureFactory8
             For z = 1 To NTex
               
             Next z
           End If
     End Select
     End If
   Next i
 End With

End Function
Function LoadParticleSystem(ParticleName As String) As ParticleSystem8
    If TVORead = True Then
      Set LoadParticleSystem = New ParticleSystem8
      For i = 1 To TVONbChunk
        LoadParticleSystem.LoadFromFile tff
      Next i
    End If
End Function

Sub LoadScript(ScriptName)

End Sub
'---------------
'  24/12/00
'-----------------
'

Sub LoadTextureFactory()

End Sub

Sub OpenTVO(file As String, Optional ForRead As Boolean = True)
  tff = FreeFile
  
  Open file For Binary As tff
  
 TVORead = ForRead
 TVOWrite = Not ForRead
 
 If TVORead = True Then
    AddLog "TVO FILE : Open TVO file for reading"
    'Check if this is a true TVO file !
    Dim magic As String * 4
    Get #tff, , magic
    If magic <> "TVOF" Then
      AddLog "TVO MANAGER : " + CStr(file) + " isn't a TVO file ( Header TVOF can't be found ) "
      Exit Sub
    End If
    
   'Read the chunk table
   Get #tff, , TVOTableOffset
   Seek #tff, TVOTableOffset
   TVONbChunk = (LOF(tff) - TVOTableOffset) / 10
   ReDim Preserve TVOChunkTable(TVONbChunk)
   Get #tff, TVOTableOffset, TVOChunkTable
 Else
    AddLog "TVO FILE : Open TVO file for writing"

   TVONbChunk = 0
   ReDim Preserve TVOChunkTable(0)
   Put #tff, , "TVOF"
   Put #tff, , TVOTableOffset 'we will fill it later !
   Dim version As Long
   version = CHUNK_VERSION_TV
   
   AddChunk CHUNK_VERSION, TVOChunkTable(), tff
   Put #tff, , version
 End If
 
End Sub

Sub SaveTextureFactory(Optional CopyTextureMemoryToo As Boolean = False)

End Sub


Private Sub Class_Terminate()
  'Check if the TVO has been "tabled"
  CloseTVO
End Sub


