VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GameController8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"Effects"
'##CD Represents a Game Controller on a users machine.
Option Explicit

Public Key As String

Event Change(JoyState As TV_JOYSTATE, JoyStateAdvanced As TV_JOYSTATE2)
'##ED Fires when a change in the controller happens. For example when the user presses a button or the direction pad.

Event Initialized()
'##ED Fires when the controller is initialized.

Event OnError(ErrNum As Long, ErrDescription As String, ErrLocation As String)
'##ED Fires when an error occurs.
'##PD ErrNum Error number.
'##PD ErrDescription Error Description.
'##PD ErrLocation Location (Class and Method/Property) the error occured in.

Event UnInitialized()
'##ED Fires when the controller is un-initialized.

Public Enum CONST_TV_JOYSTICK_DATAFORMAT
'##EN Data format.
    eDIJoyStick1 = 3
    '##EM eDIJoyStick1 Joystick whose state data can be received in a DIJOYSTATE type.
    eDIJoyStick2 = 4
    '##EM eDIJoyStick2 Joystick with extended capabilities whose state data can be received in a DIJOYSTATE2 type.
End Enum

Public Enum CONST_TV_EFFECT_TYPE
'##EN Describe types and capabilities of force-feedback effects. They are used to restrict effect enumeration in the DirectInputDevice.GetEffectsEnum method to one or more of the primary types.
    tv_ALL = 0
    '##EM tv_ALL All effects are to be enumerated.
    tv_CONDITION = 4
    '##EM tv_CONDITION The effect is a condition, or conditions are to be enumerated.
    tv_CONSTANTFORCE = 1
    '##EM tv_CONSTANTFORCE The effect is a constant force, or constant forces are to be enumerated.
    tv_CUSTOMFORCE = 5
    '##EM tv_CUSTOMFORCE The effect is a custom force, or custom forces are to be enumerated.
    tv_HARDWARE = 255
    '##EM tv_HARDWARE The effect is specific to the hardware, or hardware effects are to be enumerated.
    tv_PERIODIC = 3
    '##EM tv_PERIODIC The effect is periodic, or periodic effects are to be enumerated.
    tv_RAMPFORCE = 2
    '##EM tv_RAMPFORCE The effect is a ramp force, or ramp forces are to be enumerated.
End Enum

Public Type TV_JOYSTATE
'##UT Joystick state.
    x As Long
    '##UM x X coordinate.
    y As Long
    '##UM y X coordinate.
    z As Long
    '##UM z X coordinate.
    RotationX As Long 'rx
    RotationY As Long 'ry
    RotationZ As Long 'rz
    Slider0 As Long 'slider(0)
    Slider1 As Long 'slider(1)
    PointOfView0 As Long 'pov(0)
    PointOfView1 As Long 'pov(1)
    PointOfView2 As Long 'pov(2)
    PointOfView3 As Long 'pov(3)
    Buttons(0 To 31) As Byte
    '##UM Buttons Array of 32 possible buttons the user can press.
End Type

Public Type TV_JOYSTATE2
'##UT Advanced Joystick state.
    x As Long
    '##UM x X coordinate.
    y As Long
    '##UM y X coordinate.
    z As Long
    '##UM z X coordinate.
    RotationX As Long 'rx
    RotationY As Long 'ry
    RotationZ As Long 'rz
    Slider0 As Long 'slider(0)
    Slider1 As Long 'slider(1)
    PointOfView0 As Long 'pov(0)
    PointOfView1 As Long 'pov(1)
    PointOfView2 As Long 'pov(2)
    PointOfView3 As Long 'pov(3)
    Buttons(0 To 31) As Byte
    '##UM Buttons Array of 32 possible buttons the user can press.
    TorqueX As Long 'frx
    TorqueY As Long 'fry
    TorqueZ As Long 'frz
    ForceX As Long 'fX
    ForceY As Long 'fY
    ForceZ As Long 'fZ
    AngularVelocityX As Long 'vrX
    AngularVelocityY As Long 'vrY
    AngularVelocityZ As Long 'vrZ
    vx As Long
    vy As Long
    vz As Long
    vslider0 As Long
    vslider1 As Long
    fslider0 As Long
    fslider1 As Long
    ax As Long
    ay As Long
    az As Long
    arx As Long
    ary As Long
    arz As Long
    aslider0 As Long
    aslider1 As Long
End Type

Private DIDeviceJoystick As DirectInputDevice8
Private DiProp_Dead As DIPROPLONG
Private DiProp_Range As DIPROPRANGE
Private DiProp_Saturation As DIPROPLONG
Private Axis(1 To 8) As Boolean
Private lEvent As Long

'local variable(s) to hold property value(s)
Private mvarControllerType As Long
Private mvarFFDriver As String
Private mvarGuidInstance As String
Private mvarGuidProduct As String
Private mvarInstanceName As String
Private mvarProductName As String
Private mvarUsage As Integer
Private mvarUsagePage As Integer
Private mvarCapabilities As DIDEVCAPS
Private mvarDataFormat As CONST_TV_JOYSTICK_DATAFORMAT
Private mvarControllerState As DIJOYSTATE
Private mvarControllerStateAdvanced As DIJOYSTATE2
Private mvarEffects As ForceFeedEffects8
Private mvarInUse As Boolean

Public Function ConvertDIStateToTVState(TVJState As DIJOYSTATE) As TV_JOYSTATE
'##BD Returns the DirectInput state to a TV Joystick state.
    Dim i As Long
    
    'Fill our State type with the values of the DirectInputState type.
    'With TVJState
    '    For i = 0 To 31
    '        ConvertDIStateToTVState.Buttons(i) = .Buttons(i) 'Buttons
    '    Next i
    '    ConvertDIStateToTVState.PointOfView0 .PointOfView0
    '    ConvertDIStateToTVState.PointOfView1 = .PointOfView1
    '    ConvertDIStateToTVState.PointOfView2 = .PointOfView2
    '    ConvertDIStateToTVState.PointOfView3 = .PointOfView3
    '    ConvertDIStateToTVState.RotationX = .RotationX
    '    ConvertDIStateToTVState.RotationY = .RotationY
    '    ConvertDIStateToTVState.RotationZ.RotationZ
    '    ConvertDIStateToTVState.Slider0.Slider0
    '    ConvertDIStateToTVState.Slider1 = .Slider1
    '    ConvertDIStateToTVState.x = .x
    '    ConvertDIStateToTVState.y = .y
    '    ConvertDIStateToTVState.z = .z
    'End With
End Function


Public Function CreateForceFeedEffect(EffectGuid As String, EffectInfo As DIEFFECT) As DirectInputEffect
'##BD creates a force-feedback effect. If the device is currently acquired at the exclusive cooperative level, the effect is also downloaded.

'##PD EffectGuid String representation of a GUID for an effect recognized by the hardware driver, or one of the following aliases for standard effects: <i>(GUID_ConstantForce, GUID_RampForce, GUID_Square, GUID_Sine, GUID_Triangle, GUID_SawtoothUp, GUID_SawtoothDown, GUID_Spring, GUID_Damper, GUID_Inertia, GUID_Friction)</i>
'##PD EffectInfo DIEFFECT structure containing the parameters for the effect.

    On Error GoTo Handler
    
    If DIDeviceJoystick Is Nothing Then Exit Function
    
    Set CreateForceFeedEffect = DIDeviceJoystick.CreateEffect(EffectGuid, EffectInfo)
    Exit Function
    
Handler:
    RaiseEvent OnError(Err.Number, Err.Description, "CreateForceFeedEffect")
End Function

Friend Function GetEventID() As Long
    GetEventID = lEvent
End Function

Public Function GetForceFeedbackState() As CONST_DIGFFSFLAGS
'##BD Retrieves the state of the device's force-feedback system.
    On Error GoTo Handler
    
    If DIDeviceJoystick Is Nothing Then Exit Function
    
    GetForceFeedbackState = DIDeviceJoystick.GetForceFeedbackState
    Exit Function
    
Handler:
    GetForceFeedbackState = Err.Number
    RaiseEvent OnError(Err.Number, Err.Description, "GetForceFeedbackState")
End Function

Public Function CreateCustomForceFeedEffect(EffectInfo As DIEFFECT, Channels As Long, SamplePeriod As Long, _
                                                                    nSamples As Long, SampleData() As Long) As DirectInputEffect
'##BD Creates a force-feedback effect consisting of a series of constant forces of fixed duration.

'##PD EffectInfo Type of effect.
'##PD Channels The number of channels (axes) affected by this force. Must be 1 or 2.
'##PD SamplePeriod The sample period in microseconds
'##PD nSamples Number of elements in the sampledata array.
'##PD SampleData Array of magnitudes.
    On Error GoTo Handler
    
    If DIDeviceJoystick Is Nothing Then Exit Function
    
    Set CreateCustomForceFeedEffect = DIDeviceJoystick.CreateCustomEffect(EffectInfo, Channels, SamplePeriod, nSamples, SampleData)
    Exit Function
    
Handler:
    RaiseEvent OnError(Err.Number, Err.Description, "CreateCustomForceFeedEffect")
End Function

Public Function SendForceFeedbackCommand(Flags As CONST_DISFFCFLAGS) As Long
'##BD Sends a command to the device's force-feedback system.
    On Error GoTo Handler
    
    If DIDeviceJoystick Is Nothing Then Exit Function
    
    Call DIDeviceJoystick.SendForceFeedbackCommand(Flags)
    SendForceFeedbackCommand = 0
    Exit Function
    
Handler:
    SendForceFeedbackCommand = Err.Number
    RaiseEvent OnError(Err.Number, Err.Description, "SendForceFeedbackCommand")
End Function

'Public Property Get Effects() As Effects
''##BD Returns the Collection of Effect objects that represent ForceFeedBack effects attached to this Controller.
'    Set Effects = mvarEffects
'End Property

'    Call DIDeviceJoystick.GetDeviceStateJoystick(mvarControllerState) '' Get the device info
'    If (Err.Number = DIERR_NOTACQUIRED) Or (Err.Number = DIERR_INPUTLOST) Then 'Re-Acquire if needed
'        Call DIDeviceJoystick.Acquire
'        Exit Sub
'    End If

Public Property Get ControllerState() As TV_JOYSTATE
'##BD Returns the state of the controller.
    Dim JState As TV_JOYSTATE, i As Long
    'Fill our State type with the values of the DirectInputState type.
    With JState
        For i = 0 To 31
            .Buttons(i) = mvarControllerState.Buttons(i) 'Buttons
        Next i
        .PointOfView0 = mvarControllerState.POV(0)
        .PointOfView1 = mvarControllerState.POV(1)
        .PointOfView2 = mvarControllerState.POV(2)
        .PointOfView3 = mvarControllerState.POV(3)
        .RotationX = mvarControllerState.rx
        .RotationY = mvarControllerState.ry
        .RotationZ = mvarControllerState.rz
        .Slider0 = mvarControllerState.slider(0)
        .Slider1 = mvarControllerState.slider(1)
        .x = mvarControllerState.x
        .y = mvarControllerState.y
        .z = mvarControllerState.z
    End With
    ControllerState = JState
End Property

Public Property Get ControllerStateAdvanced() As TV_JOYSTATE2
'##BD Returns the state of the controller using an advanced joy state type.
    Dim JState As TV_JOYSTATE2, i
    'Fill our State type with the values of the DirectInputState type.
    With JState
        For i = 0 To 31
            .Buttons(i) = mvarControllerStateAdvanced.Buttons(i) 'Buttons
        Next i
        .PointOfView0 = mvarControllerStateAdvanced.POV(0)
        .PointOfView1 = mvarControllerStateAdvanced.POV(1)
        .PointOfView2 = mvarControllerStateAdvanced.POV(2)
        .PointOfView3 = mvarControllerStateAdvanced.POV(3)
        .RotationX = mvarControllerStateAdvanced.rx
        .RotationY = mvarControllerStateAdvanced.ry
        .RotationZ = mvarControllerStateAdvanced.rz
        .Slider0 = mvarControllerStateAdvanced.slider(0)
        .Slider1 = mvarControllerStateAdvanced.slider(1)
        .x = mvarControllerStateAdvanced.x
        .y = mvarControllerStateAdvanced.y
        .z = mvarControllerStateAdvanced.z
        .TorqueX = mvarControllerStateAdvanced.frx 'frx
        .TorqueY = mvarControllerStateAdvanced.fry 'fry
        .TorqueZ = mvarControllerStateAdvanced.frz 'frz
        .ForceX = mvarControllerStateAdvanced.fx 'fX
        .ForceY = mvarControllerStateAdvanced.fy 'fY
        .ForceZ = mvarControllerStateAdvanced.fz 'fZ
        .AngularVelocityX = mvarControllerStateAdvanced.vrx 'vrX
        .AngularVelocityY = mvarControllerStateAdvanced.vry 'vrY
        .AngularVelocityZ = mvarControllerStateAdvanced.vrz 'vrZ
        .vx = mvarControllerStateAdvanced.vx
        .vy = mvarControllerStateAdvanced.vy
        .vz = mvarControllerStateAdvanced.vz
        .vslider0 = mvarControllerStateAdvanced.vslider(0)
        .vslider1 = mvarControllerStateAdvanced.vslider(1)
        .fslider0 = mvarControllerStateAdvanced.fslider(0)
        .fslider1 = mvarControllerStateAdvanced.fslider(1)
        .ax = mvarControllerStateAdvanced.ax
        .ay = mvarControllerStateAdvanced.ay
        .az = mvarControllerStateAdvanced.az
        .arx = mvarControllerStateAdvanced.arx
        .ary = mvarControllerStateAdvanced.ary
        .arz = mvarControllerStateAdvanced.arz
        .aslider0 = mvarControllerStateAdvanced.aslider(0)
        .aslider1 = mvarControllerStateAdvanced.aslider(1)
    End With
    ControllerStateAdvanced = JState
End Property
Public Property Let DataFormat(ByVal vData As CONST_TV_JOYSTICK_DATAFORMAT)
    mvarDataFormat = vData
End Property

Public Property Get DataFormat() As CONST_TV_JOYSTICK_DATAFORMAT
'##BD Returns or sets the data format the controller is to use.
    DataFormat = mvarDataFormat
End Property

Public Property Get Capabilities() As DIDEVCAPS
'##BD Returns the capabilities of the controller.
    If DIDeviceJoystick Is Nothing Then Exit Property
    
    Call DIDeviceJoystick.GetCapabilities(mvarCapabilities) 'Get the capibilities if we are using the joystick.
    Capabilities = mvarCapabilities
End Property

Friend Sub FireChangeEvent()
    Dim JState As TV_JOYSTATE, i As Long
    Dim JState2 As TV_JOYSTATE2
    On Local Error Resume Next
    
    If DIDeviceJoystick Is Nothing Then Exit Sub 'User is not actually using this controller device yet so we exit.
    
    Call DIDeviceJoystick.GetDeviceStateJoystick(mvarControllerState) '' Get the device info
    Call DIDeviceJoystick.GetDeviceStateJoystick2(mvarControllerStateAdvanced) 'Get the device info extended
    If (Err.Number = DIERR_NOTACQUIRED) Or (Err.Number = DIERR_INPUTLOST) Then 'Re-Acquire if needed
        Call DIDeviceJoystick.Acquire
        Exit Sub
    End If
    
    'Fill our State type with the values of the DirectInputState type.
    With JState
        For i = 0 To 31
            .Buttons(i) = mvarControllerState.Buttons(i) 'Buttons
        Next i
        .PointOfView0 = mvarControllerState.POV(0)
        .PointOfView1 = mvarControllerState.POV(1)
        .PointOfView2 = mvarControllerState.POV(2)
        .PointOfView3 = mvarControllerState.POV(3)
        .RotationX = mvarControllerState.rx
        .RotationY = mvarControllerState.ry
        .RotationZ = mvarControllerState.rz
        .Slider0 = mvarControllerState.slider(0)
        .Slider1 = mvarControllerState.slider(1)
        .x = mvarControllerState.x
        .y = mvarControllerState.y
        .z = mvarControllerState.z
    End With
    
    'Fill our State type with the values of the DirectInputState type.
    With JState2
        For i = 0 To 31
            .Buttons(i) = mvarControllerStateAdvanced.Buttons(i) 'Buttons
        Next i
        .PointOfView0 = mvarControllerStateAdvanced.POV(0)
        .PointOfView1 = mvarControllerStateAdvanced.POV(1)
        .PointOfView2 = mvarControllerStateAdvanced.POV(2)
        .PointOfView3 = mvarControllerStateAdvanced.POV(3)
        .RotationX = mvarControllerStateAdvanced.rx
        .RotationY = mvarControllerStateAdvanced.ry
        .RotationZ = mvarControllerStateAdvanced.rz
        .Slider0 = mvarControllerStateAdvanced.slider(0)
        .Slider1 = mvarControllerStateAdvanced.slider(1)
        .x = mvarControllerStateAdvanced.x
        .y = mvarControllerStateAdvanced.y
        .z = mvarControllerStateAdvanced.z
        .TorqueX = mvarControllerStateAdvanced.frx 'frx
        .TorqueY = mvarControllerStateAdvanced.fry 'fry
        .TorqueZ = mvarControllerStateAdvanced.frz 'frz
        .ForceX = mvarControllerStateAdvanced.fx 'fX
        .ForceY = mvarControllerStateAdvanced.fy 'fY
        .ForceZ = mvarControllerStateAdvanced.fz 'fZ
        .AngularVelocityX = mvarControllerStateAdvanced.vrx 'vrX
        .AngularVelocityY = mvarControllerStateAdvanced.vry 'vrY
        .AngularVelocityZ = mvarControllerStateAdvanced.vrz 'vrZ
        .vx = mvarControllerStateAdvanced.vx
        .vy = mvarControllerStateAdvanced.vy
        .vz = mvarControllerStateAdvanced.vz
        .vslider0 = mvarControllerStateAdvanced.vslider(0)
        .vslider1 = mvarControllerStateAdvanced.vslider(1)
        .fslider0 = mvarControllerStateAdvanced.fslider(0)
        .fslider1 = mvarControllerStateAdvanced.fslider(1)
        .ax = mvarControllerStateAdvanced.ax
        .ay = mvarControllerStateAdvanced.ay
        .az = mvarControllerStateAdvanced.az
        .arx = mvarControllerStateAdvanced.arx
        .ary = mvarControllerStateAdvanced.ary
        .arz = mvarControllerStateAdvanced.arz
        .aslider0 = mvarControllerStateAdvanced.aslider(0)
        .aslider1 = mvarControllerStateAdvanced.aslider(1)
    End With
    
    RaiseEvent Change(JState, JState2)
    Exit Sub
    
'Handler:
'    If Err = DIERR_INPUTLOST Then
'        Debug.Print "Joystick Lost"
'    ElseIf Err = DIERR_INVALIDPARAM Then
'        Debug.Print "Invalid Paramater"
'    ElseIf Err = DIERR_NOTACQUIRED Then
'        Debug.Print "Joystick Not Acquired"
'    ElseIf Err = E_PENDING Then
'        Debug.Print "Pending or not able to get it yet."
'    End If
End Sub

Public Function GetAxis() As Variant
'##BD Returns a array of available axis on the controller.
    GetAxis = Axis
End Function

Public Function GetButtonCount() As Long
'##BD Returns the number of buttons located on the controller.
    If DIDeviceJoystick Is Nothing Then Exit Function
    
    GetButtonCount = mvarCapabilities.lButtons
End Function


Public Sub Poll()
'##BD Refreshes the data on the controller. Call this method before grabbing the state.
    On Error Resume Next
    
    If DIDeviceJoystick Is Nothing Then Exit Sub
    
    DoEvents
    Call DIDeviceJoystick.Poll
End Sub

Public Sub RefreshForceFeedEffects(Optional ByVal eEffectType As CONST_TV_EFFECT_TYPE = tv_ALL)
'##BD Reloads all the force feed effects attached to the controller and places them in the ForceFeedEffects8 collection.
    Dim EffectEnum As DirectInputEnumEffects
    Dim Effect As ForceFeedEffect8, i As Long
    
    If DIDeviceJoystick Is Nothing Then Exit Sub
    
    Call mvarEffects.Clear 'Clear all ForceFeedEffect8 objects from collection
    
    'Enumerate force feed effects and add them to the collection.
    Set EffectEnum = DIDeviceJoystick.GetEffectsEnum(eEffectType)
    If EffectEnum Is Nothing Then Exit Sub
    With EffectEnum
        For i = 1 To EffectEnum.GetCount
            Set Effect = mvarEffects.Add(.GetEffectGuid(i), .GetDynamicParams(i), .GetEffectGuid(i), .GetName(i), .GetStaticParams(i), .GetType(i), _
                                                                 .GetEffectGuid(i))
        Next
    End With
    
    Call mvarEffects.SetEffectsEnumObject(EffectEnum) 'Set the enumeration effects object we just created so we can reference it again.
    
    Set Effect = Nothing
    Set EffectEnum = Nothing
End Sub

Friend Sub SetProperties(ByVal lType As Long, ByVal GuidIn As String, ByVal GuidProd As String, ByVal FFDri As String, _
                                        ByVal InstName As String, ByVal ProdName As String, ByVal Usage As Integer, ByVal UsagePage As Integer)
    mvarControllerType = lType
    mvarFFDriver = FFDri
    mvarGuidInstance = GuidIn
    mvarGuidProduct = GuidProd
    mvarInstanceName = InstName
    mvarProductName = ProdName
    mvarUsage = Usage
    mvarUsagePage = UsagePage
End Sub

Public Sub UnloadController()
'##BD Clears all objects from memory used by this class and unacquires the controller. Call this method before setting this class to nothing.
    On Error Resume Next
    If lEvent <> 0 Then Call DIDeviceJoystick.SetEventNotification(0)
    
    Call DIDeviceJoystick.Unacquire 'Unacquire the controller.
    Set DIDeviceJoystick = Nothing 'Free memory
    Set mvarEffects = Nothing 'Free memory
    
    RaiseEvent UnInitialized
End Sub

Public Property Get UsagePage() As Integer
'##BD Retrieves the usage page for Human Interface Devices.
    
    UsagePage = mvarUsagePage
End Property

Public Property Get Usage() As Integer
'##BD Retrieves the usage code for Human Interface Devices.
    Usage = mvarUsage
End Property

Public Property Get ProductName() As String
Attribute ProductName.VB_UserMemId = 0
'##BD Retrieves the product name of the device.
    
    ProductName = mvarProductName
End Property

Public Property Get InstanceName() As String
'##BD Retrieves the name of the device instance.
    
    InstanceName = mvarInstanceName
End Property

Public Property Get GuidProduct() As String
'##BD Retrieves the manufacturer's unique identifier for the device.
   
    GuidProduct = mvarGuidProduct
End Property

Public Property Get GuidInstance() As String
'##BD Returns the unique identifier for the instance of the device.

    GuidInstance = mvarGuidInstance
End Property

Public Property Get FFDriver() As String
'##BD unique identifier for the force-feedback driver.
    FFDriver = mvarFFDriver
End Property

Public Property Get ControllerType() As Long
'##BD Retrieves the device type and subtype
    ControllerType = mvarControllerType
End Property

Private Sub IdentifyAxes(diDev As DirectInputDevice8)
   'It's not enough to count axes; we need to know which in particular
   'are present.
   Dim didoEnum As DirectInputEnumDeviceObjects
   Dim dido As DirectInputDeviceObjectInstance
   Dim i As Integer
   
   For i = 1 To 8
     Axis(i) = False
   Next
   
   'Enumerate the axes
   Set didoEnum = diDev.GetDeviceObjectsEnum(DIDFT_AXIS)
   
   'Check data offset of each axis to learn what it is
    For i = 1 To didoEnum.GetCount
        Set dido = didoEnum.GetItem(i)
         Select Case dido.GetOfs
            Case DIJOFS_X
              Axis(1) = True
            Case DIJOFS_Y
              Axis(2) = True
            Case DIJOFS_Z
              Axis(3) = True
            Case DIJOFS_RX
              Axis(4) = True
            Case DIJOFS_RY
              Axis(5) = True
            Case DIJOFS_RZ
              Axis(6) = True
            Case DIJOFS_SLIDER0
              Axis(7) = True
            Case DIJOFS_SLIDER1
              Axis(8) = True
         End Select
    Next
End Sub

Public Function IsConnected() As Boolean
'##BD Returns if the controller is connected or not. Remember the controller only has to be installed on the machine for DirectInput to see it, so checking this property is important for the controller may not be connected at the time you wish to use it.
    If DInput Is Nothing Then Exit Function
    
    IsConnected = DInput.GetDeviceStatus(mvarGuidProduct)
End Function

Public Sub Initialize()
'##BD initializes the GameController8 and readies it for use. This method will set the InUse property to True if no errors occurred and the controller was acquired.

'##PD CoOpLevel Cooperative level.
    Dim JoyCaps As DIDEVCAPS
    On Error GoTo Handler
       
    'cre le priphrique d'acquisition dikey comme tant un clavier
    Set DIDeviceJoystick = DInput.CreateDevice(mvarGuidProduct) 'create the device using the guid from the property
    
    'initialise le clavier
    Call DIDeviceJoystick.SetCommonDataFormat(mvarDataFormat) 'Get data format from the property
    
    JoyCaps = Capabilities 'Make the property refresh the capabilities.
    Call IdentifyAxes(DIDeviceJoystick) 'Identify the axes on the controller.
    
    lEvent = DirectX.CreateEvent(IntForm)
    Call DIDeviceJoystick.SetEventNotification(lEvent) ' Ask for notification of events
    
    With DiProp_Dead
        .lData = 1000
        .lObj = DIJOFS_X
        '.lSize = Len(DiProp_Dead)
        .lHow = DIPH_BYOFFSET
        .lObj = DIJOFS_X
        Call DIDeviceJoystick.SetProperty("DIPROP_DEADZONE", DiProp_Dead)
        .lObj = DIJOFS_Y
        Call DIDeviceJoystick.SetProperty("DIPROP_DEADZONE", DiProp_Dead)
    End With
    ' Set saturation zones for X and Y axis to 5 percent of the range
    With DiProp_Saturation
        .lData = 9500
        .lHow = DIPH_BYOFFSET
        '.lSize = Len(DiProp_Saturation)
        .lObj = DIJOFS_X
         Call DIDeviceJoystick.SetProperty("DIPROP_SATURATION", DiProp_Saturation)
        .lObj = DIJOFS_Y
         Call DIDeviceJoystick.SetProperty("DIPROP_SATURATION", DiProp_Saturation)
    End With
    ' Set range for all axes
    With DiProp_Range
        .lHow = DIPH_DEVICE
        '.lSize = Len(DiProp_Range)
        .lMin = 0
        .lMax = 10000
        Call DIDeviceJoystick.SetProperty("DIPROP_RANGE", DiProp_Range)
    End With
    
    'dclenche l'acquisition du clavier
    Call DIDeviceJoystick.Acquire 'Acquire the controller.
    Call IntForm.ForceCallBack 'Fake a event call
    
    Call RefreshForceFeedEffects  'Grab the force feedback effects
    mvarInUse = True
    RaiseEvent Initialized
    Exit Sub
    
Handler:
    If Err = -2147024894 Then
        Resume Next
    Else
        Debug.Print "Joystick not acquired."
    End If
    mvarInUse = False
    RaiseEvent OnError(Err.Number, Err.Description, "Initialize Method")
End Sub

Private Sub Class_Initialize()
    'Setup the effects collection.
    AddLog "5d"
    Set mvarEffects = New ForceFeedEffects8
    Set mvarEffects.Parent = Me
    mvarDataFormat = eDIJoyStick1
   AddLog "6c"
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    
    Call UnloadController
End Sub



Public Property Get DirectInputDevice() As DirectInputDevice8
'##BD DirectInputDevice used by this GameController8 object. Access this property for custom functionality.
    Set DirectInputDevice = DIDeviceJoystick
End Property

Public Property Get InUse() As Boolean
'##BD Returns if the controller is in use by TrueVision. This method is set to True if the Initialized method was successful.
    InUse = mvarInUse
End Property
