VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GameControllers8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"GameController"
Attribute VB_Ext_KEY = "Member0" ,"GameController"
'##CD Collection of GameController8 objects.
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private mvarParent As InputEngine8

Public Sub GetControllers()
'##BD Loads all the Installed controllers on the system. This method is called automatically when the InputEngine object is created. You may find a need to call this method again to refresh the collection. The clear method is called within this method.
    Dim i As Long, GameController8 As GameController8
    Dim JoyEnum As DirectInputEnumDevices8
    
    Call Clear 'Clear all exisiting controllers
    
    'Enumerate the game controllers and joysticks
    Set JoyEnum = EnumerateDevices(DI8DEVTYPE_GAMEPAD Or DI8DEVTYPE_JOYSTICK)
    
    'Load found game controllers into the collection
    For i = 1 To JoyEnum.GetCount
        With JoyEnum.GetItem(i)
            Set GameController8 = Add(.GetGuidProduct & "|" & Count + 1, .GetDevType, .GetGuidInstance, .GetGuidProduct, .GetInstanceName, .GetProductName, _
                                                            .GetUsage, .GetUsagePage, .GetGuidFFDriver, .GetGuidInstance)
        End With
    Next i
End Sub

Friend Property Set Parent(ByVal vData As InputEngine8)
    Set mvarParent = vData
End Property

Public Property Get Parent() As InputEngine8
'##BD InputEngine object one level above this object.
    Set Parent = mvarParent
End Property

Private Function EnumerateDevices(Optional eDeviceType As CONST_DI8DEVICETYPE, _
                                                Optional eOptions As CONST_DIENUMDEVICESFLAGS) As DirectInputEnumDevices8
    Set EnumerateDevices = DInput.GetDIDevices(eDeviceType, eOptions)
End Function

Public Sub Clear()
'##BD Removes all the GameController8 objects from the collection.
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Friend Function Add(ByVal Key As String, ByVal lType As Long, ByVal GuidIn As String, ByVal GuidProd As String, _
                                        ByVal InstName As String, ByVal ProdName As String, ByVal Usage As Integer, ByVal UsagePage As Integer, _
                                        ByVal FFDri As String, Optional ByVal sKey As String) As GameController8
    Dim objNewMember As GameController8
    
    Set objNewMember = New GameController8 'create a new object

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        Call .SetProperties(lType, GuidIn, GuidProd, FFDri, InstName, ProdName, Usage, UsagePage) 'Set read-only properties
    End With
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As GameController8
Attribute Item.VB_UserMemId = 0
'##BD Returns a specific member of a collection.
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
'##BD Removes all the MouseCursor objects from the collection.
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
'##BD Removes a GameController8 object from the collection.
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    Set IntForm.GameControllers = Me
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
    Set mvarParent = Nothing
    Set IntForm.GameControllers = Nothing
End Sub

