VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GraphicEffect8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------
' TrueVision Graphic Effects
'-----------------------------


Sub ChangeGamma(gamma As Single)
  '##BD Change the Gamma values for the scene. Note that some cards doesn't support this feature.
  '##PD gamma Gamma values : 0-dark   1-normal   more-bright
   Dim a As D3DGAMMARAMP
   Device.GetGammaRamp a
   Dim t As Long
   For i = 0 To 255
      t = i * gamma * 255
      g = 0
      If t > 32767 Then g = 1: t = t - 32767
      If t > 32767 Then t = 32767
      'We need this bit thing to handle unsigned integer
      a.Red(i) = t Or (&H8000 * g)
      a.Green(i) = t Or (&H8000 * g)
      a.Blue(i) = t Or (&H8000 * g)
      
   Next i
   
   Device.SetGammaRamp 0, a
   
End Sub


Public Property Get FadeFinished() As Boolean
    FadeFinished = IIf(SEFadeOn = True, False, True)
End Property
Public Sub FadeIn(Optional Speed As Single = 2000)
   SEFadeOn = True
   SEFlashOn = False
   SEFade = 0
   SEFadeMode = 1  'fade in
   SEFadeSpeed = Speed
End Sub
Public Sub FadeOut(Optional Speed As Single = 2000)
   SEFadeOn = True
   SEFlashOn = False
   SEFade = 0
   SEFadeMode = 2  'fade out
   SEFadeSpeed = Speed
End Sub

Public Sub Flash(r As Single, g As Single, b As Single)
   SEFadeOn = False
   SEFlashOn = True
   SEFlash = 0
   SEFlashSpeed = Speed
   SEFlashColor = DXColor(r, g, b, a)
End Sub


Public Property Get FlashFinished() As Boolean
   FlashFinished = Not SEFlashOn
End Property

Public Sub InstantFlash(r As Single, g As Single, b As Single, FlashFactor As Single)
        LocalScreen.DrawFilledBox 0, 0, TVApp.PresentMode.BackBufferWidth * 1#, TVApp.PresentMode.BackBufferHeight * 1#, RGBA(r, g, b, FlashFactor), True
End Sub

Sub SetFog(Enabled As Boolean, r As Single, g As Single, b As Single, density As Single, Optional startfog As Single = 1, Optional endfog As Single = 1000)
   SEFogMode = 0
   Device.SetRenderState D3DRS_FOGVERTEXMODE, D3DFOG_LINEAR
   Device.SetRenderState D3DRS_FOGENABLE, IIf(Enabled = True, 1, 0)
   Device.SetRenderState D3DRS_FOGCOLOR, RGBA(r, g, b, 1)
   Device.SetRenderState D3DRS_FOGSTART, FtoDW(startfog)
   Device.SetRenderState D3DRS_FOGEND, FtoDW(endfog)
   Device.SetRenderState D3DRS_FOGDENSITY, FtoDW(density)
   SEFogEnabled = Enabled
End Sub
Sub SetVolumetricFog(Enabled As Boolean, r As Single, g As Single, b As Single, density As Single, startfog As Single, endfog As Single)
   SEFogMode = 1
   Device.SetRenderState D3DRS_FOGVERTEXMODE, 0
   Device.SetRenderState D3DRS_FOGTABLEMODE, D3DFOG_LINEAR
   Device.SetRenderState D3DRS_FOGENABLE, IIf(Enabled = True, 1, 0)
   Device.SetRenderState D3DRS_FOGCOLOR, RGBA(r, g, b, 1)
   Device.SetRenderState D3DRS_FOGSTART, FtoDW(startfog)
   Device.SetRenderState D3DRS_FOGEND, FtoDW(endfog)
   Device.SetRenderState D3DRS_FOGDENSITY, FtoDW(density)
   SEFogEnabled = Enabled

End Sub


Public Sub StopFade()
   SEFadeOn = False
   SEFade = 0
End Sub
Public Sub StopFlash()
   SEFlashOn = False
   SEFlash = 0
End Sub


