VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InputEngine8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_HelpID = 2020
Attribute VB_Description = "Top level object housing all functionality to control the Keyboard, Mouse, and installed Joysticks."
'##CD Top level object housing all functionality to control the Keyboard, Mouse, and installed Joysticks.
'-----------------------------------'
' TrueVision Input Engine
' Keyboard and mouse
'------------------------------------
'
' Started 15/11/00
' Updated December 7, 2000

Option Explicit

Private mvarMouseCursor As Direct3DSurface8
Private mvarMouseSensitivity As Long
Private mvarGameControllers As GameControllers8
Private mvarMouseCursors As MouseCursors8
  Public Type POINTAPI
  x As Long
  y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

'Keyboard Consts
Public Enum CONST_TV8_KEY
    TV_KEY_DOWN = DIK_DOWN
    TV_KEY_LEFT = DIK_LEFT
    TV_KEY_RIGHT = DIK_RIGHT
    TV_KEY_UP = DIK_UP
    TV_KEY_A = DIK_A
    TV_KEY_B = DIK_B
    TV_KEY_C = DIK_C
    TV_KEY_D = DIK_D
    TV_KEY_E = DIK_E
    TV_KEY_F = DIK_F
    TV_KEY_G = DIK_G
    TV_KEY_H = DIK_H
    TV_KEY_I = DIK_I
    TV_KEY_J = DIK_J
    TV_KEY_K = DIK_K
    TV_KEY_L = DIK_L
    TV_KEY_M = DIK_M
    TV_KEY_N = DIK_N
    TV_KEY_O = DIK_O
    TV_KEY_P = DIK_P
    TV_KEY_Q = DIK_Q
    TV_KEY_R = DIK_R
    TV_KEY_S = DIK_S
    TV_KEY_T = DIK_T
    TV_KEY_U = DIK_U
    TV_KEY_V = DIK_V
    TV_KEY_W = DIK_W
    TV_KEY_X = DIK_X
    TV_KEY_Y = DIK_Y
    TV_KEY_Z = DIK_Z
    TV_KEY_0 = DIK_0
    TV_KEY_1 = DIK_1
    TV_KEY_2 = DIK_2
    TV_KEY_3 = DIK_3
    TV_KEY_4 = DIK_4
    TV_KEY_5 = DIK_5
    TV_KEY_6 = DIK_6
    TV_KEY_7 = DIK_7
    TV_KEY_8 = DIK_8
    TV_KEY_9 = DIK_9
    TV_KEY_COMMA = DIK_COMMA
    TV_KEY_CONVERT = DIK_CONVERT
    TV_KEY_COLON = DIK_COLON
    TV_KEY_AT = DIK_AT
    TV_KEY_ALT_LEFT = DIK_LALT
    TV_KEY_ALT_RIGHT = DIK_RALT
    TV_KEY_DECIMAL = DIK_DECIMAL
    TV_KEY_DELETE = DIK_DELETE
    TV_KEY_END = DIK_END
    TV_KEY_EQUALS = DIK_EQUALS
    TV_KEY_ESCAPE = DIK_ESCAPE
    TV_KEY_GRAVE = DIK_GRAVE
    TV_KEY_HOME = DIK_HOME
    TV_KEY_INSERT = DIK_INSERT
    TV_KEY_LEFTBRACKET = DIK_LBRACKET
    TV_KEY_LEFTCONTROL = DIK_LCONTROL
    TV_KEY_LEFTMENU = DIK_LMENU
    TV_KEY_LEFTSHIFT = DIK_LSHIFT
    TV_KEY_LEFTWINDOWS = DIK_LWIN
    TV_KEY_RIGHTBRACKET = DIK_RBRACKET
    TV_KEY_RETURN = DIK_RETURN
    TV_KEY_RCONTROL = DIK_RCONTROL
    TV_KEY_RIGHTMENU = DIK_RMENU
    TV_KEY_NEXT = DIK_NEXT
    TV_KEY_NOCONVERT = DIK_NOCONVERT
    TV_KEY_NUMPAD0 = DIK_NUMPAD0
    TV_KEY_NUMPAD1 = DIK_NUMPAD1
    TV_KEY_NUMPAD2 = DIK_NUMPAD2
    TV_KEY_NUMPAD3 = DIK_NUMPAD3
    TV_KEY_NUMPAD4 = DIK_NUMPAD4
    TV_KEY_NUMPAD5 = DIK_NUMPAD5
    TV_KEY_NUMPAD6 = DIK_NUMPAD6
    TV_KEY_NUMPAD7 = DIK_NUMPAD7
    TV_KEY_NUMPAD8 = DIK_NUMPAD8
    TV_KEY_NUMPAD9 = DIK_NUMPAD9
    TV_KEY_NUMPADENTER = DIK_NUMPADENTER
    TV_KEY_NUMPADEQUALS = DIK_NUMPADEQUALS
    TV_KEY_PAUSE = DIK_PAUSE
    TV_KEY_F1 = DIK_F1
    TV_KEY_F2 = DIK_F2
    TV_KEY_F3 = DIK_F3
    TV_KEY_F4 = DIK_F4
    TV_KEY_F5 = DIK_F5
    TV_KEY_F6 = DIK_F6
    TV_KEY_F7 = DIK_F7
    TV_KEY_F8 = DIK_F8
    TV_KEY_F9 = DIK_F9
    TV_KEY_F10 = DIK_F10
    TV_KEY_F11 = DIK_F11
    TV_KEY_F12 = DIK_F12
    TV_KEY_APOSTROPHE = DIK_APOSTROPHE
    TV_KEY_APPS = DIK_APPS
    TV_KEY_BACKSPACE = DIK_BACK
    TV_KEY_BACKSLASH = DIK_BACKSLASH
    TV_KEY_CAPITAL = DIK_CAPITAL
    TV_KEY_CIRCUMFLEX = DIK_CIRCUMFLEX
    TV_KEY_ADD = DIK_ADD
    TV_KEY_SUBTRACT = DIK_SUBTRACT
    TV_KEY_DIVIDE = DIK_DIVIDE
    TV_KEY_MULTIPLY = DIK_MULTIPLY
    TV_KEY_MINUS = DIK_MINUS
    TV_KEY_PAGEUP = DIK_PGUP
    TV_KEY_PAGEDOWN = DIK_PGDN
    TV_KEY_SPACE = DIK_SPACE
End Enum

Event MouseChanged(ByVal x As Long, ByVal y As Long, ByVal z As Long, ByVal Button1 As Boolean, ByVal Button2 As Boolean, _
                                        ByVal Button3 As Boolean, ByVal Button4 As Boolean)
'##ED Fires when the mouse changes state.

Event KeyboardChanged()
'##ED Fires when the keyboard changes state.
'##PD ErrNum Error number.

Friend Sub FireEvents(ByVal lEvent As Long, Optional ByVal MButton1 As Boolean, Optional ByVal MButton2 As Boolean, _
                                        Optional ByVal MButton3 As Boolean, Optional MButton4 As Boolean, Optional ByVal mx As Long, _
                                        Optional ByVal my As Long, Optional ByVal MZ As Long)
    Select Case lEvent
        Case 1 'MouseChanged
            RaiseEvent MouseChanged(mx, my, MZ, MButton1, MButton2, MButton3, MButton4)
        
        Case 2 'KeyboardChanged
            RaiseEvent KeyboardChanged
        
    End Select
End Sub

Sub GetAbsMouseState(ByRef mx As Long, ByRef my As Long, Optional ByRef b1 As Integer, Optional ByRef b2 As Integer)
  ' Dim TX As Long, TY As Long
   
   If relative = True Then
   End If
   
   mx = ActMX
   my = ActMY
   b1 = MouseState.Buttons(0)
   b2 = MouseState.Buttons(1)

End Sub

Public Sub Poll()
    Call DIMouseDevice.Poll
    Call DIKeyboardDevice.Poll
End Sub

Public Sub ReAcquire(Optional ByVal bKeyboard As Boolean = True, Optional ByVal bMouse As Boolean = False)
Attribute ReAcquire.VB_Description = "Reacquires either the Keyboar, Mouse, or both. Use this method when the connection with the keyboard and mouse is lost. This method is required when your application losses focus in window applications."
Attribute ReAcquire.VB_HelpID = 2021
'##BD Reacquires either the Keyboar, Mouse, or both. Use this method when the connection with the keyboard and mouse is lost. _
            This method is required when your application losses focus in window applications.

'##PD bKeyboard Set to True to reacquire the Keyboard.
'##PD bMouse Set to True to reacquire the Mouse.
    On Error GoTo Handler
    
    If DInput Is Nothing Then Exit Sub
    
    'Init the keyboard (take the first keyboard)
    Set DIKeyboardDevice = DInput.CreateDevice("guid_syskeyboard")
    Call DIKeyboardDevice.SetCommonDataFormat(DIFORMAT_KEYBOARD)
    If TVApp.hwnd = 0 Then
        Call DIKeyboardDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_NONEXCLUSIVE Or DISCL_FOREGROUND)
    Else
        Call DIKeyboardDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE)
    End If
    
    'Init mouse
    Set DIMouseDevice = DInput.CreateDevice("guid_sysmouse")
    Call DIMouseDevice.SetCommonDataFormat(DIFORMAT_MOUSE)
    If TVApp.hwnd = 0 Then
        Call DIMouseDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_NONEXCLUSIVE Or DISCL_FOREGROUND)
    Else
        Call DIMouseDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE)
    End If
    
    'dclenche l'acquisition du clavier
    If bKeyboard = True Then Call DIKeyboardDevice.Acquire
    If bMouse = True Then
     Dim prop As DIPROPLONG
     prop.lData = DIPROPAXISMODE_ABS
     prop.lHow = DIPH_DEVICE
     prop.lObj = 0
     DIMouseDevice.SetProperty DIPROP_AXISMODE, prop
     DIMouseDevice.Acquire
     relative = False
     
     DIMouseDevice.GetDeviceStateMouse MouseState
     MouseX = MouseState.lX
     MouseY = MouseState.lY
   End If
    Exit Sub
    
Handler:
  Call AddLog("Error : ReAcquire error " + CStr(Err.Number) + " " + CStr(Err.Description))
  Err.Clear
End Sub

Public Property Let MouseSensitivity(ByVal vData As Long)
Attribute MouseSensitivity.VB_Description = "Sensitivity of the mouse cursor. This value is used in the calculation for moving the mouse in the RenderMouse method. Default value is set to 1.  "
Attribute MouseSensitivity.VB_HelpID = 2022
    mvarMouseSensitivity = vData
End Property

Public Property Get MouseSensitivity() As Long
'##BD Sensitivity of the mouse cursor. This value is used in the calculation for moving the mouse in the RenderMouse method. Default value is set to 1.
    MouseSensitivity = mvarMouseSensitivity
End Property
Public Property Get GameControllers() As GameControllers8
Attribute GameControllers.VB_Description = "Returns the GameControllers8 collection object."
Attribute GameControllers.VB_HelpID = 2023
'##BD Returns the GameControllers8 collection object.
    Set GameControllers = mvarGameControllers
End Property

Sub SetMouseCursor(CurrentMouseCursor As MouseCursor8)
Attribute SetMouseCursor.VB_Description = "Sets the mouse cursor to be rendered to the screen."
Attribute SetMouseCursor.VB_HelpID = 2024
'##BD Sets the mouse cursor to be rendered to the screen.

'##PD CurrentMouseCursor MouseCursor object that stores the valid Direct3DSurface8 object to render to the screen.
    Set mvarMouseCursor = CurrentMouseCursor.MCursor
End Sub

Sub SetMousePosition(x As Long, y As Long)
    ActMX = x
    ActMY = y
    MouseX = MouseState.lX - x
    MouseY = MouseState.lY - y
End Sub

Sub SetMouseSensitivity(Sens As Single)
  mvarMouseSensitivity = Sens
End Sub

Public Sub ShowControlPanel(hwnd As Long)
Attribute ShowControlPanel.VB_Description = "Displays the systems Control Panel."
Attribute ShowControlPanel.VB_HelpID = 2025
'##BD Displays the systems Control Panel.

'##PD hwnd Handle (hwnd) to the owner form.
    If DInput Is Nothing Then Exit Sub
    
    Call DInput.RunControlPanel(hwnd)
End Sub

Public Property Get IsMouseConnected() As Boolean
Attribute IsMouseConnected.VB_Description = "Determines if the Mouse is connected to the system."
Attribute IsMouseConnected.VB_HelpID = 2026
'##BD Determines if the Mouse is connected to the system.
    If DInput Is Nothing Then Exit Property
    
    IsMouseConnected = DInput.GetDeviceStatus("GUID_SysMouse")
End Property

Public Property Get MouseCursor() As Direct3DSurface8
Attribute MouseCursor.VB_Description = "Direct3DSurface8 object representing the mouse cursor."
Attribute MouseCursor.VB_HelpID = 2027
'##BD Direct3DSurface8 object representing the mouse cursor.
    Set MouseCursor = mvarMouseCursor
End Property

Public Function CreateMouseCursorFromFile(ByVal file As String) As Boolean
Attribute CreateMouseCursorFromFile.VB_Description = "Creates a DirectDrawSurface7 object used as the default mouse cursor from a file."
Attribute CreateMouseCursorFromFile.VB_HelpID = 2028
'##BD Creates a DirectDrawSurface7 object used as the default mouse cursor from a file.

'##PD file Path and name of the picture file to use. <i>Example: App.Path & "\Mouse.bmp"</i>
'##RD Returns True if the mouse cursor was created or False if an error occured.
    On Error GoTo Handler
    
    CreateMouseCursorFromFile = True
    Exit Function
    
Handler:
    CreateMouseCursorFromFile = False
End Function
Public Property Get MouseCursors() As MouseCursors8
Attribute MouseCursors.VB_Description = "Returns the collection of MouseCursor objects."
Attribute MouseCursors.VB_HelpID = 2029
'##BD Returns the collection of MouseCursor objects.
    Set MouseCursors = mvarMouseCursors
End Property
Function IsKeyPressed(Key As CONST_TV8_KEY) As Boolean
Attribute IsKeyPressed.VB_Description = "Determines if a key on the keyboard is pressed down."
Attribute IsKeyPressed.VB_HelpID = 2030
'##BD Determines if a key on the keyboard is pressed down.

'##PD Key Keyboard key you wish to check for.
'##RD True if the key is pressed down or false if not.
    If KeyboardState.Key(Key) <> 0 Then
        IsKeyPressed = True
    End If
End Function
Sub GetMouseState(ByRef mx As Long, ByRef my As Long, Optional ByRef b1 As Integer, Optional ByRef b2 As Integer, _
                                        Optional ByRef b3 As Integer, Optional ByRef IntelliMouseRoll As Long)
Attribute GetMouseState.VB_Description = "Returns the current mouse state. Note: All parameters are return values."
Attribute GetMouseState.VB_HelpID = 2031
'##BD Returns the current mouse state. <b><i>Note:</b> All parameters are return values.</i>
    On Error Resume Next
    
    mx = RelMX
    my = RelMY
    IntelliMouseRoll = MouseState.lZ
    b1 = MouseState.Buttons(0)
    b2 = MouseState.Buttons(1)
    b3 = MouseState.Buttons(2)
End Sub

Public Sub UnloadDevices()
Attribute UnloadDevices.VB_HelpID = 2032
    On Error Resume Next
    
    If lKeyEvent <> 0 Then Call DIKeyboardDevice.SetEventNotification(0)
    If lMouseEvent <> 0 Then Call DIMouseDevice.SetEventNotification(0)
    
    Call DIMouseDevice.Unacquire
    Call DIKeyboardDevice.Unacquire
End Sub

Private Sub Class_Initialize()
    On Error GoTo Handler
    Call AddLog("INPUT : Global initialization")
    
    If TVApp.Initialized = False Then
        Call MsgBox("The Input Engine methods can't be called before the 3D Engine Init !", vbCritical, "ERROR TV8")
        Call AddLog("INPUT ERROR : The 3D engine must be initialized before.")
        Exit Sub
    End If
    
    'Create the DInput
    Set DInput = DirectX.DirectInputCreate
    
    'Init the keyboard (take the first keyboard)
    Set DIKeyboardDevice = DInput.CreateDevice("guid_syskeyboard")
    Call DIKeyboardDevice.SetCommonDataFormat(DIFORMAT_KEYBOARD)
    If TVApp.Fullscreen = True Then
        Call DIKeyboardDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_EXCLUSIVE Or DISCL_FOREGROUND)
        AddLog "INPUT : Key Exclusive "
    Else
        Call DIKeyboardDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE)
    End If
    'lKeyEvent = DirectX.CreateEvent(IntForm)
    'Call DIKeyboardDevice.SetEventNotification(lKeyEvent) ' Ask for notification of events
    'Call IntForm.ForceCallBack 'Fake a event call
    Call DIKeyboardDevice.Acquire
    Call AddLog("INPUT : Keyboard Acquired")
    
    'Init mouse
    Set DIMouseDevice = DInput.CreateDevice("guid_sysmouse")
    Call DIMouseDevice.SetCommonDataFormat(DIFORMAT_MOUSE)
    
    
    If TVApp.Fullscreen = True Then
        Call DIMouseDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_EXCLUSIVE Or DISCL_FOREGROUND)
        AddLog "INPUT : Mouse Exclusive"
    Else
        Call DIMouseDevice.SetCooperativeLevel(TVApp.hwnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE)
    End If
    Dim prop As DIPROPLONG
    prop.lData = DIPROPAXISMODE_ABS
    prop.lHow = DIPH_DEVICE
    prop.lObj = 0
    DIMouseDevice.SetProperty DIPROP_AXISMODE, prop
    'lMouseEvent = DirectX.CreateEvent(IntForm)
    'Call DIMouseDevice.SetEventNotification(lMouseEvent) ' Ask for notification of events
    'Call IntForm.ForceCallBack 'Fake a event call
    DIMouseDevice.Acquire
    relative = False
    
    DIMouseDevice.GetDeviceStateMouse MouseState
    MouseX = MouseState.lX
    MouseY = MouseState.lY
    AmouseX = MouseX
    AmouseY = MouseY
    
    Call AddLog("INPUT : ABS Mouse Acquired")
    'Setup game controllers & mouse cursor properties then load the game controllers collection.
    Set mvarGameControllers = New GameControllers8
    Set mvarGameControllers.Parent = Me

    Set mvarMouseCursors = New MouseCursors8
    Set mvarMouseCursors.Parent = Me
    mvarMouseSensitivity = 1
    Call DIKeyboardDevice.Poll
    Call mvarGameControllers.GetControllers
    
    TVApp.KeyboardInit = True
    Set LocalInput = Me
    Exit Sub
    
Handler:
    Call AddLog("INPUT ERROR : Class_Initialize (" + Err.Description + " " + D3DX.GetErrorString(Err.Number) + ")")
    Resume Next
End Sub


Private Sub Class_Terminate()
    Set mvarGameControllers = Nothing
    Set mvarMouseCursors = Nothing
    Set mvarMouseCursor = Nothing
    
    Call UnloadDevices 'Unaquire the keyboard and mouse.
    
    Set DIMouseDevice = Nothing
    Set DIKeyboardDevice = Nothing
    Set DInput = Nothing
End Sub

Public Sub RenderMouse()
Attribute RenderMouse.VB_Description = "Draws the active mouse cursor on the screen. Call this method during your game loop to accurately move the mouse cursor surface when the user moves the system mouse."
Attribute RenderMouse.VB_HelpID = 2033
'##BD Draws the active mouse cursor on the screen. Call this method during your game loop to accurately move the mouse cursor surface when the user moves the system mouse.

End Sub
