VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Path8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'##CD This class contains everything to create a path and moves a object along it.


'  Path type motion
'
'


Private Type PathType
  Node() As D3DVECTOR
  NumNode As Integer
  CurrentNode As Integer
  MeshAssocied As Integer
  FollowLandscape As Boolean
  Position As D3DVECTOR
  Rotation As D3DVECTOR
  Direction As D3DVECTOR
End Type

Private PathT As PathType


Public Sub AddPathNode(V As D3DVECTOR)
  '##BD Add a path node vector to the node list.
  '##PD V Node to add.
  PathT.NumNode = PathT.NumNode + 1
  ReDim Preserve PathT.Node(PathT.NumNode)
  PathT.Node(PathT.NumNode) = V
End Sub

Public Sub ApplyToMesh(Mesh As Mesh8)
  '##BD Defines the mesh that will use this path.
  '##PD Mesh The Mesh class
  PathT.MeshAssocied = Mesh.GetMeshIndex
End Sub




Function GetNode(NodeIndex As Integer) As D3DVECTOR
   '##BD Returns the position of the specified node.
   '##PD NodeIndex Node Index (range :1-NodeCount)
   GetNode = PathT.Node(NodeIndex)
End Function

Function GetNodeCount() As Integer
  '##BD Returns the nodes count in the current path.
  GetNodeCount = PathT.NumNode
End Function

Public Function MoveMesh(StepPerSecond As Single)
  '##BD Moves the mesh along the path with the specified speed.
  '##PD StepPerSecond Mesh speed.
  
End Function
Public Sub ResetPath()
  '##BD Reset the path settings and clears all the nodes.
  PathT.NumNode = 0
  ReDim PathT.Node(0)
End Sub

