VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RenderSurface8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-------------------------------------
' Render Surface 8 for Mirrors,
' Environment mapping...
'-------------------------------------

'Matrices
Private ViewMatrixRTS As D3DMATRIX, ProjectionMatrixRTS As D3DMATRIX
Private WorldMatrixRTS As D3DMATRIX
'Camera
Private StartPosRTS As D3DVECTOR, EndPosRTS As D3DVECTOR
Private AngleFOVRTS As Single, farPlaneRTS As Single
'Viewport
Private Viewport As D3DVIEWPORT8, BackGroundColor As Long

Private Texture As Direct3DTexture8, TexIndex  As Integer
Private Surface As Direct3DSurface8

Private RTS As D3DXRenderToSurface

Private FrustumPlanesRTS(6) As D3DPLANE
Private TMPPlaneRTS(6) As D3DPLANE

Private TMPEndPos As D3DVECTOR
Private TMPStartPos As D3DVECTOR

Private No3db As Boolean
Private Sub ComputeClipPlanesRTS()
    
    Dim veye As D3DVECTOR
    Dim vat As D3DVECTOR
    Dim vup As D3DVECTOR
    Dim Front As Single
    Dim Back As Single
    Dim Aspect As Single
    Dim Fov As Single
    
    veye = StartPosRTS
    vat = EndPosRTS
    vup = Vector(0, 1, 0)
    Front = 0.01
    Back = farPlaneRTS
    Fov = AngleFOVRTS
    Aspect = 3 / 4
    
    Dim vDir As D3DVECTOR
    Dim vright As D3DVECTOR
        
    Dim vFrontCenter As D3DVECTOR
    Dim vFrontUp As D3DVECTOR
    Dim vFrontRight As D3DVECTOR
    
    Dim vBackCenter As D3DVECTOR
    
    Dim vBackRight As D3DVECTOR
    Dim vbackLeft As D3DVECTOR
    
    Dim vBackRightTop As D3DVECTOR
    Dim vBackLeftTop As D3DVECTOR
    
    Dim vBackRightBot As D3DVECTOR
    Dim vBackLeftBot As D3DVECTOR
        
    Dim dx As Single
    Dim dy As Single
    
    'Establish our basis vector
    D3DXVec3Subtract vDir, vat, veye
    D3DXVec3Normalize vDir, vDir
    D3DXVec3Normalize vup, vup
    D3DXVec3Cross vright, vDir, vup
    
    dx = Tan(Fov / 2) * Back
    dy = dx * Aspect
        
    '
    '
    '              /|  vbackleft (top,bot)
    '             / |
    '        vfront |
    '           /|  |
    '       eye ----|  vbackcenter
    '           \|  |
    '            \  |dx
    '             \ |
    '              \|  vbackright (top,bot)
    '
    '
    
    
    'compute vbackcenter
    D3DXVec3Scale vBackCenter, vDir, Back
    D3DXVec3Add vBackCenter, vBackCenter, veye
    
       
    'compute vbackright
    D3DXVec3Scale vBackRight, vright, dx
    D3DXVec3Add vBackRight, vBackCenter, vBackRight
    
    
    'compute vbackleft
    D3DXVec3Scale vbackLeft, vright, -dx
    D3DXVec3Add vbackLeft, vBackCenter, vbackLeft
 
    'compute vbackrighttop
    D3DXVec3Scale vBackRightTop, vup, dy
    D3DXVec3Add vBackRightTop, vBackRight, vBackRightTop
    
    
    'compute vbacklefttop
    D3DXVec3Scale vBackLeftTop, vup, dy
    D3DXVec3Add vBackLeftTop, vBackRight, vBackLeftTop
        
     'compute vbackrightbot
    D3DXVec3Scale vBackRightBot, vup, -dy
    D3DXVec3Add vBackRightBot, vBackRight, vBackRightBot
       
    'compute vbackleftbot
    D3DXVec3Scale vBackLeftBot, vup, -dy
    D3DXVec3Add vBackLeftBot, vBackRight, vBackLeftBot
    
        
    'compute vfrontcenter
    D3DXVec3Scale vFrontCenter, vDir, Front
    D3DXVec3Add vFrontCenter, vFrontCenter, veye
 
    'compute vfrontright
    D3DXVec3Scale vFrontRight, vright, dx
    D3DXVec3Add vFrontRight, vFrontCenter, vFrontRight
 
    'compute vfrontup
    D3DXVec3Scale vFrontUp, vup, dy
    D3DXVec3Add vFrontUp, vFrontCenter, vFrontUp
 
    '
    'g_numClipPlanes = 6
    
    
    
    'front plane
    D3DXPlaneFromPointNormal FrustumPlanesRTS(0), veye, vDir
    
    'back plane
    Dim vnegdir As D3DVECTOR
    D3DXVec3Scale vnegdir, vDir, -1
    D3DXPlaneFromPointNormal FrustumPlanesRTS(1), vBackCenter, vnegdir
    
    'right plane
    D3DXPlaneFromPoints FrustumPlanesRTS(2), veye, vBackRightTop, vBackRightBot
    
    'left plane
    D3DXPlaneFromPoints FrustumPlanesRTS(3), veye, vBackLeftTop, vBackLeftBot
    
    'top plane
    D3DXPlaneFromPoints FrustumPlanesRTS(4), veye, vBackLeftTop, vBackRightTop
    
    'bot plane
    D3DXPlaneFromPoints FrustumPlanesRTS(5), veye, vBackRightBot, vBackLeftBot
    'g_numClipPlanes = 4

End Sub


Public Sub EndRender()
  RTS.EndScene
If No3db = False Then
  Device.SetTransform D3DTS_PROJECTION, ProjectionMatrix
  Device.SetTransform D3DTS_VIEW, ViewMatrix
  DXCopyMemory FrustumPlanes(0), TMPPlaneRTS(0), Len(FrustumPlanesRTS(0)) * 6
  EndPos = TMPEndPos
  StartPos = TMPStartPos
End If
End Sub

Function GetTexture() As Texture8
    '##BD Get the dynamic texture from the render surface. Note you can use this dynamic texture everywhere as a normal texture.
    Set GetTexture = Textures(TexIndex).TextureOb
End Function

'Device.CreateRenderTarget
Friend Sub Init(width As Long, height As Long, tex As Boolean, no3d As Boolean)
 '   Set Surface = Device.CreateDepthStencilSurface(width, height, D3DFMT_D16, D3DMULTISAMPLE_NONE)
 If tex = True Then
  D3DX.CheckTextureRequirements Device, width, height, 1, D3DUSAGE_RENDERTARGET, FmtTexture, D3DPOOL_DEFAULT
 End If
  

  Set RTS = D3DX.CreateRenderToSurface(Device, width, height, TVApp.PresentMode.BackBufferFormat, 1, D3DFMT_D16)
  Viewport.MinZ = 0#
  Viewport.maxZ = 1#
  Viewport.x = 0
  Viewport.y = 0
  Viewport.width = width
  Viewport.height = height
  farPlaneRTS = 500
  AngleFOVRTS = AngleFOV
   
   
 No3db = no3d
 If No3db = True Then
   D3DXMatrixPerspectiveFovLH ProjectionMatrixRTS, AngleFOV, height / width, 1, farPlaneRTS
 End If
  If tex = True Then
    Set Texture = D3DX.CreateTexture(Device, width, height, 0, 0, FmtTexture, D3DPOOL_MANAGED)
    Set Surface = Texture.GetSurfaceLevel(0)
    TexIndex = LocTexFactory.GetNewTextureIndex
    Set Textures(TexIndex).TexSurf = Texture
  Else
    
  End If
  
  
End Sub




Sub SetCamera(PosX As Single, PosY As Single, PosZ As Single, LookAtX As Single, LookAtY As Single, LookAtZ As Single)
   '##BD Set the camera for the render surface. Useful for having 3D rendering in a render surface.
   StartPosRTS = Vector3(PosX, PosY, PosZ)
   EndPosRTS = Vector3(LookAtX, LookAtY, LookAtZ)
    D3DXMatrixLookAtLH ViewMatrixRTS, StartPosRTS, EndPosRTS, Vector(0, 1, 0)
End Sub

Public Sub StartRender()
 '##BD Start to render in this surface. You need to call this function out of the TV.Clear/Tv.renderToScreen block. After this function, you can work with your render surface with the Screen8 class object and the Scene8 object. And you can manipulate the "surface camera" with the SetCamera function of THIS class.
 
   RTS.BeginScene Surface, Viewport
   Device.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1, 0

If No3db = False Then
   DXCopyMemory TMPPlaneRTS(0), FrustumPlanes(0), Len(FrustumPlanesRTS(0)) * 6
   ComputeClipPlanesRTS
   DXCopyMemory FrustumPlanes(0), FrustumPlanesRTS(0), Len(FrustumPlanesRTS(0)) * 6
   TMPStartPos = StartPos
   TMPEndPos = EndPos
   StartPos = StartPosRTS
   EndPos = EndPosRTS
   
   Device.SetTransform D3DTS_PROJECTION, ProjectionMatrixRTS
   Device.SetTransform D3DTS_VIEW, ViewMatrixRTS
 End If
End Sub

Private Sub Class_Initialize()
  StartPosRTS = Vector(0, 0, 0)
  EndPosRTS = Vector(0, 0, 1)
  D3DXMatrixLookAtLH ViewMatrixRTS, StartPosRTS, EndPosRTS, Vector(0, 1, 0)
  
End Sub


