VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Scene8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------
' Standard TrueVision8 Scene
'-----------------------------

Private TexFactory As New TextureFactory8

Public Enum CONST_TV_RENDERMODE
   TV_POINT = 1
   TV_LINE = 2
   TV_SOLID = 3
End Enum

Private SkyTexture(6) As Direct3DTexture8
Private SkyVertex(36) As D3DLVERTEX
Private SkyMatrix As D3DMATRIX


Public Enum CONST_TV_TESTTYPE
  TV_TESTTYPE_BOUNDINGBOX = 1
  TV_TESTTYPE_BOUNDINGSPHERE = 2
  TV_TESTTYPE_ACCURATETESTING = 3
  TV_TESTTYPE_MDL_HITBOXES = 4
End Enum

Public Enum CONST_TV_COLORKEY
  TV_COLORKEY_NO = 0
  TV_COLORKEY_WHITE = &HFFFFFFFF
  TV_COLORKEY_BLACK = &HFF000000
  TV_COLORKEY_BLUE = &HFF0000FF
  TV_COLORKEY_RED = &HFFFF0000
  TV_COLORKEY_GREEN = &HFF00FF00
  TV_COLORKEY_YELLOW = &HFFFFFF00
  TV_COLORKEY_MAGENTA = &HFFFF00FF
  TV_COLORKEY_CYAN = &HFF00FFFF
End Enum

Public Enum CONST_TV_BLENDINGMODE
  TV_BLEND_NO = 0
  TV_BLEND_ALPHA = 1
  TV_BLEND_ADD = 2
  TV_BLEND_COLOR = 3
 End Enum


Function Collide(Start As D3DVECTOR, EndLine As D3DVECTOR, Optional TestType As CONST_TV_TESTTYPE = TV_TESTTYPE_ACCURATETESTING) As Boolean
 '##BD Checks if a ray collide with the entire scene except  Actors.
 '##PD Start Start of the ray
 '##PD End End of the ray
 '##PD TestType Accuracy for the testing. Bounding box is faster than Accurate test.
    
   If Not BSPTree Is Nothing Then
     Collide = BSPTree.DetectCollision(Start, EndLine)
   End If
   If Collide = True Then
      Exit Function
   End If
   
   For i = 1 To NBMesh
     If Mesh(i).Enabled = True And Mesh(i).Active = True Then
       Collide = Mesh(i).Object.Collision(Start, EndLine, TestType)
     End If
     If Collide = True Then Exit Function
   Next i

   If Not LocalLand Is Nothing Then
     If LocalLand.MousePicking(Start, EndLine).IsCollision = True Then
      Collide = True
     End If
   End If
End Function

Function CreateBillboard(Texture As Texture8, x As Single, y As Single, z As Single, width As Single, height As Single, Optional Name As String = "", Optional alpha As Boolean, Optional src As CONST_D3DBLEND, Optional dest As CONST_D3DBLEND, Optional color As Long = &HFFFFFFFF) As Mesh8
   Set CreateBillboard = CreateMeshBuilder(Name)
   
   CreateBillboard.SetGroupPointer 1
   CreateBillboard.AddWall Texture, -width / 2, 0, width / 2, 0, -height, height
   CreateBillboard.SetPrimitiveType TV_TRIANGLESTRIP
   CreateBillboard.SetMaterial 0
   CreateBillboard.SetTexture Texture
   CreateBillboard.SetPosition x, y, z
   CreateBillboard.ScaleMesh 1, 1, 1
   CreateBillboard.SetVertexType TV_NORMAL_VERTEX
  '
  Mesh(CreateBillboard.GetMeshIndex).Features.Settings.Billboard = 1
 '  AddLog "CreateBillboard " + CStr(CreateBillboard.GetMeshIndex)
End Function
Function CreateRenderSurface(width As Long, height As Long, Texture As Boolean, Optional PosX As Long = 0, Optional PosY As Long = 0) As RenderSurface8
  Set CreateRenderSurface = New RenderSurface8
  CreateRenderSurface.Init width, height, True, False
End Function

Sub EnableMipMapping()
  Device.SetTextureStageState 0, D3DTSS_MIPFILTER, D3DTEXF_POINT
End Sub

Function GetTriangleNumber() As Long
 '##BD Get the number of faces displayed by the engine in a frame (only for meshes object and BSP for now)
 GetTriangleNumber = NumFaceDisplayed
End Function

Public Sub LoadCursor(Filename As String, Optional Colorkey As CONST_TV_COLORKEY = 0, Optional width As Single = 32, Optional height As Single = 32)
    
    'Set CursorSurface = Device.CreateImageSurface(32, 32, D3DFMT_A8R8G8B8)
    'D3DX.LoadSurfaceFromFile CursorSurface, ByVal 0, ByVal 0, Filename, ByVal 0, D3DX_DEFAULT, Colorkey, ByVal 0
    CursorSurface = LocTexFactory.LoadTexture(Filename, "Cursor", , , Colorkey).GetTexIndex
    CursorEnable = True
    
    CursorWidth = width
    CursorHeight = height
End Sub

Sub LoadShaders(Filename As String)
  Dim lin As String
  Dim TF As New TextureFactory8
  Open Filename For Input As 6
     Do
       'Load a line
       Line Input #6, lin$
       
       lin$ = Trim$(lin$)
       If Left$(lin$, 2) = "//" Or Left$(lin$, 2) = "" Then
         GoTo ChangeLine
       End If
       ins = InStr(lin$, " ")
       If ins > 0 Then
         keyw$ = Left$(lin$, ins - 1)
         rest$ = Trim$(mid$(lin$, InStr(lin$, " ") + 1))
       Else
         keyw$ = lin$
         rest$ = ""
       End If
       Select Case UCase$(keyw$)
         Case "TEXTURES", "TEXTURETABLE", "TEXTURESTABLE"
           NbTex = val(rest$)
           For i = 1 To NbTex
             Line Input #6, lin$
             file$ = Trim$(Left$(lin$, InStr(lin$, ">") - 1))
             Name$ = Trim$(mid$(lin$, InStr(lin$, ">") + 1))
             TF.LoadTexture file$, Name$, 256, 256, TV_COLORKEY_BLACK
           Next i
         Case "SHADER"
          LoadSimpleShader 6, Trim$(rest$)
         
       End Select
ChangeLine:
     Loop Until EOF(6)
  Close 6
End Sub

Public Function MousePicking(x As Long, y As Long, Optional ObjectTypeToTest As CONST_TV_OBJECT_TYPE = 0, Optional TestType As CONST_TV_TESTTYPE = TV_TESTTYPE_BOUNDINGBOX) As CollisionResult8
   Dim vi As D3DVECTOR, vf As D3DVECTOR
   Set MousePicking = New CollisionResult8
   GetProjetedVector x, y, vi, vf
  Dim U As Single, v As Single, t As Single
  Dim res As Boolean
'  If ObjectTypeToTest = 0 Or (ObjectTypeToTest And TV_COLLIDE_TERRAIN) <> 0 Then
'    Set MousePicking = Land.MousePicking(vi, vf)
'  End If
  If ObjectTypeToTest = 0 Or (ObjectTypeToTest And TV_COLLIDE_BSPTREE) <> 0 Then
   res = BSPTree.DetectCollision(vi, vf)
   If res = True Then
     MousePicking.SetCollisionProperties res, 0, 0, 0, CollisionNormal, -2, CollisionImpact
   End If
  End If
  
  If ObjectTypeToTest = 0 Or (ObjectTypeToTest And TV_COLLIDE_MESH) <> 0 Then
  For i = 0 To NBMesh
    If Mesh(i).Enabled = True Then
      If Mesh(i).Active = True Then
        If Mesh(i).Object.Collision(StartPos, vf, TestType) = True Then
           MousePicking.SetCollisionProperties True, t, U, v, CollisionNormal, i, CollisionImpact
           Exit Function
        End If
      End If
    End If
  Next i
  
 End If
 
 If ObjectTypeToTest = 0 Or (ObjectTypeToTest And TV_COLLIDE_LANDSCAPE) <> 0 Then
    Set MousePicking = LocalLand.MousePicking(StartPos, vf)
 End If
End Function

Public Sub RenderAllMeshes()
  Dim i As Integer
  For i = 1 To NBMesh
    If Mesh(i).Parent = 0 Then
      RenderMesh2 i, False
    End If
  Next i
End Sub

Friend Sub RenderCursor()
  On Error Resume Next
  Dim mx As Long, my As Long
  LocalInput.GetAbsMouseState mx, my
  LocalScreen.DrawTexture GetTex("Cursor"), mx * 1, my * 1, mx + CursorWidth, my + CursorHeight
End Sub


Sub SetCursorTexture(Cursor As Texture8, Optional CursWidth As Single = 32, Optional CursHeight As Single = 32)
  If Cursor Is Nothing Then
    CursorEnable = False
    CursorSurface = 0
  Else
    CursorSurface = Cursor.GetTexIndex
    CursorWidth = CursWidth
    CursHeight = CursHeight
    CursorEnable = True
  End If
End Sub

Public Sub SetDithering(OnOff As Boolean)
  '##BD Enable/Disable the dithering for the scene. Useful for some cards (GeForce2 or other) that must use the 16bits mode with TV.
  Device.SetRenderState D3DRS_DITHERENABLE, OnOff
End Sub

Sub SetPickingPrecision(farPlane As Single)
      PrecisionMousePicking = farPlane
End Sub

Public Sub SetSkyTexture(Front As Texture8, Back As Texture8, Left As Texture8, Right As Texture8, Top As Texture8, Bottom As Texture8, Optional SkyDistance As Single = 600)
   CreateSkyVertex SkyDistance
   Set SkyTexture(1) = Textures(Left.GetTexIndex).TexSurf
   Set SkyTexture(2) = Textures(Right.GetTexIndex).TexSurf
   Set SkyTexture(3) = Textures(Front.GetTexIndex).TexSurf
   Set SkyTexture(4) = Textures(Back.GetTexIndex).TexSurf
   Set SkyTexture(5) = Textures(Top.GetTexIndex).TexSurf
   Set SkyTexture(6) = Textures(Bottom.GetTexIndex).TexSurf
End Sub


Private Sub CreateSkyVertex(Sky As Single)
    C = RGBA(1, 1, 1, 1)

   'left
  SkyVertex(1) = LVertex(-Sky, -Sky, -Sky, C, 0, 1)
  SkyVertex(2) = LVertex(Sky, -Sky, -Sky, C, 1, 1)
  SkyVertex(3) = LVertex(-Sky, Sky, -Sky, C, 0, 0)
  SkyVertex(4) = LVertex(Sky, Sky, -Sky, C, 1, 0)

  'right
  SkyVertex(6) = LVertex(-Sky, -Sky, Sky, C, 1, 1)
  SkyVertex(5) = LVertex(Sky, -Sky, Sky, C, 0, 1)
  SkyVertex(8) = LVertex(-Sky, Sky, Sky, C, 1, 0)
  SkyVertex(7) = LVertex(Sky, Sky, Sky, C, 0, 0)

  'front
  SkyVertex(9) = LVertex(-Sky, -Sky, -Sky, C, 1, 1)
  SkyVertex(10) = LVertex(-Sky, Sky, -Sky, C, 1, 0)
  SkyVertex(11) = LVertex(-Sky, -Sky, Sky, C, 0, 1)
  SkyVertex(12) = LVertex(-Sky, Sky, Sky, C, 0, 0)

  'back
  SkyVertex(14) = LVertex(Sky, -Sky, -Sky, C, 0, 1)
  SkyVertex(13) = LVertex(Sky, Sky, -Sky, C, 0, 0)
  SkyVertex(16) = LVertex(Sky, -Sky, Sky, C, 1, 1)
  SkyVertex(15) = LVertex(Sky, Sky, Sky, C, 1, 0)

  'up
  SkyVertex(21) = LVertex(-Sky, Sky, -Sky, C, 1, 0)
  SkyVertex(22) = LVertex(Sky, Sky, -Sky, C, 0, 0)
  SkyVertex(23) = LVertex(-Sky, Sky, Sky, C, 1, 1)
  SkyVertex(24) = LVertex(Sky, Sky, Sky, C, 0, 1)
   '18 17 20 19  /
  'down
  SkyVertex(18) = LVertex(-Sky, -Sky, -Sky, C, 1, 1)
  SkyVertex(17) = LVertex(Sky, -Sky, -Sky, C, 0, 1)
  SkyVertex(20) = LVertex(-Sky, -Sky, Sky, C, 1, 0)
  SkyVertex(19) = LVertex(Sky, -Sky, Sky, C, 0, 0)
  
  'Fix small texcoords problem.
  For i = 1 To 24
    If SkyVertex(i).tu = 0 Then SkyVertex(i).tu = 0.001
    If SkyVertex(i).tv = 0 Then SkyVertex(i).tv = 0.001
    If SkyVertex(i).tu = 1 Then SkyVertex(i).tu = 0.999
    If SkyVertex(i).tv = 1 Then SkyVertex(i).tv = 0.999
    
  Next i
End Sub

Public Function CreateMeshBuilder(Optional Name As String = "") As Mesh8
   Dim i As Integer
   For i = 1 To NBMesh
      If Mesh(i).Active = False Then
        Exit For
      End If
   Next i
   
   If i = NBMesh + 1 Then
     NBMesh = NBMesh + 1
     
     ReDim Preserve Mesh(i)
   End If
   
   With Mesh(i)
    .Active = True
    .Enabled = True
    Set .Object = New Mesh8
    .MeshName = IIf(Name = "", "Mesh" + CStr(i), Name)
    ReDim .Features.Groups(1)
    .Features.NumGroup = 0
    .Created = False
    .Object.SetMeshIndex i
   End With
   
   Set CreateMeshBuilder = Mesh(i).Object
  'Mesh(i).Features.TypeVertex = TV_VERTEX2
  D3DXMatrixIdentity Mesh(i).Matrix
  Mesh(i).Features.PrimType = D3DPT_TRIANGLELIST
  Mesh(i).Features.Settings.VertexBufferEnabled = False
  Mesh(i).Features.Settings.Scaling = Vector(1, 1, 1)
  Mesh(i).Features.NumGroup = 1
  Mesh(i).Object.SetGroupPointer 1
  Mesh(i).Object.SetCullMode D3DCULL_NONE
  Mesh(i).Features.TypeVertex = TV_VERTEX2
  Mesh(i).Enabled = True
  Mesh(i).Changed = True
End Function

Public Sub DrawText(Text As String, x As Long, y As Long, Optional color As Long = &HFFFFFFFF)
   D3DX.DrawText D3DFont, color, Text, REC(x, y, 0, 0), 0
End Sub

Public Function LoadTexture(Filename As String, Optional width As Long = -1, Optional height As Long = -1, Optional TextureName As String) As Texture8
   Set LoadTexture = TexFactory.LoadTexture(Filename, TextureName, width, height)
End Function

Public Sub SelectFont(Optional FontName As String, Optional FontSize As String, Optional color As String, Optional Bold As Boolean, Optional Italic As Boolean, Optional Underlined As Boolean)
    If FontName <> "" Then IntForm.FontName = FontName
    If FontSize <> 0 Then IntForm.FontSize = FontSize
    IntForm.FontBold = Bold
    IntForm.fontItalic = Italic
    IntForm.fontUnderline = Underlined
    Dim FontS As IFont
    Set FontS = IntForm.Font
    Set D3DFont = Nothing
    Set D3DFont = D3DX.CreateFont(Device, FontS.hFont)
End Sub

Sub SetCollisionPrecision(Collide As Single)
     PrecisionCollide = Collide
End Sub

Public Sub SetSceneBackGround(r As Single, g As Single, b As Single)
   BackGroundColor = DXCToL(DXColor(r, g, b, 1))
End Sub


Public Sub SetCamera(xpos As Single, ypos As Single, zpos As Single, xlookat As Single, ylookat As Single, zlookat As Single)
     StartPos = Vector3(xpos, ypos, zpos): EndPos = Vector3(xlookat, ylookat, zlookat)
 D3DXMatrixLookAtLH ViewMatrix, StartPos, EndPos, Vector(0, 1, 0)
If CameraRoll <> 0 Then
  ViewMatrix = MRotate(ViewMatrix, 0, 0, CameraRoll)
End If
  Device.SetTransform D3DTS_VIEW, ViewMatrix
End Sub


Public Sub SetRenderMode(RM As CONST_TV_RENDERMODE)
 If RM = TV_LINE Then
   Device.SetRenderState D3DRS_FILLMODE, D3DFILL_WIREFRAME
 End If
 If RM = TV_POINT Then
   Device.SetRenderState D3DRS_FILLMODE, D3DFILL_POINT
 End If
 If RM = TV_SOLID Then
   Device.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
 End If
End Sub


Sub SetViewFrustum(sAngleFOV As Single, sFarPlane As Single)
      AngleFOV = sAngleFOV * PI / 180
      farPlane = sFarPlane
      
      D3DXMatrixPerspectiveFovLH ProjectionMatrix, AngleFOV, 3 / 4, 1, farPlane
   '   D3DXMatrixPerspectiveLH ProjectionMatrix, 256, 256, 0.1, farPlane
'
'       Device.SetViewport Viewport
 
      Device.SetTransform D3DTS_PROJECTION, ProjectionMatrix
End Sub

Private Sub Class_Initialize()
 Set LocalScene = Me
 PrecisionCollide = 30
 PrecisionMousePicking = 1000
End Sub
Sub LoadSky(TextureFileName As String, Optional SkyDistance As Single = 1000)
'##BD Loads the skydome from 6 bitmap files. You have to give the first sky bitmap (Sky1.bmp) _
The bitmaps (or GIF/JPG) must be in this order : left, right, front, back, up, down. _
Then you can render this sky with the RenderSky method.

'##PD TextureFileName First bitmap to load.
'##PD SkyDistance Distance between the skydome and the player.
  Dim Sky As Single
  ext = Right(TextureFileName, 4)
  file = Left(TextureFileName, Len(TextureFileName) - 5)
  
  For i = 1 To 6
    Set SkyTexture(i) = LoadTexture(file + CStr(i) + ext)
  Next i
  Sky = SkyDistance
  
  CreateSkyVertex Sky

 
End Sub
Sub RenderSky()
  Dim v As D3DLVERTEX
'##BD Renders the sky that has been loaded in LoadSky.
  D3DXMatrixIdentity SkyMatrix
  D3DXMatrixTranslation SkyMatrix, StartPos.x, StartPos.y, StartPos.z
  Device.SetTransform D3DTS_WORLD, SkyMatrix
  Device.SetRenderState D3DRS_LIGHTING, 0
  Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
  Device.SetVertexShader TV_LVERTEX
  Device.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  For i = 0 To 5
   Device.SetTexture 0, SkyTexture(i + 1)
   Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, SkyVertex(i * 4 + 1), Len(v)
  Next i
End Sub

