VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Screen8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------'
' 2D Interface for TrueVision
'---------------------------------'
' It uses of course 3D primitives !
' Note you can render these primitives in a RenderSurface8 Too.
' very useful for blending textures, or write text in one texture.

Private BoxVertex(4) As D3DTLVERTEX
Private LineVertex(6) As D3DTLVERTEX

Private SrcBlend As Long, DestBlend As Long

Private Type FontType
   Font As D3DXFont
   UserName As String
End Type

Option Explicit

Private LocalFont() As FontType, NbFont As Long


Sub CreateUserFont(UserName As String, FontName As String, FontSize As Long, FontBold As Boolean, fontItalic As Boolean, fontUnderline As Boolean)
    IntForm.FontName = FontName
    IntForm.FontSize = FontSize
    IntForm.fontItalic = fontItalic
    IntForm.fontUnderline = fontUnderline
    IntForm.FontBold = FontBold
    NbFont = NbFont + 1
    ReDim Preserve LocalFont(NbFont)
    LocalFont(NbFont).UserName = IIf(UserName = "", "UserFont" + CStr(NbFont), UserName)
    Dim FontS As IFont
    Set FontS = IntForm.Font
    Set LocalFont(NbFont).Font = D3DX.CreateFont(Device, FontS.hFont)
    Set FontS = Nothing
End Sub


Friend Sub DrawBackGround()
 If BackgroundEnable = True Then
  Device.CopyRects BackPicture, ByVal 0, 0, Device.GetBackbuffer(0, D3DBACKBUFFER_TYPE_MONO), ByVal 0
 End If
End Sub

Sub DrawBox(x As Single, y As Single, x1 As Single, y1 As Single, color As Long)
    Dim v As D3DTLVERTEX
    BoxVertex(0) = TLVertex(x, y, 0, color, 0, 0)
    BoxVertex(1) = TLVertex(x1, y, 0, color, 1, 0)
    BoxVertex(3) = TLVertex(x, y1, 0, color, 0, 1)
    BoxVertex(2) = TLVertex(x1, y1, 0, color, 1, 1)
    BoxVertex(4) = TLVertex(x, y, 0, color, 0, 0)
    
    Device.SetTexture 0, Nothing
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetVertexShader TV_TLVERTEX
    
    Device.DrawPrimitiveUP D3DPT_LINESTRIP, 4, BoxVertex(0), Len(v)
End Sub

Sub DrawFilledBox(x As Single, y As Single, x1 As Single, y1 As Single, color As Long, Optional AlphaBlended As Boolean = False)
    Dim v As D3DTLVERTEX
    BoxVertex(0) = TLVertex(x, y, 0, color, 0, 0)
    BoxVertex(1) = TLVertex(x1, y, 0, color, 1, 0)
    BoxVertex(2) = TLVertex(x, y1, 0, color, 0, 1)
    BoxVertex(3) = TLVertex(x1, y1, 0, color, 1, 1)
    Device.SetTexture 0, Nothing
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
    Device.SetRenderState D3DRS_ALPHABLENDENABLE, IIf(AlphaBlended = True, 1, 0)
    Device.SetRenderState D3DRS_DESTBLEND, DestBlend
    Device.SetRenderState D3DRS_SRCBLEND, SrcBlend
    
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, BoxVertex(0), Len(v)
End Sub
Sub DrawFilledColorBox(x As Single, y As Single, x1 As Single, y1 As Single, color1 As Long, color2 As Long, color3 As Long, color4 As Long, Optional AlphaBlended As Boolean = False)
    Dim v As D3DTLVERTEX
    BoxVertex(0) = TLVertex(x, y, 0, color1, 0, 0)
    BoxVertex(1) = TLVertex(x1, y, 0, color2, 1, 0)
    BoxVertex(2) = TLVertex(x, y1, 0, color3, 0, 1)
    BoxVertex(3) = TLVertex(x1, y1, 0, color4, 1, 1)
    Device.SetRenderState D3DRS_ALPHABLENDENABLE, AlphaBlended
        Device.SetRenderState D3DRS_DESTBLEND, DestBlend
    Device.SetRenderState D3DRS_SRCBLEND, SrcBlend

    Device.SetTexture 0, Nothing
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetVertexShader TV_TLVERTEX
    
    Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, BoxVertex(0), Len(v)
End Sub


Sub DrawLine(x As Single, y As Single, x1 As Single, y1 As Single, color As Long)
    Dim v As D3DTLVERTEX
    LineVertex(0) = TLVertex(x, y, 0, color, 0, 0)
    LineVertex(1) = TLVertex(x1, y1, 0, color, 1, 0)
    Device.SetTexture 0, Nothing
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_LINELIST, 1, LineVertex(0), Len(v)
End Sub

Sub DrawPoint(x As Single, y As Single, color As Long)
    Dim v As D3DTLVERTEX
    LineVertex(0) = TLVertex(x, y, 0, color, 0, 0)
 '   LineVertex(1) = TLVertex(x, y, 0, color, 1, 0)
    Device.SetTexture 0, Nothing
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_POINTLIST, 1, LineVertex(0), Len(v)
End Sub
Sub DrawLine3D(x As Single, y As Single, z As Single, x1 As Single, y1 As Single, z1 As Single, color As Long)
    Dim v As D3DLVERTEX2
    Dim LineVertex2(1) As D3DLVERTEX2
    LineVertex2(0) = LVertex2(x, y, z, color, 0, 0, 0, 0)
    LineVertex2(1) = LVertex2(x1, y1, z1, color, 1, 0, 1, 0)
    Device.SetTexture 0, Nothing
    Device.SetTransform D3DTS_WORLD, WorldMatrix
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetVertexShader TV_LVERTEX2
    Device.DrawPrimitiveUP D3DPT_LINELIST, 1, LineVertex2(0), Len(v)
End Sub

Sub DrawPartTexture(Texture As Texture8, x As Single, y As Single, x1 As Single, y1 As Single, tu1 As Single, tv1 As Single, tu2 As Single, tv2 As Single, Optional color As Long = &HFFFFFFFF, Optional AlphaBlended As Boolean = False)
    Dim v As D3DTLVERTEX
    BoxVertex(0) = TLVertex(x, y, 0, color, tu1, tv1)
    BoxVertex(1) = TLVertex(x1, y, 0, color, tu2, tv1)
    BoxVertex(2) = TLVertex(x, y1, 0, color, tu1, tv2)
    BoxVertex(3) = TLVertex(x1, y1, 0, color, tu2, tv2)
    Device.SetTexture 0, Textures(Texture.GetTexIndex).TexSurf
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetRenderState D3DRS_ALPHABLENDENABLE, AlphaBlended
    Device.SetRenderState D3DRS_DESTBLEND, DestBlend
    Device.SetRenderState D3DRS_SRCBLEND, SrcBlend
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, BoxVertex(0), Len(v)
End Sub

Sub DrawSprite(SpriteIndex As Integer, x As Long, y As Long)
   With sprites(SpriteIndex)
     .sprite.Draw Textures(.Texture).TexSurf, ByVal 0, .Scaling, .RotationCenter, .Rotation, Vec2(x, y), &HFFFFFFFF
   End With
End Sub
Public Sub DrawText(Text As String, x As Long, y As Long, color As Long, Optional UserFont As String = "")
   Dim i As Long
   For i = 1 To NbFont
     If UCase$(UserFont) = UCase$(LocalFont(i).UserName) Then
        Exit For
     End If
   Next i
   If i = NbFont + 1 Then UserFont = ""
   
   If UserFont = "" Then
     'use standard font :
     LocalScene.DrawText Text, x, y, color
   Else
     D3DX.DrawText LocalFont(i).Font, color, Text, REC(x, y, 0, 0), 0
   End If
   
End Sub

Sub DrawTexture(Texture As Texture8, x As Single, y As Single, x1 As Single, y1 As Single, Optional color As Long = &HFFFFFFFF, Optional AlphaBlended As Boolean = False)
    Dim v As D3DTLVERTEX
    BoxVertex(0) = TLVertex(x, y, 0, color, 0.02, 0.02)
    BoxVertex(1) = TLVertex(x1, y, 0, color, 0.98, 0.02)
    BoxVertex(2) = TLVertex(x, y1, 0, color, 0.02, 0.98)
    BoxVertex(3) = TLVertex(x1, y1, 0, color, 0.98, 0.98)
    Device.SetTexture 0, Textures(Texture.GetTexIndex).TexSurf
    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetRenderState D3DRS_ALPHABLENDENABLE, AlphaBlended
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
    
    Device.SetRenderState D3DRS_DESTBLEND, DestBlend
    Device.SetRenderState D3DRS_SRCBLEND, SrcBlend
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, BoxVertex(0), Len(v)
End Sub

Sub DrawTextureRotated(Texture As Texture8, x As Single, y As Single, width As Single, height As Single, angle As Single, Optional color As Long = &HFFFFFFFF, Optional AlphaBlended As Boolean = False)
    '##BD Paint a texture on the current RenderSurface or Screen and rotate it around Z-axis.
    '##PD Texture Texture to apply
    '##PD x Position Center x
    '##PD y Position Center y
    '##PD width Texture width on the screen
    '##PD height Texture height on the screen
    '##PD angle Rotation angle in degrees
    '##PD color Color modulation.
    '##PD alphablended Choose if it's alphablended or not.
    
    Dim va As D3DTLVERTEX
    Dim M As D3DMATRIX, v(4) As D3DVECTOR
    Dim w As Single, h As Single, i As Integer
    D3DXMatrixRotationZ M, angle * 3.1415 / 180
    
    M.m41 = x
    M.m42 = y
    w = width / 2
    h = height / 2
    
    v(1) = Vector3(-w, -h, 0)
    v(2) = Vector3(w, -h, 0)
    v(3) = Vector3(-w, h, 0)
    v(4) = Vector3(w, h, 0)
    
    For i = 1 To 4
     D3DXVec3TransformCoord v(i), v(i), M
    Next i
    'Device.SetTransform D3DTS_WORLD, M
    BoxVertex(0) = TLVertex(v(1).x, v(1).y, v(1).z, color, 0.02, 0.02)
    BoxVertex(1) = TLVertex(v(2).x, v(2).y, v(2).z, color, 0.98, 0.02)
    BoxVertex(2) = TLVertex(v(3).x, v(3).y, v(3).z, color, 0.02, 0.98)
    BoxVertex(3) = TLVertex(v(4).x, v(4).y, v(4).z, color, 0.98, 0.98)

    Device.SetRenderState D3DRS_LIGHTING, 0
    Device.SetRenderState D3DRS_ALPHABLENDENABLE, AlphaBlended
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
    Device.SetRenderState D3DRS_DESTBLEND, DestBlend
    Device.SetRenderState D3DRS_SRCBLEND, SrcBlend
    Device.SetTexture 0, Textures(Texture.GetTexIndex).TexSurf
    Device.SetVertexShader TV_TLVERTEX
    Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, BoxVertex(0), Len(va)
End Sub

Sub EnableBackground(OnOff As Boolean)
  BackgroundEnable = OnOff
End Sub


Sub LoadBackground(Filename As String)
   Dim BackFormat As Long, width As Long, height As Long
   With TVApp
     BackFormat = .PresentMode.BackBufferFormat
     width = .PresentMode.BackBufferWidth
     height = .PresentMode.BackBufferHeight
   End With
Set BackPicture = Device.CreateImageSurface(width, height, BackFormat)
D3DX.LoadSurfaceFromFile BackPicture, ByVal 0, REC(0, 0, width - 1, height - 1), Filename, ByVal 0, D3DX_FILTER_LINEAR, 0, ByVal 0
End Sub

Function LoadSprite(sprite As String, Optional Name As String = "") As Integer
    Dim i As Long
    
    For i = 1 To NBSprite
       If sprites(i).Active = False Then
        Exit For
       End If
    Next i
    If i = NBSprite + 1 Then
       NBSprite = NBSprite + 1
       ReDim Preserve sprites(NBSprite)
    End If
    
    sprites(i).Active = True
    sprites(i).Scaling = Vec2(1, 1)
    sprites(i).Position = Vec2(0, 0)
    sprites(i).Rotation = 0
    sprites(i).Name = IIf(Name = "", "Sprite " + CStr(i), Name)
    Set sprites(i).sprite = D3DX.CreateSprite(Device)
    LoadSprite = i
End Function
Function RollOver(TextureOver As Texture8, TextureNormal As Texture8, Left As Long, Top As Long, Right As Long, Bottom As Long, Optional AlphaBlended As Boolean = False) As Boolean
    Dim mx As Long, my As Long
    LocalInput.GetAbsMouseState mx, my
    If mx > Left And mx < Right And my > Top And my < Bottom Then
      RollOver = True
      DrawTexture TextureOver, Left * 1, Top * 1, Right * 1, Bottom * 1, , AlphaBlended
    Else
      RollOver = False
      DrawTexture TextureNormal, Left * 1, Top * 1, Right * 1, Bottom * 1, , AlphaBlended
    End If
End Function
Sub RotateSprite(SpriteIndex As Integer, RotationCenterX As Single, RotationCenterY As Single, RotationAngles As Single)
  sprites(SpriteIndex).RotationCenter = Vec2(RotationCenterX, RotationCenterY)
  sprites(SpriteIndex).Rotation = RotationAngles * 3.14 / 180
End Sub

Sub ScaleSprite(SpriteIndex As Integer, scalex As Single, scaley As Single)
    sprites(SpriteIndex).Scaling = Vec2(scalex, scaley)
End Sub
Public Sub SetBlendingMode(Destination As CONST_D3DBLEND, src As CONST_D3DBLEND)
  DestBlend = Destination
  SrcBlend = src
  
End Sub

Private Sub Class_Initialize()
  ReDim Preserve LocalFont(0)
  NbFont = 0
  AddLog "SCREEN INTERFACE 2D : Initialized"
  DestBlend = D3DBLEND_INVSRCALPHA
  SrcBlend = D3DBLEND_SRCALPHA
  
End Sub

Private Sub Class_Terminate()
   AddLog "SCREEN MANAGER : Desallocate memory from fonts and sprites..."
   On Error Resume Next
   Dim i As Long
   For i = 0 To NbFont
     Set LocalFont(i).Font = Nothing
   Next i
   ReDim LocalFont(0)
End Sub

