VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoundEngine8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
'  Temporary Sound Engine
'
'

Function LoadSound(file As String, Optional Use3D As Boolean = False, Optional Name As String) As Integer
On Error GoTo errorsound
    
    For i = 1 To NBSounds
      If Sounds(i).Active = False Then
        Exit For
      End If
    Next i
    
    If i = NBSounds + 1 Then
      ReDim Preserve Sounds(i)
      NBSounds = NBSounds + 1
    End If
    
    Dim Desc As DSBUFFERDESC
    Desc.lFlags = DSBCAPS_STATIC Or DSBCAPS_CTRLVOLUME Or DSBCAPS_CTRLFREQUENCY
    Desc.guid3DAlgorithm = GUID_DS3DALG_DEFAULT
    Desc.lBufferBytes = 0
    With Sounds(i)
      .Active = True
      .Playing = False
      Set .SoundBuffer = DirectSound.CreateSoundBufferFromFile(file, Desc)
      .SoundName = IIf(Name = "", "Sound" + CStr(i), Name)
    End With
    
    LoadSound = i

 Exit Function
errorsound:
  
End Function

Function Play(Sound As Integer, Optional Looping As Boolean = False)
     Sounds(Sound).Playing = True
     Sounds(Sound).SoundBuffer.Play IIf(Looping = True, DSBPLAY_LOOPING, DSBPLAY_DEFAULT)
End Function

Sub SetFrequency(Buffer As Integer, Frequency As Long)
  Sounds(Buffer).SoundBuffer.SetFrequency Frequency
End Sub

Public Sub SetGeneralVolume(Volume As Single)
    PrimaryBuffer.SetVolume Volume
End Sub

Public Sub StopSound(Optional SoundIndex As Integer = -1)
    For i = 1 To NBSounds
      If SoundIndex = -1 Or SoundIndex = i Then
       Sounds(i).SoundBuffer.Stop
      End If
    Next i
End Sub
Private Sub Class_Initialize()
   AddLog "SOUND : Creating Primary Buffer"
   
   If TVApp.hwnd = 0 Then
    MsgBox "DirectSound Problem : The 3D engine must be initialized before any sound operation", vbCritical
    Exit Sub
   End If
   
   Set DirectSound = DirectX.DirectSoundCreate("")
   DirectSound.SetCooperativeLevel TVApp.hwnd, DSSCL_NORMAL
   
   Dim PrimaryDesc As DSBUFFERDESC, PrimaryF As WAVEFORMATEX
   PrimaryF.nChannels = 1
   PrimaryF.lSamplesPerSec = 44100
   PrimaryF.nBitsPerSample = 8
   PrimaryDesc.lFlags = DSBCAPS_PRIMARYBUFFER
   PrimaryDesc.lBufferBytes = 0
   
   Set PrimaryBuffer = DirectSound.CreatePrimarySoundBuffer(PrimaryDesc)

   AddLog "SOUND : Set default sound settings"
'   PrimaryBuffer.SetFormat PrimaryF
   PrimaryBuffer.Play DSBPLAY_LOOPING
End Sub


Private Sub Class_Terminate()
   AddLog "SOUND : Desallocate sound buffers memory"
   StopSound
   For i = 1 To NBSounds
     Sounds(i).Playing = False
     Set Sounds(i).SoundBuffer = Nothing
   Next i
   ReDim Sounds(0)
End Sub


