Attribute VB_Name = "TrueVisionActor"
'
' TrueVision 1.8
'
'--------------------
'  MDL file loader
'-------------------

' 01-10-2001 : MD3 support.
'
' 08-28-2000 : All work. The animation bugs is away
'

' 08-18-2000 : The class works now.
'              Bone controller

' 05-07-2000 : Management with Mesh Class (vertex & triangles)
'              We suppose that we take first model of a bodyparts

' 04-07-2000 : Module added with MDL file structure
'              Textures loading (even in a external texture MDL)

'MDL Structure File
Option Explicit

Public Enum StudioControllerType
  studio_x = 1
  STUDIO_Y = 2
  STUDIO_Z = 4
  STUDIO_XR = 8
  STUDIO_YR = 16
  STUDIO_ZR = 32
  STUDIO_LX = 64
  STUDIO_LY = 128
  STUDIO_LZ = 256
  STUDIO_AX = 512
  STUDIO_AY = 1024
  STUDIO_AZ = 2048
  STUDIO_AXR = 4096
  STUDIO_AYR = 8192
  STUDIO_AZR = 16384
  STUDIO_TYPE = 32767
  STUDIO_RLOOP = 32768
End Enum

Public Type StudioHeader
   id As String * 4
   version As Long
   Name As String * 64
   
   Length As Long
   EyePosition As D3DVECTOR
   min As D3DVECTOR
   max As D3DVECTOR
   bbmin As D3DVECTOR
   bbmax As D3DVECTOR
   
   Flags As Long
   
   NumBones As Long
   BoneIndex As Long
   
   NumBoneControllers As Long
   BoneControllerIndex As Long
   
   NumHitBoxes As Long
   HitBoxIndex As Long

   NumSeq As Long
   seqindex As Long
   
   NumSeqGroups As Long
   SeqGroupIndex As Long

   NumTextures As Long
   TextureIndex As Long
   TextureDataIndex As Long
   
   NumSkinRef As Long
   NumSkinFamilies As Long
   SkinIndex As Long
   
   NumBodyparts As Long
   Bodypartindex As Long
   
   NumAttachments As Long
   Attachmentindex As Long
   
   SoundTable As Long
   SoundIndex As Long
   SoundGroups As Long
   SoundGroupIndex As Long
   
   NumTransitions As Long
   TransitionIndex As Long
End Type

Public Type StudioSeqHeader
   id As Long
   version As Long
   Name As String * 64
   Length As Long
End Type

Public Type StudioBones
   Name As String * 32
   Parent As Long
   Flags As Long
   BoneController(5) As Long
   
   value(5) As Single
   ScaleV(5) As Single
   'Rot As D3DVECTOR
   'ScalePos As D3DVECTOR
   'ScaleRot As D3DVECTOR
End Type

Public Type StudioBoneController
   Bone As Long
   Type As Long
   Start As Single
   End As Single
   rest As Long
   Index As Long
End Type

Public Type StudioBoundingBox
  Bone As Long
  Group As Long
  bbmin As D3DVECTOR
  bbmax As D3DVECTOR
End Type

Public Type StudioSeqGroup
  Label As String * 32
  Name As String * 64
  Cache As Long
  Data As Long
End Type

Public Type StudioSeqDesc
  Name As String * 32
  FPS As Single
  Flags As Long
  Activity As Long
  ActWeight As Long
  
  NumEvents As Long
  EventIndex As Long
  
  NumFrames As Long
  
  NumPivots As Long
  PivotIndex As Long
  
  MotionType As Long
  MotionBone As Long
  LinearMovement As D3DVECTOR
  AutomovePosIndex As Long
  AutoMoveAngleIndex As Long
  
  bbmin As D3DVECTOR
  bbmax As D3DVECTOR
  
  numblends As Long
  AnimIndex As Long
  
  BlendType(1) As Long
  BlendStart(1) As Single
  BlendEnd(1) As Single
  BlendParent As Long
  
  SeqGroup As Long
  
  EntryNode As Long
  ExitNode As Long
  NodeFlags As Long
  
  NextSeq As Long
End Type

Public Type StudioEvent
  frame As Long
  Event As Long
  Type As Long
  Option As String * 64
End Type

Public Type StudioPivots
  Org As D3DVECTOR
  Start As Long
  End As Long
End Type

Public Type StudioAttachment
  Name As String * 32
  Type As Long
  Bone As Long
  Org As D3DVECTOR
  Vec(2) As D3DVECTOR
End Type

Public Type StudioAnim
 offset(5) As Integer
End Type

Public Type StudioAnimFrame
   animframe  As Long
End Type

Public Type StudioAnimUnion
 Valid As Byte
 Total As Byte
End Type

Public Type SAF
  value As Integer
End Type

Public Type StudioBodyParts
  Name As String * 64
  NumModels As Long
  Base As Long
  ModelIndex As Long
End Type

Public Type StudioTexture
 Name As String * 64
 Flags As Long
 width As Long
 height As Long
 Index As Long
End Type

Public Type StudioModels
 Name As String * 64
 Type As Long
 BoundingRadius As Single
 NumMesh As Long
 MeshIndex As Long
 
 NumVertex As Long
 VertexInfoindex As Long
 VertexIndex As Long
 
 NumNormals As Long
 NormalInfoIndex As Long
 NormalIndex As Long
 
 NumGroups As Long
 GroupIndex As Long
End Type

Public Type StudioMesh
 NumTris As Long
 TriIndex As Long
 SkinRef As Long
 NumNorms As Long
 NormIndex As Long
End Type

Public Type StudioTri
 Vertindex As Integer
 NormIndex As Integer
 S As Integer
 t As Integer
End Type


'Local variables
Public Hdr As StudioHeader
Public BodyP() As StudioBodyParts

Public Type MDLTexCoord
 U As Single
 v As Single
End Type
Public Type MDLMesh
   Texture As Integer
   Vertex() As Integer
   TC() As MDLTexCoord
End Type

Public Type MDLModels
  Vertex() As D3DVECTOR
  'TC() As D3DVECTOR    'only .x and .y will be used for texture coordinates
  VertexIndex() As Integer
  VertexBones() As Byte
  Mesh() As MDLMesh
  SMesh() As StudioMesh
  NumMesh As Integer
End Type

Public Type BodyParts
  BodyP As StudioBodyParts
  ModelSelect As Integer
  Model() As StudioModels
  Mods() As MDLModels
End Type

Public Type BoneState
  Pos() As D3DVECTOR
  Rot() As D3DVECTOR
End Type

Public Type StudioAnimation
  NBFrame As Integer
  FPS As Integer
  Bones() As BoneState
End Type

Public Type FileByte
  b() As Byte
End Type
Public Type StudioSeqA
  Anim() As StudioAnim
  Index As Long
  Group As Integer
End Type

Public Type StudioHitBoxes
   min As D3DVECTOR
   max As D3DVECTOR
   BOXV(36) As D3DVECTOR
End Type
    
Public Type StudioAnimBones
   Matrix As D3DMATRIX
   Parent As Long
   Rot As D3DVECTOR
   Pos As D3DVECTOR
   Name As String
End Type
   
Public Type StudioAnimStatus
    Bones() As StudioAnimBones
    NbBones As Long
End Type

Public Type Attachme
  Bone As Integer
  Matrix As D3DMATRIX
  AttachePoint As Integer
  AttachMesh As Integer
End Type

Public Type MDLFile
  Filename As String
  Bones() As StudioBones
  HitBoxes() As StudioBoundingBox
  BP() As BodyParts
  Seq() As StudioSeqDesc
  SeqGrp() As StudioSeqGroup
  TexHeader() As StudioTexture
  TextureOffset() As Integer
  TexSize() As D3DVECTOR
  ControllerBone() As StudioBoneController
  ControllerValue() As Single
  MAdj() As Single
  Speed As Single
  KeyFrame As Single
  OldTime As Single
  Sequence As Integer
  SequenceA As StudioSeqA
  Anim() As StudioAnimation
  f() As FileByte
  MeshF As MeshFeatures
  Header As StudioHeader
  UseHitboxes As Boolean
  HitboxesT() As StudioHitBoxes
  AnimationStatus As StudioAnimStatus
  Attachment() As Attachme
  NumAttachment As Integer
  Matrix As D3DMATRIX
  BoxMin As D3DVECTOR
  BoxMax As D3DVECTOR
  SphereComputed As Boolean
  Center As D3DVECTOR
  Radius As Single
  Modified As Boolean
  AttachMesh As Integer
  AttachPoint As Integer
End Type



   
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Sub TransformVertexes Lib "tvpatch" (ByRef Vertex As D3DVECTOR, ByRef Matrix As D3DMATRIX, ByRef OutVector As D3DVECTOR)

Const MAX_MD2_VERTEX = 2048


Public Type MD2TriVert
  v As D3DVECTOR
  N As D3DVECTOR
End Type

Public Type MD2TriVertX
  v(2) As Byte
  LightNormalIndex As Byte
End Type

Public Type MD2AliasFrame
 ScaleM(2) As Single
 TranslateM(2) As Single
 Name As String * 16
 Verts(MAX_MD2_VERTEX) As MD2TriVertX
End Type

Public Type MD2Frame
   Mins As D3DVECTOR
   Maxs As D3DVECTOR
   v(MAX_MD2_VERTEX) As MD2TriVert
End Type
   
Public Type MD2StVert
  S As Integer
  t As Integer
End Type

Public Type MD2StVert2
  S As Single
  t As Single
End Type


Public Type MD2Triangle
 Vertex(2) As Integer
 St(2) As Integer
End Type

Public Type MD2File
   magic As String * 4
   version As Long
   SkinWidth As Long
   SkinHeight As Long
   FrameSize As Long
   Num_Skins As Long
   Num_Vertex As Long
   Num_TexCoords As Long
   Num_tris As Long
   Num_glcmds As Long
   Num_frames As Long
   Ofs_Skins As Long
   Ofs_TextCoords As Long
   Ofs_Tris As Long
   Ofs_frame As Long
   Ofs_glcmds As Long
   Ofs_end As Long
End Type

Public Type MD2FrameL
  Name As String
  vertices() As MD2TriVert
End Type
Public Type MD2Anim
  Name As String
  Start As Long
  End As Long
End Type

Public Type MD2Type
  Header As MD2File
  TexCoord() As MD2StVert
  TexCoord2() As MD2StVert2
  Triangle() As MD2Triangle
  Frames() As MD2FrameL
  VIndexes() As Integer
  TIndexes() As Integer
 
  CurrentFrame As Single
  EndFrame As Single
  StartFrame As Single
  
  Anim() As MD2Anim
    
  SkinTexture As Integer
End Type



'*/

Global Const MD3Magic = "IDP3"
Global Const MD3_VERSION = 15


'// limits
Global Const MD3_MAX_LODS = 3
Global Const MD3_MAX_TRIANGLES = 8192 '    // per surface
Global Const MD3_MAX_VERTS = 4096    '// per surface
Global Const MD3_MAX_SHADERS = 256    '    // per surface
Global Const MD3_MAX_FRAMES = 1024     '   // per model
Global Const MD3_MAX_SURFACES = 32   '   // per model
Global Const MD3_MAX_TAGS = 16        '    // per frame

'// vertex scales
Global Const MD3_XYZ_SCALE = (1# / 64)

Public Type MD3Frame
   Bound(1) As D3DVECTOR
   LocalOrigin As D3DVECTOR
   Radius As Single
   Name As String * 16
End Type

Public Type MD3Tag
  Name As String * 64
  Origin As D3DVECTOR
  Axis(2) As D3DVECTOR
End Type


'/*
'** md3Surface_t
'**
'** CHUNK            SIZE
'** header           sizeof( md3Surface_t )
'** shaders          sizeof( md3Shader_t ) * numShaders
'** triangles[0]     sizeof( md3Triangle_t ) * numTriangles
'** st               sizeof( md3St_t ) * numVerts
'** XyzNormals       sizeof( md3XyzNormal_t ) * numVerts * numFrames
'*/

Public Type MD3Surface
   Ident As String * 4
   Name As String * 64
   Flags As Long
   NumFrames As Long
   numShaders As Long
   numVerts As Long
   numTriangles As Long
   ofsTriangles As Long
   ofsShaders As Long
   ofsSt As Long
   ofsXyzNormals As Long
   ofsEnd As Long
End Type


'typedef struct {
'    int     ident;              //

 '   char    name[MAX_QPATH];    // polyset name

'    int     flags;
'    int     numFrames;          // all surfaces in a model should have the same
'
'    int     numShaders;         // all surfaces in a model should have the same
'    int     numVerts;

'    int     numTriangles;
'    int     ofsTriangles;

'    int     ofsShaders;         // offset from start of md3Surface_t
'    int     ofsSt;              // texture coords are common for all frames
'    int     ofsXyzNormals;      // numVerts * numFrames'

'    int     ofsEnd;             // next surface follows
'} md3Surface_t;

Public Type MD3Shader
  Name As String * 64
  ShaderIndex As Long
End Type

'typedef struct {
''    char            name[MAX_QPATH];
'    int             shaderIndex;    // for in-game use
'} md3Shader_t;

Public Type MD3Triangle
  Index(2) As Long
End Type

'typedef struct {
'    int         indexes[3];
'} md3Triangle_t;
Public Type MD3ST
  S As Single
  t As Single
End Type

'typedef struct {
'    float       st[2];
'} md3St_t;
Public Type MD3XYZNormal
   XYZ(2) As Integer
   normal As Integer
End Type

'typedef struct {
'    short       xyz[3];
'    short       normal;
'} md3XyzNormal_t;

Public Type MD3Header
  Ident As String * 4
  version As Long
  Name As String * 64
  Flags As Long
  NumFrames As Long
  numTags As Long
  numSurfaces As Long
  numSkins As Long
  ofsFrames As Long
  ofsTags As Long
  ofsSurfaces As Long
  ofsEnd As Long
End Type
  
Public Type MD3LFrame
  Vector() As D3DVECTOR
  NumVector As Integer
End Type

Public Type MD3LSurface
  Vertex() As D3DVERTEX
  St() As MD3ST
  ShaderIndex As Integer
  Frames() As MD3LFrame
  NumFrames As Integer
  Indexes() As Long
  TIndexes() As Long
End Type

Public Type MD3Attach
  Matrix As D3DMATRIX
  Tags() As MD3Tag
  AttachMesh As Integer
End Type

Public Type MD3Type
  Header As MD3Header
  Surfaces() As MD3LSurface
  Frames() As MD3Frame
  AttachPoint() As MD3Attach
  NbAttachPoint As Integer
  NbSurface As Integer
  BoundMin As D3DVECTOR
  BoundMax As D3DVECTOR
  CurrentFrame As Single
  EndFrame As Single
  StartFrame As Single
  Attach As Integer
  AttachBone As Integer
  
End Type



Public LocalActors() As Actor8
Public NbActors As Integer


Sub SetVector(Index As Integer, v As D3DVECTOR, value As Single)
  Select Case Index
   Case 0, 3: v.x = value
   Case 1, 4: v.y = value
   Case 2, 5: v.z = value
  End Select
End Sub


