Attribute VB_Name = "TrueVisionMath"
'-----------------------------
' TrueVision Maths and Macros
'-----------------------------

Dim Maths As New Globals8

Global Const PiFactor = 3.141592 / 180

Global P As D3DPLANE
Sub MDebug(M As D3DMATRIX)
Debug.Print
  Debug.Print Format$(M.m11, "0.000"), Format$(M.m12, "0.000"), Format$(M.m13, "0.000"), Format$(M.m14, "0.000")
  Debug.Print Format$(M.m21, "0.000"), Format$(M.m22, "0.000"), Format$(M.m23, "0.000"), Format$(M.m24, "0.000")
  Debug.Print Format$(M.m31, "0.000"), Format$(M.m32, "0.000"), Format$(M.m33, "0.000"), Format$(M.m34, "0.000")
  Debug.Print Format$(M.m41, "0.000"), Format$(M.m42, "0.000"), Format$(M.m43, "0.000"), Format$(M.m44, "0.000")
  
End Sub

Function GetProjetedVector(x As Long, y As Long, Nearv As D3DVECTOR, DirV As D3DVECTOR)
      Dim vIn As D3DVECTOR, vNear As D3DVECTOR, vFar As D3DVECTOR, vDir As D3DVECTOR
    Dim bHit As Boolean, i As Long
    
   ' If frame Is Nothing Then Exit Function
        
                        
    Dim currentMatrix As D3DMATRIX
    Dim NewWorldMatrix As D3DMATRIX
    
    'currentMatrix = frame.GetMatrix
        
    'Setup our basis matrix for this frame
  '    D3DXMatrixMultiply NewWorldMatrix, currentMatrix, world
    
    vIn.x = x:    vIn.y = y
    
    'Compute point on Near Clip plane at cursor
    vIn.z = 0
    D3DXVec3Unproject vNear, vIn, Viewport, ProjectionMatrix, ViewMatrix, WorldMatrix
    
    'compute point on far clip plane at cursor
    vIn.z = 1
    D3DXVec3Unproject vFar, vIn, Viewport, ProjectionMatrix, ViewMatrix, WorldMatrix

    'Comput direction vector
    'D3DXVec3Subtract DirV, vFar, vNear
    'D3DXVec3Normalize DirV, DirV
    Nearv = vNear
    DirV = vFar
End Function


Function VAverage(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
With VAverage
   .x = (V1.x + V2.x) / 2
   .y = (V1.y + V2.y) / 2
   .z = (V1.z + V2.z) / 2
End With

End Function
Function VAverage2(V1 As D3DVECTOR2, V2 As D3DVECTOR2) As D3DVECTOR2
With VAverage2
   .x = (V1.x + V2.x) / 2
   .y = (V1.y + V2.y) / 2
 '  .z = (V1.z + v2.z) / 2
End With

End Function

Public Sub VDebug(V As D3DVECTOR)
  Debug.Print V.x, V.y, V.z
End Sub

Function Vec2(x, y) As D3DVECTOR2
  Vec2.x = x
  Vec2.y = y
End Function

Function Vector3(x As Single, y As Single, z As Single) As D3DVECTOR
    Vector3.x = x
    Vector3.y = y
    Vector3.z = z
End Function
Function Ray_Tri(orig As D3DVECTOR, Dir As D3DVECTOR, vert0 As D3DVECTOR, vert1 As D3DVECTOR, Vert2 As D3DVECTOR, t As Single, U As Single, V As Single, Optional NoCollideI As Boolean = False) As Byte
Dim Edge1 As D3DVECTOR
Dim Edge2 As D3DVECTOR
Dim tvec As D3DVECTOR
Dim pvec As D3DVECTOR
Dim qvec As D3DVECTOR
Dim inv_det As Double
Dim det As Double
On Error Resume Next

   '/* find vectors for two edges sharing vert0 *'/
   Edge1 = VSubtract(vert1, vert0)
   Edge2 = VSubtract(Vert2, vert0)

   '/* begin calculating determinant - also used to calculate U parameter *'/
   pvec = VCrossProduct(Dir, Edge2)

   '/* if determinant is near zero, ray lies in plane of triangle *'/
   det = VDotProduct(Edge1, pvec)
 
   If det > -EPSILON And det < EPSILON Then
      Ray_Tri = 0
      Exit Function
   End If
   inv_det = 1 / det
   
   'calculate distance from vert0 to ray origin
   tvec = VSubtract(orig, vert0)

   'calculate u parameter and test bounds
   U = VDotProduct(tvec, pvec) * inv_det
   If U < 0 Or U > 1 Then
      Ray_Tri = 0
      Exit Function
   End If
   
   'Prepare to test v parameter
   qvec = VCrossProduct(tvec, Edge1)

   'Calculate v parameter and test bounds
   V = VDotProduct(Dir, qvec) * inv_det
   If V < 0 Or U + V > 1 Then
      Ray_Tri = 0
      Exit Function
   End If
   
   'Calculate t, ray intersects triangle
   t = VDotProduct(Edge2, qvec) * inv_det
   If NoCollideI = True Then
   CollisionNormal = VCrossProduct(Edge1, Edge2)
   CollisionImpact = VAdd(orig, VScale(Dir, t))
   End If
   Ray_Tri = 1
      
    'ColScore.t = t
    'ColScore.u = u
    'ColScore.v = v

End Function
Public Function VDotProduct(V1 As D3DVECTOR, V2 As D3DVECTOR) As Single
  '##BD Returns the dot product of two vectors.
  '##PD V1 First vector
  '##PD V2 Second vector
  VDotProduct = D3DXVec3Dot(V1, V2)
End Function
Public Function VCrossProduct(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
  '##BD Returns the cross product vector from two vectors. This function can be called to compute the face normals.
  '##PD V1 First vector
  '##PD V2 Second vector
  D3DXVec3Cross VCrossProduct, V1, V2
End Function


Function ByteToInt(a As Byte, b As Byte) As Integer
   Dim C As Long
   C = a + 256# * b
   If C And &H8000 Then
     ByteToInt = 32768 - (C And &H7FFF)
   Else
     ByteToInt = C
   End If
End Function


Function FtoDW(f As Single) As Long
    Dim buf As D3DXBuffer
    Dim l As Long
    
    Set buf = D3DX.CreateBuffer(4)
    D3DX.BufferSetData buf, 0, 4, 1, f
    D3DX.BufferGetData buf, 0, 4, 1, l
    FtoDW = l
End Function
Function LCToDXC(color As Long) As D3DCOLORVALUE
    Dim a As Long, r As Long, g As Long, b As Long
        
    If color < 0 Then
        a = ((color And (&H7F000000)) / (2 ^ 24)) Or &H80&
    Else
        a = color / (2 ^ 24)
    End If
    r = (color And &HFF0000) / (2 ^ 16)
    g = (color And &HFF00&) / (2 ^ 8)
    b = (color And &HFF&)
    
    LCToDXC.a = a / 255
    LCToDXC.r = r / 255
    LCToDXC.g = g / 255
    LCToDXC.b = b / 255
        
End Function


'-----------------------------------------------------------------------------
' Name: D3DCOLORVALUEtoLONG
'-----------------------------------------------------------------------------

Function DXCToL(cv As D3DCOLORVALUE) As Long
    Dim r As Long
    Dim g As Long
    Dim b As Long
    Dim a As Long
    Dim C As Long
    
    r = cv.r * 255
    g = cv.g * 255
    b = cv.b * 255
    a = cv.a * 255
    If r > 255 Or g > 255 Or b > 255 Or a > 255 Then Exit Function
    If a > 127 Then
        a = a - 128
        
        C = a * 2 ^ 24 Or &H80000000
        C = C Or r * 2 ^ 16
        C = C Or g * 2 ^ 8
        C = C Or b
    Else
        C = a * 2 ^ 24
        C = C Or r * 2 ^ 16
        C = C Or g * 2 ^ 8
        C = C Or b
    End If
    
    DXCToL = C
End Function
Function DXColor(r, g, b, a) As D3DCOLORVALUE
   DXColor.r = r
   DXColor.g = g
   DXColor.b = b
   DXColor.a = a
End Function

Function LVertex(x, y, z, C, tu, tv) As D3DLVERTEX
     With LVertex
       .x = x
       .y = y
       .z = z
       .color = C
       .Specular = C
       .tu = tu
       .tv = tv
     End With

End Function

Function MScale(SrcMatrix As D3DMATRIX, x As Single, y As Single, z As Single) As D3DMATRIX
      Dim TempMatrix As D3DMATRIX
      D3DXMatrixScaling TempMatrix, x, y, z
      D3DXMatrixMultiply MScale, SrcMatrix, TempMatrix
End Function

Function MScale2(SrcMatrix As D3DMATRIX, x As Single, y As Single, z As Single) As D3DMATRIX
      Dim TempMatrix As D3DMATRIX
      TempMatrix.m11 = x
      TempMatrix.m32 = y
      TempMatrix.m23 = z
      TempMatrix.m44 = 1
      D3DXMatrixMultiply MScale2, SrcMatrix, TempMatrix
End Function
Function MTranslate(SrcMatrix As D3DMATRIX, x As Single, y As Single, z As Single) As D3DMATRIX
      Dim TempMatrix As D3DMATRIX
      D3DXMatrixTranslation TempMatrix, x, y, z
      D3DXMatrixMultiply MTranslate, SrcMatrix, TempMatrix
End Function


Sub AngleQuaternion(angles As D3DVECTOR, quaternion As D3DQUATERNION)
    Dim angle As Single
    Dim sr As Single, sp As Single, sy As Single, Cr As Single, cp As Single, cy As Single

   ' // FIXME: rescale the inputs to 1/2 angle
    angle = angles.z * 0.5
    sy = Sin(angle)
    cy = Cos(angle)
    angle = angles.y * 0.5
    sp = Sin(angle)
    cp = Cos(angle)
    angle = angles.x * 0.5
    sr = Sin(angle)
    Cr = Cos(angle)

    quaternion.x = sr * cp * cy - Cr * sp * sy '// X
    quaternion.y = Cr * sp * cy + sr * cp * sy  '// Y
    quaternion.z = Cr * cp * sy - sr * sp * cy  ' // Z
    quaternion.w = Cr * cp * cy + sr * sp * sy ' // W
End Sub

Function QuaternionSlerp(q1 As D3DQUATERNION, q2 As D3DQUATERNION, S As Single, Q As D3DQUATERNION)
 Dim i As Integer
 Dim omega As Single, cosom As Single, sinom As Single, sclp As Single, sclq As Single
 Dim a As Single, b As Single
 Dim V(3) As Single, w(3) As Single, r(3) As Single
 a = 0: b = 0
 CopyMemory V(0), q1, Len(q1)
 CopyMemory w(0), q2, Len(q2)
 
 For i = 0 To 3
   a = a + (V(i) - w(i)) * (V(i) - w(i))
   b = b + (V(i) + w(i)) * (V(i) + w(i))
 Next i
 If a > b Then
    For i = 0 To 3: w(i) = -w(i): Next
 End If
 
 cosom = V(0) * w(0) + V(1) * w(1) + V(2) * w(2) + V(3) * w(3)
 
 If ((1# + cosom) > 0.00000001) Then
   If ((1# - cosom) > 0.00000001) Then
    omega = Atn(-cosom / Sqr(-cosom * cosom + 1)) + 2 * Atn(1)
    sinom = Sin(omega)
    sclp = Sin((1# - S) * omega) / sinom
    sclq = Sin(S * omega) / sinom
   Else
     sclp = 1# - S
     sclq = S
   End If
   For i = 0 To 3
     r(i) = sclp * V(i) + sclq * w(i)
   Next i
 Else
   r(0) = -V(1)
   r(1) = V(0)
   r(2) = -V(3)
   r(3) = V(2)
   sclp = Sin((1# - S) * 0.5 * 3.141592653)
   sclq = Sin((S * 0.5 * 3.141592653))
   For i = 0 To 3
    r(i) = sclp * V(i) + sclq * r(i)
   Next i
 End If
 CopyMemory Q, r(0), Len(Q)
End Function

Sub QuaternionMatrix(quaternion As D3DQUATERNION, Matrix As D3DMATRIX)

    Matrix.m11 = 1 - 2 * quaternion.y * quaternion.y - 2 * quaternion.z * quaternion.z
    Matrix.m12 = 2 * quaternion.x * quaternion.y + 2 * quaternion.w * quaternion.z
    Matrix.m13 = 2 * quaternion.x * quaternion.z - 2 * quaternion.w * quaternion.y

    Matrix.m21 = 2 * quaternion.x * quaternion.y - 2 * quaternion.w * quaternion.z
    Matrix.m22 = 1# - 2# * quaternion.x * quaternion.x - 2# * quaternion.z * quaternion.z
    Matrix.m23 = 2# * quaternion.y * quaternion.z + 2# * quaternion.w * quaternion.x

    Matrix.m31 = 2# * quaternion.x * quaternion.z + 2# * quaternion.w * quaternion.y
    Matrix.m32 = 2# * quaternion.y * quaternion.z - 2# * quaternion.w * quaternion.x
    Matrix.m33 = 1# - 2# * quaternion.x * quaternion.x - 2# * quaternion.y * quaternion.y
    
End Sub
Function MRotate(SrcMatrix As D3DMATRIX, x As Single, y As Single, z As Single) As D3DMATRIX
      Dim TempMatrix As D3DMATRIX
      D3DXMatrixRotationYawPitchRoll TempMatrix, y * PI / 180, x * PI / 180, z * PI / 180
      D3DXMatrixMultiply MRotate, SrcMatrix, TempMatrix
End Function

Function VMaX(V As D3DVECTOR) As Single
    If V.x > V.z And V.x > V.y Then VMaX = V.x: Exit Function
    If V.y > V.z And V.y > V.x Then VMaX = V.y: Exit Function
    VMaX = V.z
End Function

Function VMult(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
   VMult.x = V1.x * V2.x
   VMult.y = V1.y * V2.y
   VMult.z = V1.z * V2.z

End Function

Function RGBA(r, g, b, a) As Long
   RGBA = DXCToL(DXColor(r, g, b, a))
End Function

Function TLVertex(x As Single, y As Single, z As Single, color As Long, tu As Single, tv As Single) As D3DTLVERTEX
   With TLVertex
      .sx = x
      .sy = y
      .sz = z
      .color = color
      .tu = tu
      .tv = tv
      .rhw = 0.5
      .Specular = color
   End With
End Function

Function VAdd(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
    D3DXVec3Add VAdd, V1, V2
End Function
Public Function VCompare(V1 As D3DVECTOR, V2 As D3DVECTOR) As Integer
   If V1.x = V2.x And V1.y = V2.y And V1.z = V2.z Then VCompare = 1
End Function

Function Vert(V As D3DVERTEX2) As D3DVECTOR
   Vert.x = V.x
   Vert.y = V.y
   Vert.z = V.z
End Function

Function Vert2(V As D3DLVERTEX2) As D3DVECTOR
   Vert2.x = V.x
   Vert2.y = V.y
   Vert2.z = V.z
End Function
Function Vertex2(x, y, z, nx, ny, nz, tu, tv, tu1, tv1) As D3DVERTEX2
      With Vertex2
          .x = x
          .y = y
          .z = z
          .nx = nx
          .ny = ny
          .nz = nz
          .tu1 = tu
          .tv1 = tv
          .tu2 = tu1
          .tv2 = tu2
      End With
End Function

Function LVertex2(x, y, z, C, tu, tv, tu1, tv1) As D3DLVERTEX2
     With LVertex2
       .x = x
       .y = y
       .z = z
       .color = C
       .Specular = C
       .tu1 = tu1
       .tv1 = tv1
       .tu2 = tv1
       .tv2 = tv2
     End With
End Function
Function MTransform(Matrix As D3DMATRIX, V As D3DVECTOR) As D3DVECTOR
      D3DXVec3TransformCoord MTransform, V, Matrix
End Function

Function MITransform(Matrix As D3DMATRIX, V As D3DVECTOR) As D3DVECTOR
  '    D3DXVec3TransformCoord MTransform, V, Matrix
  Dim TempV As D3DVECTOR
  
  D3DXVec3Subtract TempV, V, Vector(Matrix.m41, Matrix.m42, Matrix.m43)
  MITransform.x = Matrix.m11 * TempV.x + Matrix.m12 * TempV.y + Matrix.m13 * TempV.z
  MITransform.y = Matrix.m21 * TempV.x + Matrix.m22 * TempV.y + Matrix.m23 * TempV.z
  MITransform.z = Matrix.m31 * TempV.x + Matrix.m32 * TempV.y + Matrix.m33 * TempV.z
End Function

Function REC(x, y, x1, y1) As RECT
   REC.Left = x
   REC.Right = x1
   REC.Top = y
   REC.Bottom = y1
End Function

Function Vector(x, y, z) As D3DVECTOR
  Vector.x = x
  Vector.y = y
  Vector.z = z
End Function

Function VModulus(V As D3DVECTOR) As Single
      VModulus = D3DXVec3Length(V)
End Function
Function VNegate(V1 As D3DVECTOR) As D3DVECTOR
  VNegate.x = -V1.x
  VNegate.y = -V1.y
  VNegate.z = -V1.z
End Function

Function VNormalize(V As D3DVECTOR) As D3DVECTOR
  D3DXVec3Normalize VNormalize, V
End Function

Function VScale(V As D3DVECTOR, S As Single) As D3DVECTOR
  VScale.x = V.x * S
  VScale.y = V.y * S
  VScale.z = V.z * S
End Function

Function VSubtract(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
   D3DXVec3Subtract VSubtract, V1, V2
End Function


