Attribute VB_Name = "TrueVisionSurface"
'-------------------------------
' TrueVision Surfaces functions
'-------------------------------

' Started 15/11/00


Public Type TextureType
   TexSurf As Direct3DTexture8
   TextureOb As Texture8
   TextureWidth As Long
   TextureHeight As Long
   TextureName As String
   TextureFileName As String
   Colorkey As Long
   Enabled As Boolean
   RTS As D3DXRenderToSurface
End Type

Public Type MaterialType
   MaterialName As String
   Mat As D3DMATERIAL8
   Enabled As Boolean
End Type

Public Type SpriteSurface
   sprite As D3DXSprite
   Texture As Integer
   Position As D3DVECTOR2
   Scaling As D3DVECTOR2
   RotationCenter As D3DVECTOR2
   Rotation As Single
   Active As Boolean
   Name As String
End Type

Public Textures() As TextureType
Public Materials() As MaterialType
Public sprites() As SpriteSurface

Public NBSprite As Integer
Public NBTexture As Integer
Public NBMaterial As Integer

Public TerrainName() As String

'---------------------
' Textures Format used
'---------------------
Public FmtTexture As Long
Public FmtAlphaTexture As Long

'----------------------------
' Surface Graphic Effects 8
'---------------------------
Public SEFlash As Single
Public SEFade As Single
Public SEFadeOn As Boolean
Public SEFlashOn As Boolean
Public SEFadeMode As Integer
Public SEFadeSpeed As Single, SEFlashSpeed As Single
Public SEFlashColor As D3DCOLORVALUE
Public SEFogEnabled As Boolean
Public SEFogMode As Integer

'----------------
'Background
'----------------
Public BackPicture As Direct3DSurface8, BackgroundEnable As Boolean

'---------------------------
' View Frustum planes
'---------------------------
Public FrustumPlanes(6) As D3DPLANE

Public Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Public CursorSurface As Integer, CursorEnable As Boolean
Public CursorWidth As Single, CursorHeight As Single

Public Sub DrawFade()
    If SEFadeOn = True Then
      If SystemFrame > 200 Then SystemFrame = 200
      SEFade = SEFade + SystemFrame / SEFadeSpeed
      If SEFadeMode = 2 Then
        LocalScreen.DrawFilledBox 0, 0, TVApp.PresentMode.BackBufferWidth * 1#, TVApp.PresentMode.BackBufferHeight * 1#, RGBA(0, 0, 0, SEFade), True
      Else
        LocalScreen.DrawFilledBox 0, 0, TVApp.PresentMode.BackBufferWidth * 1#, TVApp.PresentMode.BackBufferHeight * 1#, RGBA(0, 0, 0, 1 - SEFade), True
      End If
            
      If SEFade >= 1 Then SEFadeOn = False
   End If
   
    If SEFlashOn = True Then
      If SystemFrame > 200 Then SystemFrame = 200
       SEFlash = SEFlash + SystemFrame / SEFlashSpeed
       LocalScreen.DrawFilledBox 0, 0, TVApp.PresentMode.BackBufferWidth * 1#, TVApp.PresentMode.BackBufferHeight * 1#, RGBA(SEFlashColor.r, SEFlashColor.g, SEFlashColor.b, 1 - SEFlash), True
      If SEFlash >= 1 Then SEFadeOn = False
   End If
End Sub

Public Function LoadSurface(Filename As String, width As Long, height As Long, Format As CONST_D3DFORMAT, ReturnStuff As D3DXIMAGE_INFO, Optional Colorkey As Long = 0) As Direct3DSurface8
On Error GoTo re
    Set LoadSurface = Device.CreateImageSurface(width, height, Format)
    D3DX.LoadSurfaceFromFile LoadSurface, ByVal 0, ByVal 0, Filename, ByVal 0, D3DX_DEFAULT, Colorkey, ReturnStuff
 Exit Function
re:
AddLog D3DX.GetErrorString(Err.Number)
Resume Next
End Function
Public Function LoadTexture(Filename As String, Optional Colorkey As Long = 0, Optional width As Long = -1, Optional height As Long = -1) As Direct3DTexture8
On Error GoTo re
      TestPAKFile Filename
       Dim Format As Long
       If Colorkey = 0 Then
       Format = FmtTexture
       Else
       Format = FmtAlphaTexture
       'Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
       'Device.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATER
       End If
        'Search the good format for the new texture (this function corrects the width, the height
        'and the format type)
        D3DX.CheckTextureRequirements Device, width, height, 0, 0, Format, D3DPOOL_DEFAULT
    
        Set LoadTexture = D3DX.CreateTextureFromFileEx(Device, Filename, _
                           width, height, 0, 0, _
                          Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, -1, Colorkey, ByVal 0, ByVal 0)
      DeletePAKTemp Filename
     Exit Function
re:
AddLog "Error loading surface : " + CStr(Filename) + " no found."
Resume Next
End Function


Public Function LoadTextureFromMemory(width As Long, height As Long, BitCount As Integer, Data() As Byte) As Direct3DTexture8
  On Error GoTo treat
  Dim gg As String
  'Dim MemoryCount As Long, y As Long, temp As Byte
  'MemoryCount = UBound(Data) + 54
  'ReDim bitmapdata(MemoryCount) As Byte
  'Dim bm As BITMAPHEADER2
  'Dim bm2 As BITMAPINFOHEADER
  'bm.Magic = 19778
  'bm.Size1 = MemoryCount Mod 65536
  ''bm.Size2 = MemoryCount \ 65536
  ''Debug.Print "Memory Count", MemoryCount, CStr(UBound(Data))
  'bm.OffSet = 54
  'bm.OffSet2 = 0
  'bm2.biBitCount = BitCount
  'bm2.biWidth = Width
  'bm2.biHeight = Height
  'bm2.biSize = 40
  'bm2.biPlanes = 1
  'bm2.biSizeImage = MemoryCount - 54
  'bm2.biCompression = 0
  'bm2.biXPelsPerMeter = 50
  'bm2.biYPelsPerMeter = 50
 '
 '' AddLog "deee :" + CStr(Width) + " " + CStr(Height)
''  For y = 0 To Height - 1
'    AddLog CStr(1 + (Height - y - 1) * Width * 3) + " " + CStr(Height - y - 1)
'''    DXCopyMemory bitmapdata(54 + y * Width * 3), Data(1 + (Height - y - 1) * Width * 3), Width * 3
''  Next y
 ' For y = 0 To UBound(Data) - 1 Step 3
 '   temp = Data(y): Data(y) = Data(y + 2): Data(y + 2) = temp
 ' Next y
 ' DXCopyMemory bitmapdata(54), Data(0), MemoryCount - 54
 ' DXCopyMemory bitmapdata(0), bm, 14
 ' DXCopyMemory bitmapdata(14), bm2, 40
 'Static eer As Integer
 'Open "d:\lpe" + CStr(eer) + ".bmp" For Binary As 1
 '  Put #1, , bitmapdata
 'Close
 'eer = eer + 1

 Dim Format As Long, cw As Long, ch As Long
 Format = D3DFMT_R5G6B5
 cw = width: ch = height
 If width < 8 Then width = 8
 If height < 8 Then height = 8
 If height > width Then width = height
 gg = "ee"
 D3DX.CheckTextureRequirements Device, width, height, 0, 0, Format, D3DPOOL_DEFAULT
 Dim a As Direct3DSurface8, temptex As Direct3DTexture8
 gg = "dded"
 Set temptex = D3DX.CreateTexture(Device, width, height, 0, 0, Format, D3DPOOL_DEFAULT)
 Set a = temptex.GetSurfaceLevel(0)
 gg = "ddss"
 D3DX.LoadSurfaceFromMemory a, ByVal 0, REC(0, 0, width, height), Data(0), D3DFMT_R8G8B8, 0, ByVal 0, REC(0, 0, ch, cw), D3DX_DEFAULT, 0
 Set LoadTextureFromMemory = temptex
Exit Function '

treat:
AddLog "MEMORY LOADING : Error " + CStr(Err.Number) + " " + CStr(Err.Description) + " " + gg

Resume Next
End Function


